////////////////////////////////////////////////////
//
// VGAPaint 386 - arrange.c
//
// Routines for rearranging a picture's palette.
//

#define	VGAPAINT_ARRANGE_C

#include <a/bits.h>

#include <math.h>

#include "vgapaint.h"
#include "palette.h"
#include "arrange.h"
#include "listbox.h"
#include "picture.h"

#define	COP_COPY	RZoneMsg(0,0)
#define	COP_SWAP	RZoneMsg(0,1)
#define	COP_SWAPPIC	RZoneMsg(0,2)
#define	COP_SPREADRGB	RZoneMsg(0,3)
#define	COP_SPREADHSV	RZoneMsg(0,4)
#define	COP_DELETE	RZoneMsg(0,5)
#define	COP_UNDELETE	RZoneMsg(0,6)
#define	COP_UNUSED	RZoneMsg(0,7)
#define	COP_CANCEL	RZoneMsg(0,8)
#define	COP_OKAY	RZoneMsg(0,9)

////////////////////////////////////////////

static uchar *ArrangePalette;

static void ArrangeSliderRefreshHandler(struct Slider *sld);

////////////////////////////////////////////

static struct Zone arrng_z[]={
	{ 7*16+6,1+0*11,64,11,ZN_3D+ZN_TEXTRENDER,NULL,"Copy",NULL },
	{ 7*16+6,1+1*11,64,11,ZN_3D+ZN_TEXTRENDER,NULL,"Swap",NULL },
	{ 7*16+6,1+2*11,64,11,ZN_3D+ZN_TEXTRENDER,NULL,"SwapPic",NULL },
	{ 7*16+6,1+3*11,64,11,ZN_3D+ZN_TEXTRENDER,NULL,"SpreadRGB",NULL },
	{ 7*16+6,1+4*11,64,11,ZN_3D+ZN_TEXTRENDER,NULL,"SpreadHSV",NULL },
	{ 7*16+6,1+5*11,64,11,ZN_3D+ZN_TEXTRENDER,NULL,"Delete",NULL },
	{ 7*16+6,1+6*11,64,11,ZN_3D+ZN_TEXTRENDER,NULL,"Undelete",NULL },
	{ 7*16+6,1+7*11,64,11,ZN_3D+ZN_TEXTRENDER,NULL,"Unused",NULL },
	{ 7*16+6,1+8*11,64,11,ZN_3D+ZN_TEXTRENDER,NULL,"Cancel",NULL },
	{ 7*16+6,1+9*11,64,11,ZN_3D+ZN_TEXTRENDER,NULL,"Ok",NULL },
	{-1,-1,-1,-1}
};

static struct Zone arrng_z2[]={
	{ 4,114,52,11,ZN_3D+ZN_TEXTRENDER,NULL,"Abstract",NULL },
	{-1,-1,-1,-1}
};

static struct ZoneRange arrng_zr[]={
	{ &arrng_zr[1],&arrng_z,NULL,-1,ZR_TAP,NULL,0,0,NULL,FALSE },
	{ NULL        ,&arrng_z2,NULL,-1,ZR_TAP,NULL,0,0,NULL,FALSE }
};

static struct Slider arrng_sld[]={
	{ &arrng_sld[1],{NULL},NULL,{ 12,152,134,4 },NULL,0,0,8,4,0,0,1535,0,16,16,0,0,0,0,
		SLD_ARROW1*4 + SLD_ARROW2*6 + SLD_ATTACHX + SLD_OUTLINE3D,
		ArrangeSliderRefreshHandler,{ 0,0,8,8 },{ 0,0,8,8},-1,0,1,0,NULL },

	{ &arrng_sld[2],{NULL},NULL,{ 12,160,134,4 },NULL,0,0,8,4,0,0,255,0,16,16,0,0,0,0,
		SLD_ARROW1*4 + SLD_ARROW2*6 + SLD_ATTACHX + SLD_OUTLINE3D,
		ArrangeSliderRefreshHandler,{ 0,0,8,8 },{ 0,0,8,8},-1,0,1,0,NULL },

	{ &arrng_sld[3],{NULL},NULL,{ 12,168,134,4 },NULL,0,0,8,4,0,0,255,0,16,16,0,0,0,0,
		SLD_ARROW1*4 + SLD_ARROW2*6 + SLD_ATTACHX + SLD_OUTLINE3D,
		ArrangeSliderRefreshHandler,{ 0,0,8,8 },{ 0,0,8,8},-1,0,1,0,NULL },

	{ &arrng_sld[4],{NULL},NULL,{ 12,128,134,4 },NULL,0,0,8,4,0,0,255,0,16,16,0,0,0,0,
		SLD_ARROW1*4 + SLD_ARROW2*6 + SLD_ATTACHX + SLD_OUTLINE3D,
		ArrangeSliderRefreshHandler,{ 0,0,8,8 },{ 0,0,8,8},-1,0,1,0,NULL },

	{ &arrng_sld[5],{NULL},NULL,{ 12,136,134,4 },NULL,0,0,8,4,0,0,255,0,16,16,0,0,0,0,
		SLD_ARROW1*4 + SLD_ARROW2*6 + SLD_ATTACHX + SLD_OUTLINE3D,
		ArrangeSliderRefreshHandler,{ 0,0,8,8 },{ 0,0,8,8},-1,0,1,0,NULL },

	{ NULL         ,{NULL},NULL,{ 12,144,134,4 },NULL,0,0,8,4,0,0,255,0,16,16,0,0,0,0,
		SLD_ARROW1*4 + SLD_ARROW2*6 + SLD_ATTACHX + SLD_OUTLINE3D,
		ArrangeSliderRefreshHandler,{ 0,0,8,8 },{ 0,0,8,8},-1,0,1,0,NULL },
};

static struct Requester arrngreq={
	0,0,184,177,			// 184x126
	REQ_BORDER + REQ_POPCEN + REQ_SYSTITLE + REQ_COORDBIAS,
//	"Arrange Colors",
	NULL,
	St2,				// backfill
	NULL,				// no listboxes
	NULL,				// no fields
	arrng_zr,			// zone range
	arrng_sld,				// no sliders
	NULL,				// no positives
	NULL,				// no negatives
	NULL,				// no text
	NULL,				// old_winbm
	NULL,				// savepal
};

///////////////////////////////////////////////////

//static uchar	arrange_sliders_initialized;

static boolean arrange_dragging;

static void ArrangeSliderRefreshHandler(struct Slider *sld) {
	int	idx = sld-arrng_sld;
	int	h,s,v;
	static boolean reentry = FALSE;

//	arrange_sliders_initialized |= 1<<idx;

	mouse_hide();
	vid_printf6(sld->destbm,sld->arrow2.x+sld->arrow2.width+2,sld->arrow2.y,St0,St2,"%c%3d"
		,"HSVRGB"[idx]
		,idx==0 ? sld->cposx/6 : sld->cposx
		);
	mouse_show();

	if (!arrange_dragging) return;

	// avoid infinite recursion

	if (idx>=3) {
		ArrangePalette[fcolor*3+(idx-3)] = sld->cposx;

		if (reentry) return;

		reentry=TRUE;

		ColorSpaceRGBtoHSV(
			((ulong)ArrangePalette[fcolor*3+0]<<16)|
			((ulong)ArrangePalette[fcolor*3+1]<<8)|
			(ulong)ArrangePalette[fcolor*3+2],
			&h,&s,&v);

		SliderAbs(arrng_sld+0,h,0);
		SliderAbs(arrng_sld+1,s,0);
		SliderAbs(arrng_sld+2,v,0);

	} else {
		int r,g,b;

		if (reentry) return;

		reentry=TRUE;

		h = arrng_sld[0].cposx;
		s = arrng_sld[1].cposx;
		v = arrng_sld[2].cposx;

		switch(h>>8) {
		case 0:	r = 0xFF;	      	g = (uchar)h;	   	b = 0x00;	    	break;
		case 1:	r = 0xFF-(uchar)h;  	g = 0xFF;	   	b = 0x00;	    	break;
		case 2:	r = 0x00;	      	g = 0xFF;	   	b = (uchar)h;	    	break;
		case 3:	r = 0x00;	      	g = 0xFF-(uchar)h;     	b = 0xFF;	    	break;
		case 4:	r = (uchar)h;	      	g = 0x00;	   	b = 0xFF;	    	break;
		case 5:	r = 0xFF;	      	g = 0x00;	   	b = 0xFF-(uchar)h;  	break;
		}

		SliderAbs(arrng_sld+3,((255L*(255-s)+r*s)*v)/(255*255L),0);
		SliderAbs(arrng_sld+4,((255L*(255-s)+g*s)*v)/(255*255L),0);
		SliderAbs(arrng_sld+5,((255L*(255-s)+b*s)*v)/(255*255L),0);
	}

	vid_setRGB6(fcolor,ArrangePalette[fcolor*3+0],ArrangePalette[fcolor*3+1],ArrangePalette[fcolor*3+2]);

	reentry=FALSE;
}

////////////////////////////////////////////

static void	ChangeColorRange(struct Rectangle *,uchar,uchar);
static void	ChangeColorRange2(struct BitMap *bm,struct Rectangle *,uchar,uchar);
static void	ArrangeRedraw(struct Requester *req, struct Rectangle *rect, uchar range1, uchar range2, uchar *palbits);
static void	ArrangeDeleteColors(struct Requester *req,struct Rectangle *r,uchar *palbits,uchar idx1,int cols);
static void	ArrangeUndeleteColors(struct Requester *req,struct Rectangle *r,uchar *palbits,uchar idx1,int cnt);
static void	ArrangeRefreshRects(struct Requester *req,struct Rectangle *r,uchar *palbits,uchar idx1,int cols);
static void	ArrangeColorToSliders(uchar *palette,uchar col);
static int	arrange_get_dest_color(struct Requester *req,struct Rectangle *r);

static uchar	rangefirst,rangelast;

void DoArrange(uchar *palette,uchar *palbits,char *title) {
	mouse_coord x,y,x2,y2,b;
	int	rect,rect2;
	int	src,srcend,dst,dstend;
	int	srcidx1,srcidx2,dstidx1,dstidx2;
	int	numcolors;
	int	i;
	uchar	srcmask,src2mask,dstmask;
	uchar	*srcptr,*src2ptr,*dstptr;
	uchar c;
	struct Rectangle *r,*r2;
	ulong	msg;
	boolean	quit = FALSE;
	int	key;
	char	reqtitle[64];

	union {
		ulong	histogram[256];
		uchar	translate[256];
	} arrays;

	/////////////////

	//arrange_sliders_initialized = NULL;
	arrange_dragging = FALSE;

	sprintf(reqtitle,"Edit %sPalette",title);
	arrngreq.title = reqtitle;

	ArrangePalette = palette;

	if (!(r=(struct Rectangle *)malloc(sizeof(struct Rectangle [257])))) return;
	r[256].x=r[256].y=r[256].width=r[256].height=RECT_END;

	arrng_sld[3].cposx = palette[fcolor*3+0];
	arrng_sld[4].cposx = palette[fcolor*3+1];
	arrng_sld[5].cposx = palette[fcolor*3+2];

	mouse_hide();
	if (!OpenRequester(&arrngreq,0,0)) { mouse_show(); free(r); return; }

//	rangefirst = rangelast = fcolor;
	ArrangeRedraw(&arrngreq,r,fcolor,fcolor,palbits);
	vd->refresh();

	mouse_show();

	while(!quit) {
		vd->refresh();
		do {
			if ((key = kbd_check())!=-1) switch(key) {
			case 0x1b:	// esc
				quit = TRUE;
				break;
			case ' ':	// space (duh) - repick colors & redraw requester
				choose_colors(palette);
				mouse_hide();
				RenderRequester(&arrngreq);
				ArrangeRedraw(&arrngreq,r,rangefirst,rangelast,palbits);
				mouse_show();
				break;
			}
			mouse_read2(&x,&y,&b);
		} while(!b && !quit);

		arrange_dragging = TRUE;
		msg = CheckRequester(&arrngreq,x,y,b);
		arrange_dragging = FALSE;

		if (msg) {
			if (msg == RZoneMsg(1,0)) {
				msg = PickAbstractColor();

				if (msg != 0xffffffff) {
					ArrangePalette[fcolor*3+0] = (msg>>16)&255;
					ArrangePalette[fcolor*3+1] = (msg>>8 )&255;
					ArrangePalette[fcolor*3+2] = (msg    )&255;
					vid_setRGB6(fcolor,ArrangePalette[fcolor*3+0],ArrangePalette[fcolor*3+1],ArrangePalette[fcolor*3+2]);
				}
			} else if (RMsgIsZone(msg)) {
				src	= rangefirst*3;
				srcend	= rangelast *3+3;
				if (srcend<src) {
					srcend	-=3;
					src	+=3;
				}
				srcidx1 = min(rangefirst,rangelast);
				srcidx2 = max(rangefirst,rangelast);

				numcolors = abs(srcidx1-srcidx2)+1;

				srcptr  = palbits + (srcidx1>>3);
				srcmask = 1<<(srcidx1&7);
				src2ptr  = palbits + (srcidx2>>3);
				src2mask = 1<<(srcidx2&7);

				switch(msg) {
				case COP_COPY:
					if ((rect2 = arrange_get_dest_color(&arrngreq,r))>=0) {
						dst	= rect2*3;
						dstend	= (rect2+rangelast+1-rangefirst)*3L;
						if (dstend<dst)
							dst	+=3;
						dstidx1 = rect2;
						dstidx2 = (rect2+numcolors-1)&0xff;

						dstptr  = palbits + (dstidx1>>3);
						dstmask = 1<<(dstidx1&7);

						if (srcend > src) {	// range from lower to higher
							if (dstend>768) {	// dest range overlaps
								while(dst<   768) piccol[dst++]=piccol[src++];
								dst=0;
							}
							while(src<srcend) piccol[dst++]=piccol[src++];
						} else {
							if (dstend<0) {
								while(dst>0) piccol[--dst]=piccol[--src];
							}
							while(src>srcend) piccol[--dst]=piccol[--src];
						};

						for(i=numcolors;i;i--) {
							if (*srcptr & srcmask)
								*dstptr |= dstmask;
							else
								*dstptr &= ~dstmask;

							if (!(srcmask<<=1)) {
								srcmask = 0x01;
								srcptr = palbits + ((srcptr+1-palbits) & 31);
							}
							if (!(dstmask<<=1)) {
								dstmask = 0x01;
								dstptr = palbits + ((dstptr+1-palbits) & 31);
							}
						}

						ArrangeRefreshRects(&arrngreq,r,palbits,dstidx1,numcolors);
					}
					break;
				case COP_SWAPPIC:
					// initialize translation matrix

					for(i=0;i<256;i++) arrays.translate[i] = i;

					// swap the colors in question

					for(i=(srcidx1+srcidx2)>>1;i>=srcidx1;i--) {
						c = arrays.translate[i];
						arrays.translate[i] = arrays.translate[srcidx1+srcidx2-i];
						arrays.translate[srcidx1+srcidx2-i] = c;
					}

					// translate the current picture

					vid13_translate(pict_cur->bm,pict_cur->bm->x1,pict_cur->bm->y1,pict_cur->bm->width,
						pict_cur->bm->height,arrays.translate);
					PictureMarkDirty(pict_cur);

					// flip the requester out, repaint the picture, and flip the requester back in

					mouse_hide();
					HideRequester(&arrngreq);
					redraw_picture();
					ShowRequester(&arrngreq);
					mouse_show();

				case COP_SWAP:
					if (srcend > src) {
						srcend-=3;
						while(src<srcend) {
							c=piccol[src+0]; piccol[src+0]=piccol[srcend+0]; piccol[srcend+0]=c;
							c=piccol[src+1]; piccol[src+1]=piccol[srcend+1]; piccol[srcend+1]=c;
							c=piccol[src+2]; piccol[src+2]=piccol[srcend+2]; piccol[srcend+2]=c;
							c = !!(*srcptr & srcmask);
							if (*src2ptr & src2mask)
								*srcptr |= srcmask;
							else
								*srcptr &= ~srcmask;
							if (c)
								*src2ptr |= src2mask;
							else
								*src2ptr &= ~src2mask;

							if (!(srcmask<<=1)) {
								srcmask = 0x01;
								++srcptr;
							}
							if (!(src2mask>>=1)) {
								src2mask = 0x80;
								--src2ptr;
							}

							src+=3;
							srcend-=3;
						}
					} else {
						src-=3;
						while(srcend<src) {
							c=piccol[src+0]; piccol[src+0]=piccol[srcend+0]; piccol[srcend+0]=c;
							c=piccol[src+1]; piccol[src+1]=piccol[srcend+1]; piccol[srcend+1]=c;
							c=piccol[src+2]; piccol[src+2]=piccol[srcend+2]; piccol[srcend+2]=c;
							c = !!(*srcptr & srcmask);
							if (*src2ptr & src2mask)
								*srcptr |= srcmask;
							else
								*srcptr &= ~srcmask;
							if (c)
								*src2ptr |= src2mask;
							else
								*src2ptr &= ~src2mask;

							if (!(srcmask<<=1)) {
								srcmask = 0x01;
								++srcptr;
							}
							if (!(src2mask>>=1)) {
								src2mask = 0x80;
								--src2ptr;
							}
							src-=3;
							srcend+=3;
						}
					}
					ArrangeRefreshRects(&arrngreq,r,palbits,srcidx1,numcolors);
					break;
				case COP_SPREADRGB:
					{
						uchar red1,grn1,blu1,red2,grn2,blu2;
						uchar *pcc;
						short diff;

						x2=src;
						y2=srcend;
						if (x2<y2) y2-=3; else x2-=3;

						if (x2<y2) { b=x2; x2=y2; y2=b; }
						red1=piccol[x2];
						grn1=piccol[x2+1];
						blu1=piccol[x2+2];
						red2=piccol[y2];
						grn2=piccol[y2+1];
						blu2=piccol[y2+2];
						pcc=piccol+y2;
						diff=x2=abs(rangefirst-rangelast);
						if (!diff) break;
						y2=0;
						while(x2>=0) {
							*pcc++=(red1*y2+red2*x2)/diff;
							*pcc++=(grn1*y2+grn2*x2)/diff;
							*pcc++=(blu1*y2+blu2*x2)/diff;
							x2--;
							y2++;
						};
					}
					ArrangeUndeleteColors(&arrngreq,r,palbits,srcidx1,numcolors);
					break;
				case COP_SPREADHSV:
					{
						double hue1,hue2,huedif;
						uchar sat1,sat2,bright1,bright2;
						uchar *pcc;
						short diff;

						x2=src;
						y2=srcend;
						if (x2<y2) y2-=3; else x2-=3;

						if (x2<y2) { b=x2; x2=y2; y2=b; }
						RGBtoHSV2(piccol[x2],piccol[x2+1],piccol[x2+2]);
						hue1=rad_to_deg(hue); sat1=sat; bright1=bright;
						RGBtoHSV2(piccol[y2],piccol[y2+1],piccol[y2+2]);
						hue2=rad_to_deg(hue); sat2=sat; bright2=bright;

						huedif=hue1-hue2;
						if (huedif<-180.0) huedif+=360.0;
						else if (huedif>180.0) huedif-=360.0;
						pcc=piccol+y2;
						x2=diff=abs(rangefirst-rangelast);
						if (!diff) break;
						y2=0;
						huedif/=diff;
						hue2+=360.0; /* fmod won't work <0 */
						while(x2>=0) {
							sat=(sat2*x2+sat1*y2)/diff;
							bright=(bright2*x2+bright1*y2)/diff;
							*pcc++=((ColorVal3(hue2)*(long)sat+255L*(255-sat))*bright)/32385L;
							*pcc++=((ColorVal3(hue2+120)*(long)sat+255L*(255-sat))*bright)/32385L;
							*pcc++=((ColorVal3(hue2+240)*(long)sat+255L*(255-sat))*bright)/32385L;
							hue2+=huedif;
							x2--;
							y2++;
						};
					}
					ArrangeUndeleteColors(&arrngreq,r,palbits,srcidx1,numcolors);
					break;
				case COP_DELETE:
					ArrangeDeleteColors(&arrngreq,r,palbits,srcidx1,numcolors);
					break;
				case COP_UNDELETE:
					ArrangeUndeleteColors(&arrngreq,r,palbits,srcidx1,numcolors);
					break;
				case COP_UNUSED:

					// histo the picture

					Histogram(arrays.histogram,pict_cur->bm);

					// scan the histo and delete any unused colors

					for(i=0;i<256;i++)
						if (!arrays.histogram[i]) palbits[i>>3] &= ~(1<<(i&7));

					ArrangeRefreshRects(&arrngreq,r,palbits,0,256);

					break;
				case COP_CANCEL:
				case COP_OKAY:
					quit = TRUE;
					break;
				}
				vid_loadRGB6(0,piccol,256);
//				Release3DGadget(r+rect);

				{
					int h,s,v;

					ColorSpaceRGBtoHSV(
						arrng_sld[0].cposx | (arrng_sld[1].cposx<<8) | (arrng_sld[2].cposx<<16)
						,&h,&s,&v);

					SliderAbs(arrng_sld+3,h,0);
					SliderAbs(arrng_sld+4,s,0);
					SliderAbs(arrng_sld+5,v,0);
				}
			} else {
				uchar	rgb;
				int	h,s,v;

				switch(msg&0xffff0000L) {
				case REQM_SLIDER+0x00000:
				case REQM_SLIDER+0x10000:
				case REQM_SLIDER+0x20000:
					ColorSpaceRGBtoHSV(
						(arrng_sld[3].cposx<<16) | (arrng_sld[4].cposx<<8) | arrng_sld[5].cposx
						,&h,&s,&v);

					SliderAbs(arrng_sld+0,h,0);
					SliderAbs(arrng_sld+1,s,0);
					SliderAbs(arrng_sld+2,v,0);

					break;
				case REQM_SLIDER+0x30000:
				case REQM_SLIDER+0x40000:
				case REQM_SLIDER+0x50000:
					rgb = ColorSpaceHSVtoRGB(arrng_sld[0].cposx,arrng_sld[1].cposx,arrng_sld[2].cposx);

					SliderAbs(arrng_sld+3,(uchar)(rgb>>16),0);
					SliderAbs(arrng_sld+4,(uchar)(rgb>> 8),0);
					SliderAbs(arrng_sld+5,(uchar)(rgb    ),0);

					break;
				}
			}
		} else if (-1!=(rect=rectSearch(r,x-arrngreq.reqbm.xbias,y-arrngreq.reqbm.ybias))) {
			r2=r+rect;
			if (rect<256) {
				/* we must be dragging a new range */

				do {
					x2=x;
					y2=y;
					do {
						mouse_read2(&x,&y,&b);
					} while(x2==x && y2==y && (b & 1));
					rect2=rectSearch(r,x-arrngreq.reqbm.xbias,y-arrngreq.reqbm.ybias);
					if (rect2<256 && rect2>=0) {
						mouse_hide();
						ChangeColorRange2(&arrngreq.reqbm,r,rect,rect2);
						vid_printf6(&arrngreq.reqbm,104,116,ST0,ST2,"%3d   to %3d",rangefirst,rangelast);
						vd->bar    (&arrngreq.reqbm,128,116,5,8,rangefirst);
						vd->bar    (&arrngreq.reqbm,176,116,5,8,rangelast);
						fcolor = rect2;
						ArrangeColorToSliders(palette,rect2);
						mouse_show();
						vd->refresh();
					}
				} while(b & 1);
			}
		};
	};

	CloseRequester(&arrngreq);

	free(r);

	/* I'm gonna be lazy and let restore_screen() do the refresh for me */

	ZRTool1[3].highindex=fcolor;
	mouse_setpointer(crosshairs,7,7,ST3,ST0);
	repick_colors();
	restore_screen();
}

#define	ARRANGE_COLOR_WIDTH	(7)
#define	ARRANGE_COLOR_HEIGHT	(7)

static void ArrangeRedraw(struct Requester *req, struct Rectangle *rect, uchar range1, uchar range2, uchar *palbits) {
	int x,y,x2,y2,c;
	struct Rectangle *r = rect;

	// call the requester routines to rerender the requester

	RenderRequester(req);

	// redraw color rectangles
	// very similar to DrawColorArray()

	y2=1;
	c=0;
	for (y=0;y<16;y++) {
		x2=2;
		for (x=0;x<16;x++) {
			vid_draw3d(&req->reqbm,x2,y2,x2+ARRANGE_COLOR_WIDTH-1,y2+ARRANGE_COLOR_HEIGHT-1);
			if (palbits[c>>3] & (1<<(c&7)))
				vd->bar(&req->reqbm,x2+1,y2+1,ARRANGE_COLOR_WIDTH-2,ARRANGE_COLOR_HEIGHT-2,c);
			else
				vid13_grey(&req->reqbm,x2+1,y2+1,ARRANGE_COLOR_WIDTH-2,ARRANGE_COLOR_HEIGHT-2,St3,St0);
			++c;
			r->x	  = x2;
			r->y	  = y2;
			r->width  = ARRANGE_COLOR_WIDTH;
			r->height = ARRANGE_COLOR_HEIGHT;
			++r;
			x2+=ARRANGE_COLOR_WIDTH;
		};
		y2+=ARRANGE_COLOR_HEIGHT;
	};

	// depress the correct range
	// hack it by telling the routines that the first color is depressed,
	// then depressing it ourselves.

	rangefirst = rangelast = range1;
	ChangeColorRange2(&req->reqbm,rect,range1,range2);
	Depress3DGadget(&req->reqbm,rect+range1);
}

static void ArrangeDeleteColors(struct Requester *req,struct Rectangle *r,uchar *palbits,uchar idx1,int cnt) {
	while(cnt--) {
		palbits[idx1>>3] &= ~(1<<(idx1&7));
 		vid13_grey(&req->reqbm,r[idx1].x+1,r[idx1].y+1,ARRANGE_COLOR_WIDTH-2,ARRANGE_COLOR_HEIGHT-2,St3,St0);
		++idx1;
	}
}

static void ArrangeUndeleteColors(struct Requester *req,struct Rectangle *r,uchar *palbits,uchar idx1,int cnt) {
	while(cnt--) {
		palbits[idx1>>3] |= (1<<(idx1&7));
		vd->bar(&req->reqbm,r[idx1].x+1,r[idx1].y+1,ARRANGE_COLOR_WIDTH-2,ARRANGE_COLOR_HEIGHT-2,idx1);
		++idx1;
	}
}

static void ArrangeRefreshRects(struct Requester *req,struct Rectangle *r,uchar *palbits,uchar idx1,int cnt) {
	while(cnt--) {
		if (palbits[idx1>>3] & (1<<(idx1&7)))
				vd->bar(&req->reqbm,r[idx1].x+1,r[idx1].y+1,ARRANGE_COLOR_WIDTH-2,ARRANGE_COLOR_HEIGHT-2,idx1);
			else
				vid13_grey(&req->reqbm,r[idx1].x+1,r[idx1].y+1,ARRANGE_COLOR_WIDTH-2,ARRANGE_COLOR_HEIGHT-2,St3,St0);
		++idx1;
	}
}

static void ArrangeColorToSliders(uchar *palette,uchar col) {
	int r,g,b,h,s,v;

	SliderAbs(arrng_sld+3,r = palette[col*3+0],0);
	SliderAbs(arrng_sld+4,g = palette[col*3+1],0);
	SliderAbs(arrng_sld+5,b = palette[col*3+2],0);

	ColorSpaceRGBtoHSV((r<<16)|(g<<8)|(b),&h,&s,&v);

	SliderAbs(arrng_sld+0,h,0);
	SliderAbs(arrng_sld+1,s,0);
	SliderAbs(arrng_sld+2,v,0);
}

void	ColorSpaceRGBtoHSV(ulong rgb,int *hp,int *sp,int *vp) {
	int	r,g,b,h,s,v,m;

	r = (uchar)(rgb>>16);
	g = (uchar)(rgb>> 8);
	b = (uchar)(rgb    );

	v = max(max(r,g),b);
	m = min(min(r,g),b);
	if (!v) {
		s = 0;
		h = 0;
	} else {
		s = ((v-m)*255L)/v;
		if (!s) {
			h = 0;
		} else {
			if (m==r)
				if (v==g)	// 00 FF xx
					h = 0x200 + ((b-m)*255L/(v-m));
				else		// 00 xx FF
					h = 0x3FF - ((g-m)*255L/(v-m));
			else if (m==g)
				if (v==r)	// FF 00 xx
					h = 0x5FF - ((b-m)*255L/(v-m));
				else		// xx 00 FF
					h = 0x400 + ((r-m)*255L/(v-m));
			else if (m==b)
				if (v==r)	// FF xx 00
					h = 0x000 + ((g-m)*255L/(v-m));
				else		// xx FF 00
					h = 0x1FF - ((r-m)*255L/(v-m));
		}
	}

	*hp = h;
	*sp = s;
	*vp = v;
}

ulong	ColorSpaceHSVtoRGB(int h,int s,int v) {
	int r,g,b;

	switch(h>>8) {
	case 0:	r = 0xFF;	      	g = (uchar)h;	   	b = 0x00;	    	break;
	case 1:	r = 0xFF-(uchar)h;  	g = 0xFF;	   	b = 0x00;	    	break;
	case 2:	r = 0x00;	      	g = 0xFF;	   	b = (uchar)h;	    	break;
	case 3:	r = 0x00;	      	g = 0xFF-(uchar)h;     	b = 0xFF;	    	break;
	case 4:	r = (uchar)h;	      	g = 0x00;	   	b = 0xFF;	    	break;
	case 5:	r = 0xFF;	      	g = 0x00;	   	b = 0xFF-(uchar)h;  	break;
	}

	return	  ((((255L*(255-s)+r*s)*v)/(255*255L))<<16)
		| ((((255L*(255-s)+g*s)*v)/(255*255L))<< 8)
		| (((255L*(255-s)+b*s)*v)/(255*255L));
}

////////////////////////////////////////////////////////////////////////////////////////////////

/* DoRange: Bring up Ranges requester */

static struct Listbox range_lbox={
	128,123,14*6,64,14,8,NULL,
	0,0,-1,NULL,
	&range_getindex,
	&range_displayindex,
	&range_clearindex,
	&range_scrollindex,
	&range_clearwindow,
	&vidbm,
	8,
	NULL
};

static struct Slider range_sld1={
	NULL,
	{ NULL },
	&vidbm,
	{ 216,131,4,48 },
	NULL,0,0,
	4,4,0,0,0,0,
	0,2,0,0,0,0,
	SLD_ARROW1HIT+SLD_ARROW2HIT+SLD_LISTBOX+(SLD_ARROW1*2)+(SLD_ARROW2*8)+SLD_OUTLINE3D,
	NULL,
	{ 214,121,8,8 },
	{ 214,181,8,8 },
	0,-1,
	0,1,
	&range_lbox
};

static struct Slider range_sld2={
	NULL,{NULL},
	&vidbm,
	{ 10,123,80,4 },
	NULL,0,0,
	4,4,0,0,1193181*5,0,
	1024*18,0,0,0,0,0,
	SLD_ARROW1HIT+SLD_ARROW2HIT+(SLD_ARROW1*4)+(SLD_ARROW2*6)+SLD_OUTLINE3D,
	range_updater1,
	{ 0,121,8,8 },
	{ 92,121,8,8 },
	-65536L*5,0,
	65536L*5,0,
	NULL
};

static struct Slider range_sld3={
	NULL,{NULL},&vidbm,
	{ 242,123,76,4 },
	NULL,0,0,
	4,4,0,0,7,0,
	1,0,0,0,0,0,
	SLD_OUTLINE3D,
	range_updater2,
	{ 0 },{ 0 },
	0,0,0,0,
	NULL
};

static struct	CycleRange *rangecr;

void	DoRange(void) {
	struct Rectangle *r,*r2;
	struct CycleStrip *cs;
	mouse_coord x,y,b,ox,oy;
	short rect,rect2;

	if (!(r=(struct Rectangle *)malloc(sizeof(struct Rectangle [261])))) return;

	mouse_hide();
	vid13_set(&vidbm,ST2);

	DrawColorArray(r);

	vid_inv3d(&vidbm,126,121,126+14*6+3,121+8*8+3);
	vid_inv3d(&vidbm,126,189,126+14*6+3,199);

	r2=r+256;

	Make3DGadget(r2++,256,189,64,11,"Okay");
	Make3DGadget(r2++,0,200-33,64,11,"Add");
	Make3DGadget(r2++,0,200-22,64,11,"Insert");
	Make3DGadget(r2++,0,200-11,64,11,"Delete");
	r2->x=r2->y=r2->width=r2->height=RECT_END;

	Depress3DGadget(&vidbm,r+fcolor);
	rangefirst=fcolor;
	rangelast=fcolor;

	SliderInit(&range_sld1);
	SliderInit(&range_sld2);
	SliderInit(&range_sld3);
	range_lbox.cpos=0;
	range_lbox.listadd=rangecr=&cyclerange[range_sld3.cposx];
	range_lbox.sel=-1;
	range_lbox.seladd=NULL;
	range_lbox.alen=rangecr->strips;
	DrawListbox(&range_lbox);

	vd->refresh();
	mouse_show();

	for(;;) {
		mouse_wait_key();
		mouse_read2(&x,&y,&b);
		if (-1!=(rect=rectSearch(r,x,y))) {
			r2=r+rect;
			if (rect>=256) Click3DGadget(&vidbm,r2);
			if (rect<256) {
				/* we must be dragging a new range */

				do {
					ox=x;
					oy=y;
					do {
						mouse_read2(&x,&y,&b);
					} while(ox==x && oy==y && (b & 1));
					rect2=rectSearch(r,x,y);
					if (rect2<256 && rect2>=0)
						ChangeColorRange(r,rect,rect2);
				} while(b & 1);
			} else if (rect==256) {
				break;
			} else if (rect==257) {
				if (range_lbox.alen<32) {
					++range_lbox.alen;
					rangecr->strip[rangecr->strips].start=rangefirst;
					rangecr->strip[rangecr->strips].end=rangelast;
					++rangecr->strips;
					DrawListbox(&range_lbox);
					SliderRecompute(&range_sld1);
				};
			} else if (rect==258) {
				mouse_setpointer(to_pointer,7,3,ST3,ST0);
				mouse_wait_key();
				mouse_wait_unkey();
				mouse_read2(&x,&y,&b);
				if (rectInside((struct Rectangle *)&range_lbox,x,y)) {
					y=range_lbox.cpos+(y-range_lbox.y)/range_lbox.textheight;
					if (y>range_lbox.alen) y=range_lbox.alen;
					if (y<range_lbox.alen) {
						if (y!=range_lbox.alen)
							memmove(&rangecr->strip[y+1],&rangecr->strip[y],sizeof(struct CycleStrip)*(range_lbox.alen-y));
						rangecr->strip[y].start=rangefirst;
						rangecr->strip[y].end=rangelast;
						++rangecr->strips;
						++range_lbox.alen;
						DrawListbox(&range_lbox);
						SliderRecompute(&range_sld1);
					};
				};
				mouse_setpointer(crosshairs,7,7,ST3,ST0);
			} else if (rect==259) {
				if (range_lbox.sel>-1) {
					--range_lbox.alen;
					--rangecr->strips;
					if (range_lbox.sel<rangecr->strips)
						memmove(&rangecr->strip[range_lbox.sel],&rangecr->strip[range_lbox.sel+1],sizeof(struct CycleStrip)*(rangecr->strips+1-range_lbox.sel));
					range_lbox.sel=-1;
					range_lbox.seladd=NULL;
					DrawListbox(&range_lbox);
					SliderRecompute(&range_sld1);
				};
			};
		} else if (rectInside((struct Rectangle *)&range_lbox,x,y)) {
			SelectListbox(&range_lbox,range_lbox.cpos+(y-range_lbox.y)/range_lbox.textheight);
			if (cs=(struct CycleStrip *)range_lbox.seladd)
				ChangeColorRange(r,cs->start,cs->end);
		} else if (SliderHandle(&range_sld1,x,y)) {
		} else if (SliderHandle(&range_sld2,x,y)) {
		} else if (SliderHandle(&range_sld3,x,y)) {
			range_lbox.cpos=0;
			range_lbox.listadd=rangecr=&cyclerange[range_sld3.cposx];
			range_lbox.sel=-1;
			range_lbox.seladd=NULL;
			range_lbox.alen=rangecr->strips;
			DrawListbox(&range_lbox);
			SliderRecompute(&range_sld1);
			SliderAbs(&range_sld2,rangecr->speed,0);
		};
		mouse_wait_unkey();
	};

	SliderClose(&range_sld1);
	SliderClose(&range_sld2);
	SliderClose(&range_sld3);

	free(r);

	restore_screen();
}

void ChangeColorRange2(struct BitMap *bm,struct Rectangle *r,uchar first,uchar last) {
	short rfirst,rlast,t;

	rfirst=rangefirst;
	rlast=rangelast;
	rangefirst=first;
	rangelast=last;

/* sort the ranges */

	if (rfirst>rlast) {
		t=rfirst;
		rfirst=rlast;
		rlast=t;
	};
	if (first>last) {
		t=first;
		first=last;
		last=t;
	};

/* depress new colors not in old range */

	if (first<rfirst) {
		/* either	-bbb--aaa-,
		** or		-bxxxa---- */
		t=min(last+1,rfirst);
		if ((t-first)>0) Depress3DGadgets(bm,r+first,t-first);
	};
	if (last>rlast)	{
		/* either	-aaa--bbb-,
		** or		-axxxb---- */
		t=max(first-1,rlast);
		if ((last-t)>0) Depress3DGadgets(bm,r+t+1,last-t);
	};

/* release new colors not in old range */

	if (rfirst<first) {
		/* either	-aaa--bbb-,
		** or		-axxxb---- */
		t=min(first,rlast+1);
		if ((t-rfirst)>0) Release3DGadgets(bm,r+rfirst,t-rfirst);
	};
	if (rlast>last) {
		/* either	-bbb--aaa-,
		** or		-bxxxa---- */
		t=max(rfirst-1,last);
		if ((rlast-t)>0) Release3DGadgets(bm,r+t+1,rlast-t);
	};
}

void ChangeColorRange(struct Rectangle *r,uchar first,uchar last) {

	ChangeColorRange2(&vidbm,r,first,last);

/* redraw text spot */

	mouse_hide();
	vid_printf6(&vidbm,128,191,ST0,ST2,"%3d   to %3d",rangefirst,rangelast);
	vd->bar(&vidbm,152,191,5,8,rangefirst);
	vd->bar(&vidbm,200,191,5,8,rangelast);
	mouse_show();

	vd->refresh();
}

/* these functions for the range listbox */

struct CycleStrip *range_getindex(struct Listbox *lb,short index) {
	if (index>=((struct CycleRange *)lb->listadd)->strips)
		return NULL;
	return &((struct CycleRange *)lb->listadd)->strip[index];
}

void range_clearindex(struct Listbox *lb,short index) {
	vd->bar(lb->destbm,lb->x,lb->y+index*lb->textheight,lb->width,lb->textheight,ST2);
}

void range_displayindex(struct Listbox *lb,struct CycleStrip *cs,short index,short highlighted) {
	coord y;

	if (!cs) {
		range_clearindex(lb,index);
		return;
	};
	y=lb->y+index*lb->textheight;
	mouse_hide();
	vd->bar(lb->destbm,lb->x,y,lb->width,lb->textheight,highlighted ? ST1 : ST2);
	vid_printf6(lb->destbm,lb->x,y,highlighted ? ST3 : ST0,highlighted ? ST1 : ST2,"%3d   to %3d",cs->start,cs->end);
	vd->bar(lb->destbm,lb->x+24,y,5,8,cs->start);
	vd->bar(lb->destbm,lb->x+72,y,5,8,cs->end);
	mouse_show();
}

void range_scrollindex(struct Listbox *lb,short dy) {
	mouse_hide();
	vd->vblit(lb->destbm,lb->x,lb->y,lb->width,lb->height,dy*lb->textheight);
	mouse_show();
}

void range_clearwindow(struct Listbox *lb) {
	mouse_hide();
	vd->bar(lb->destbm,lb->x,lb->y,lb->width,lb->height,ST2);
	mouse_show();
}

void range_updater1(struct Slider *sld) {
	mouse_hide();
	if (sld->cposx >= 1193181.0) {
		vid_printf6(&vidbm,0,130,ST0,ST2,"%5.2f seconds/step",sld->cposx/1193181.0);
	} else if (sld->cposx) {
		vid_printf6(&vidbm,0,130,ST0,ST2,"%5.2f steps/second",1193181.0/sld->cposx);
	} else {
		vd->text6(&vidbm,0,130,          "----- Frozen -----",ST0,ST2);
	}
	rangecr->speed=sld->cposx;
	rangecr->timer=1;
	mouse_show();
}

void range_updater2(struct Slider *sld) {
	mouse_hide();
	vid_printf6(&vidbm,240,130,ST0,ST2,"Range %d",sld->cposx+1);
	mouse_show();
}

/* DrawColorArray: Draw all 256 colors on screen in a 32x8 matrix */

#define	RANGE_COLOR_WIDTH	(10)
#define	RANGE_COLOR_HEIGHT	(10)

void DrawColorArray(struct Rectangle *r) {
	long x,y,x2,y2,c;

	y2=0;
	c=0;
	for (y=0;y<8;y++) {
		x2=0;
		for (x=0;x<32;x++) {
			vid_draw3d(&vidbm,x2,y2,x2+RANGE_COLOR_WIDTH-1,y2+RANGE_COLOR_HEIGHT-1);
			vd->bar(&vidbm,x2+1,y2+1,RANGE_COLOR_WIDTH-2,RANGE_COLOR_HEIGHT-2,c++);
			r->x	  = x2;
			r->y	  = y2;
			r->width  = RANGE_COLOR_WIDTH;
			r->height = RANGE_COLOR_HEIGHT;
			++r;
			x2+=RANGE_COLOR_WIDTH;
		};
		y2+=RANGE_COLOR_HEIGHT;
	};
}

static int arrange_get_dest_color(struct Requester *req,struct Rectangle *r) {
	mouse_coord	mx,my,mb;
	int		rect;

 	mouse_setpointer(to_pointer,7,3,ST3,ST0);
	mouse_wait_key();
	mouse_wait_unkey();
	mouse_read2(&mx,&my,&mb);
 	mouse_setpointer(crosshairs,7,7,ST3,ST0);

	rect = rectSearch(r,mx - req->reqbm.xbias,my - req->reqbm.ybias);

	if (rect>=0 && rect<256) return rect;
	else return -1;
}

//////////////////////////////////////////////////////////////////////////////////////////////

static struct Requester pickcol;

void pickcol_vec(struct ZoneRange *zr,struct Zone *z,short x,short y) {
	coord xp,yp;

	x -= z->x;
	y -= z->y;

	x /= 8*XPOINT;	xp = z->x+x*8*XPOINT;
	y /= 8*YPOINT;	yp = z->y+y*8*YPOINT;

	mouse_hide();
	vid_inv3d(zonebm,xp,yp,xp+8*XPOINT-1,yp+8*YPOINT-1);
	vd->refresh();
	mouse_show();
	mouse_wait_unkey();

	zr->highindex = x+y*16;
}

void pickcol_disp(struct ZoneRange *zr,struct Zone *z,short ind,char frame) {
	int x,y;
	coord xp,yp;

	mouse_hide();
	for(y=0;y<16;y++) {
		for(x=0;x<16;x++) {
			xp = z->x + x*8*XPOINT;
			yp = z->y + y*8*YPOINT;
			vid_draw3d(zonebm,xp,yp,xp+8*XPOINT-1,yp+8*YPOINT-1);
			vd->bar(zonebm,xp+1,yp+1,8*XPOINT-2,8*YPOINT-2,x+y*16);
		}
	}
	mouse_show();
}

static struct Zone pickcol_z[]={
	{ 0,0,0,0,NULL,(ZoneHitHandler)&pickcol_vec,(ZoneDispHandler)&pickcol_disp },
	{-1,-1,-1,-1},
};

static struct ZoneRange pickcol_zr[]={
	NULL,pickcol_z,NULL,-1,ZR_TAP
};

static struct Requester pickcol={
	0,0,0,0,
	REQ_BORDER+REQ_POPCEN+REQ_COORDBIAS+REQ_SYSTITLE,
	"Choose color",
	St2,
	NULL,
	NULL,
	pickcol_zr,
	NULL,
	NULL,
	NULL,
	NULL
};

int	PalettePickColor(void) {
	mouse_coord mx,my,mb;
	boolean quit=FALSE;
	ulong msg;

	pickcol.width  = (16*8+4)*XPOINT;
	pickcol.height = (16*8+4)*YPOINT;
	pickcol_z[0].x = 2*XPOINT;
	pickcol_z[0].y = 2*YPOINT;
	pickcol_z[0].xs= 16*8*XPOINT;
	pickcol_z[0].ys= 16*8*YPOINT;

	mouse_read2(&mx,&my,&mb);
	if (!OpenRequester(&pickcol,mx,my)) return 0;

	while(!quit) {
		mouse_read2(&mx,&my,&mb);

		switch(msg = CheckRequester(&pickcol,mx,my,mb)) {
		case RZoneMsg(0,0):
			quit=TRUE;
			break;
		}
	}

	CloseRequester(&pickcol);

	return pickcol_zr[0].highindex;
}

////////////////////////////////////////////////////////////////////////////

static struct Requester pickacol_req;

#define C0	0
#define	C1	8
#define	C2	7
#define	C3	15

static uchar	hsvknob_save[49],
		hsv_knob[]={
		C0,C0,C3,C3,C3,C0,C0,
		C0,C3,C1,C1,C1,C2,C0,
		C3,C1,C0,C0,C0,C3,C1,
		C3,C1,C0,C0,C0,C3,C1,
		C3,C1,C0,C0,C0,C3,C1,
		C0,C2,C3,C3,C3,C1,C0,
		C0,C0,C1,C1,C1,C0,C0,
};

#undef C3
#undef C2
#undef C1
#undef C0

struct Sprite hsv_knob_sprite={
	NULL,NULL,
	{ (uchar *)hsv_knob },
	{ (uchar *)hsvknob_save },
	NULL,
	0,0,7,7,0,0,
	NULL,
	0,0,
};

ulong	fixedmulsquare32u(ulong,ulong);
#pragma aux fixedmulsquare32u="mul ebx","mul eax","add eax,eax","adc edx,0"\
	parm [eax] [ebx] value [edx] modify exact nomemory [eax edx];

static uchar pac_huered,pac_huegrn,pac_hueblu;
static uchar pac_hsred,pac_hsgrn,pac_hsblu;
static uchar pac_red,pac_grn,pac_blu;
static uchar pac_sat,pac_val;

void PickAbstractColorHSHandler(struct ZoneRange *zr,struct Zone *z,coord x,coord y) {
	ulong d;
	coord dx,dy,nx,ny;
	mouse_coord mx,my,mb;
	double	d2;
	double	a;
	long	al;

	while(mouse_readmove(&mx,&my,&mb),(mb)) {

		// bias coordinates

		mx -= pickacol_req.reqbm.xbias;
		my -= pickacol_req.reqbm.ybias;

		// compute distance

		nx = mx - 66*XPOINT;
		ny = my - 66*YPOINT;
		dx = abs(nx)/XPOINT;
		dy = abs(ny)/YPOINT;

		if (x_ratio>0x10000)
			d = dx*dx + fixedmulsquare32u(dy,x_ratio);
		else
			d = fixedmulsquare32u(dx,y_ratio) + dy*dy;

		d2 = sqrt(d);
		pac_sat = 4.0*d2;

		if (d>=4096) {
			mx = 66*XPOINT + (nx*64)/d2;
			my = 66*YPOINT + (ny*64)/d2;
			pac_sat = 255;
		}

		// get angle

		if (x_ratio>0x10000)
			a = atan2(fixedmul_32x16fi(ny/YPOINT,y_ratio),nx/XPOINT);
		else
			a = atan2(ny/YPOINT,fixedmul_32x16fi(nx/XPOINT,x_ratio));

#define HS_ADJUST (768.0/3.14159265358979323846);

		al = a*HS_ADJUST;
		if (al<0) al+=1536; else if (al>=1536) al-=1536;

		// compute hue

		switch(al>>8) {
		case 0:	pac_huered=255;		pac_huegrn=al&255;	pac_hueblu=  0;		break;
		case 1:	pac_huered=255-al&255;	pac_huegrn=255;		pac_hueblu=  0;		break;
		case 2:	pac_huered=  0;		pac_huegrn=255;		pac_hueblu=al&255;	break;
		case 3:	pac_huered=  0;		pac_huegrn=255-al&255;	pac_hueblu=255;		break;
		case 4:	pac_huered=al&255;	pac_huegrn=  0;		pac_hueblu=255;		break;
		case 5:	pac_huered=255;		pac_huegrn=  0;		pac_hueblu=255-al&255;	break;
		}

		pac_hsred = (pac_huered*(long)pac_sat+255L*(255-pac_sat))/255;
		pac_hsgrn = (pac_huegrn*(long)pac_sat+255L*(255-pac_sat))/255;
		pac_hsblu = (pac_hueblu*(long)pac_sat+255L*(255-pac_sat))/255;

		vid_setRGB6(14,pac_hsred,pac_hsgrn,pac_hsblu);

		pac_red = (pac_hsred*(ulong)pac_val)/255;
		pac_grn = (pac_hsgrn*(ulong)pac_val)/255;
		pac_blu = (pac_hsblu*(ulong)pac_val)/255;

		vid_setRGB6(1,pac_red,pac_grn,pac_blu);

		vid_setRGB6( 5,(pac_hsred*1L)/8,(pac_hsgrn*1L)/8,(pac_hsblu*1L)/8);
		vid_setRGB6( 6,(pac_hsred*2L)/8,(pac_hsgrn*2L)/8,(pac_hsblu*2L)/8);
		vid_setRGB6( 9,(pac_hsred*3L)/8,(pac_hsgrn*3L)/8,(pac_hsblu*3L)/8);
		vid_setRGB6(10,(pac_hsred*4L)/8,(pac_hsgrn*4L)/8,(pac_hsblu*4L)/8);
		vid_setRGB6(11,(pac_hsred*5L)/8,(pac_hsgrn*5L)/8,(pac_hsblu*5L)/8);
		vid_setRGB6(12,(pac_hsred*6L)/8,(pac_hsgrn*6L)/8,(pac_hsblu*6L)/8);
		vid_setRGB6(13,(pac_hsred*7L)/8,(pac_hsgrn*7L)/8,(pac_hsblu*7L)/8);

		mouse_hide();
		sprite_quikmove(&hsv_knob_sprite,mx-3,my-3);
		vd->refresh();
		mouse_show();
	}
}

static struct Zone pickacol_z[]={
	{ 0,0,0,0,ZN_3D+ZN_TEXTRENDER,NULL,"Ok" },
	{ 0,0,0,0,ZN_3D+ZN_TEXTRENDER,NULL,"Cancel" },
	{-1,-1,-1,-1},
};

static struct Zone pickacol_z2[]={
	{ 0,0,0,0,NULL,(ZoneHitHandler)&PickAbstractColorHSHandler,NULL },
	{-1,-1,-1,-1},
};

static struct ZoneRange pickacol_zr[]={
	{	pickacol_zr+1	,pickacol_z ,NULL,-1,ZR_TAP },
	{	NULL		,pickacol_z2,NULL,-1,ZR_CUSTOM },
};

///////////

static struct Slider pickacol_sld[];

static void PickAbstractColorVHandler(struct Slider *sld) {
	pac_val = 255-pickacol_sld[0].cposy;
	vid_setRGB6(1,(pac_hsred*(ulong)pac_val)/255,(pac_hsgrn*(ulong)pac_val)/255,(pac_hsblu*(ulong)pac_val)/255);
}

static struct Slider pickacol_sld[]={
	{	NULL,{NULL},NULL,{ 12,144,140,4 },
		NULL,0,0,
		8,4,
		0,0,
		0,255,
		16,16,
		0,0,
		0,0,
		SLD_ARROW1*2+SLD_ARROW2*8+SLD_ATTACHY,
		&PickAbstractColorVHandler,
		{ 0,0,8,8 },{ 0,0,8,8},
		0,-1,0,1,
		NULL
	}
};

static struct Requester pickacol_req={
	0,0,0,0,
	REQ_BORDER+REQ_POPCEN+REQ_COORDBIAS+REQ_SYSTITLE+REQ_FORCECOL,
	"Pick abstract color",
	St2,
	NULL,
	NULL,
	pickacol_zr,
	pickacol_sld,
	NULL,
	NULL,
	NULL
};

static uchar	huevals[]={
	0xff,0x00,0x00,	// 00
	0xff,0x33,0x00,	// 01
	0xff,0x66,0x00,	// 02
	0xff,0x99,0x00,	// 03
	0xff,0xcc,0x00,	// 04
	0xff,0xff,0x00,	// 05
	0xcc,0xff,0x00,	// 06
	0x99,0xff,0x00,	// 07
	0x66,0xff,0x00,	// 08
	0x33,0xff,0x00,	// 09
	0x00,0xff,0x00,	// 0a
	0x00,0xff,0x33,	// 0b
	0x00,0xff,0x66,	// 0c
	0x00,0xff,0x99,	// 0d
	0x00,0xff,0xcc,	// 0e
	0x00,0xff,0xff,	// 0f
	0x00,0xcc,0xff,	// 10
	0x00,0x99,0xff,	// 11
	0x00,0x66,0xff,	// 12
	0x00,0x33,0xff,	// 13
	0x00,0x00,0xff,	// 14
	0x33,0x00,0xff,	// 15
	0x66,0x00,0xff,	// 16
	0x99,0x00,0xff,	// 17
	0xcc,0x00,0xff,	// 18
	0xff,0x00,0xff,	// 19
	0xff,0x00,0xcc,	// 1a
	0xff,0x00,0x99,	// 1b
	0xff,0x00,0x66,	// 1c
	0xff,0x00,0x33,	// 1d
};




ulong	PickAbstractColor(void) {
	mouse_coord mx,my,mb;
	coord	x,y;
	long	c;
	boolean quit=FALSE;
	boolean	cancel=FALSE;
	ulong	msg;
	uchar	*ps;
	ulong	rndgen=1;


	pickacol_req.width		= (160+4)*XPOINT;
	pickacol_req.height		= (160+4)*YPOINT;
	pickacol_z[0].xs		=   4*XPOINT+4*sysfontwidth;
	pickacol_z[0].ys		=   4*YPOINT+sysfontheight;
	pickacol_z[0].x			= 156*XPOINT-4*sysfontwidth;
	pickacol_z[0].y			= 156*YPOINT-sysfontheight;
	pickacol_z[0].xs		=   4*XPOINT+6*sysfontwidth;
	pickacol_z[0].ys		=   4*YPOINT+sysfontheight;
	pickacol_z[0].x			= 152*XPOINT-6*sysfontwidth;
	pickacol_z[0].y			= 156*YPOINT-sysfontheight;
	pickacol_z2[0].x		=   2*XPOINT;
	pickacol_z2[0].y		=   2*YPOINT;
	pickacol_z2[0].xs		= 128*XPOINT;
	pickacol_z2[0].ys		= 128*YPOINT;
	pickacol_sld[0].min_width	=   8*XPOINT;
	pickacol_sld[0].min_height	=   4*YPOINT;
	pickacol_sld[0].boundbox.x	= 144*XPOINT;
	pickacol_sld[0].boundbox.y	=  18*YPOINT;
	pickacol_sld[0].boundbox.width	=   8*XPOINT;
	pickacol_sld[0].boundbox.height	=  97*YPOINT;
	pickacol_sld[0].arrow1.width	=
	pickacol_sld[0].arrow2.width	=  16*XPOINT;
	pickacol_sld[0].arrow1.height	=
	pickacol_sld[0].arrow2.height	=   8*YPOINT;

	if (!(ps = malloc(1536))) return 0;

	vid_saveRGB6(0,ps,256);

	mouse_read2(&mx,&my,&mb);
	if (!OpenRequester(&pickacol_req,mx,my)) {
		free(ps);
		return 0;
	}

	memcpy(ps+768,stdcol,48);

	c=768+48;
	for(x=0;x<90;x+=3) {
		for(y=0;y<8;y++) {
			ps[c+0]=(huevals[x+0]*(y+1)+255*(7-y))/9;
			ps[c+1]=(huevals[x+1]*(y+1)+255*(7-y))/9;
			ps[c+2]=(huevals[x+2]*(y+1)+255*(7-y))/9;
			c+=3;
		}
	}

	vid_loadRGB6(0,ps+768,256);

	mouse_hide();

	// draw hue/saturation circle

	{
		int	rz	= 64*max(XPOINT,YPOINT);
		int	rx	= (min(0x10000,x_ratio)*XPOINT)/max(XPOINT,YPOINT);
		int	ry	= (min(0x10000,y_ratio)*YPOINT)/max(XPOINT,YPOINT);
		int	px	= 66*XPOINT;
		int	py	= 66*YPOINT;
		int	halfpts	= 295*max(XPOINT,YPOINT);
		ulong	cpi	= 0x80000L/rz;
		ulong	cpa	= 0;
		ulong	cpai	= 0xf00000L/(2*halfpts);
		double	ainc	= 3.14159265358979323846/halfpts;
		double	a;

		for(a=0;a<3.14159265358979323846*2;a+=ainc) {
			long	ix,iy;
			long	sx,sy;
			ulong	cp,cp2,cpa2;
			int	r;

			ix	= cos(a)*rx;
			iy	= sin(a)*ry;

			sx=sy=0;
			cp=0;

			for(r=0;r<rz;r++) {
				cpa2 = cpa+((rndgen=psr32adv16(rndgen))&0xfffff)-0x80000+0x40000;
				if (cpa2>=0xff000000) cpa2+=0xf00000;
				else if (cpa2>=0xf00000) cpa2-=0xf00000;

				cp2 = cp+((rndgen=psr32adv16(rndgen))&0x0ffff)-0x08000+0x8000;
				if (cp2>=0xff0000) cp2=0; else if (cp2>0x80000) cp2=0x7ffff;

				vd->plot(&pickacol_req.reqbm,px+(sx>>16),py+(sy>>16),16+(cp2>>16)+((cpa2&0xf80000)>>16));
				sx += ix;
				sy += iy;
				cp += cpi;
			}
			cpa+=cpai;
		}
	}

	// draw value bar on the right
	//
	// shade the value bar: 0F -> 0E -> 0D -> 0C -> 0B -> 0A -> 09 -> 06 -> 00

	{
		coord	xb=135*XPOINT,yb=18*YPOINT;
		int	x,y;
		long	shade=0x10000;
		long	shade2;
		long	shadeinc = 0x2aa/YPOINT;
		uchar	c;

		for(y=0;y<=96*YPOINT;y++) {
			for(x=0;x<8*XPOINT;x++) {
				shade2 = shade + ((rndgen=psr32adv16(rndgen))&0x3fff)-0x2000;
				if (shade2<0) shade2=0; else if (shade2>=0x10000) shade2=0x10000;

				if	(shade2>=0xe38e)	c=0x0e;
				else if	(shade2>=0xc71c)	c=0x0d;
				else if	(shade2>=0xaaaa)	c=0x0c;
				else if (shade2>=0x8e38)	c=0x0b;
				else if (shade2>=0x71c7)	c=0x0a;
				else if (shade2>=0x5555)	c=0x09;
				else if (shade2>=0x38e3)	c=0x06;
				else if (shade2>=0x1c71)	c=0x05;
				else				c=0x00;

				vd->plot(&pickacol_req.reqbm,xb+x,yb+y,c);
			}
			shade-=shadeinc;
		}
	}

	sprite_init(&hsv_knob_sprite,hsv_knob_sprite.imgbm.vm,hsv_knob_sprite.savebm.vm,&pickacol_req.reqbm,hsv_knob_sprite.width);
	sprite_quikmove(&hsv_knob_sprite,66*XPOINT-3,66*YPOINT-3);

	vd->bar(&pickacol_req.reqbm, 4*XPOINT,144*YPOINT,16*XPOINT,16*YPOINT,14);
	vd->bar(&pickacol_req.reqbm,24*XPOINT,144*YPOINT,16*XPOINT,16*YPOINT,1);

	vd->refresh();
	mouse_show();

	while(!quit) {
		mouse_read2(&mx,&my,&mb);

		switch(msg = CheckRequester(&pickacol_req,mx,my,mb)) {
		case RZoneMsg(0,1):
			cancel=TRUE;
		case RZoneMsg(0,0):
			quit=TRUE;
			break;
		}
	}

	CloseRequester(&pickacol_req);

	vid_loadRGB6(0,ps,256);
	free(ps);

	if (cancel)
		return 0xffffffff;
	else
		return ((ulong)pac_red<<16) + ((ulong)pac_grn<<8) + (ulong)pac_blu;
}

