	.386p
	.model	flat
	NAME	asmfunc

	include	asmhead.i

	.data?

mouse_EAX	dd	?
mouse_EBX	dd	?
mouse_ECX	dd	?
mouse_EDX	dd	?
mouse_ESI	dd	?
mouse_EDI	dd	?

	.data

mouse_called	db	0

_TEXT	SEGMENT	DWORD PUBLIC USE32 'CODE'
	PUBLIC	vid_detect_
	PUBLIC	cpu_detect_
	PUBLIC	cpu_speed_
	PUBLIC	asm_mouse_disable_
	PUBLIC	asm_mouse_enable_
	PUBLIC	asm_mouse_ptrfunc_
	PUBLIC	asm_mouse_ptrf2_
	PUBLIC	asm_2xblit_fwd_
	PUBLIC	asm_4xblit_fwd_
	PUBLIC	asm_8xblit_fwd_
	PUBLIC	asm_16xblit_fwd_
	extern	printf_ :near
	extern	mouse_pointerfunc_:near
	extern	__GETDS:near

vid_detect_:
	push	ebx

;first check for VGA... if so, return it immediately

	mov	ax,1a00h		;read display codes
	int	10h
	cmp	al,1ah			;VGA?
	jne	vdet_not_vga
	mov	al,"V"			;return V for VGA
	pop	ebx
	ret
vdet_not_vga:
	mov	bl,10h			;try EGA
	mov	ah,12h
	int	10h
	cmp	al,10h			;failed?
	je	vdet_not_ega
	mov	al,"E"			;return E for EGA
	pop	ebx
	ret
vdet_not_ega:
	mov	dx,03d4h		;try CGA
	call	vdet_detectCRTC
	jne	vdet_not_cga
	mov	al,"C"			;return C for CGA
	pop	ebx
	ret
vdet_not_cga:
	mov	dx,03b4h		;try MDA
	call	vdet_detectCRTC
	jne	vdet_not_mda
	mov	al,"M"			;return M for MDA
	pop	ebx
	ret
vdet_not_mda:
	xor	al,al			;return NULL
	pop	ebx
	ret
vdet_detectCRTC:
	mov	al,0fh			;cursor low register
	out	dx,al			;save current value
	inc	dx
	in	al,dx
	mov	bl,al
	mov	al,66h			;write '66' into it
	out	dx,al
	xor	cx,cx			;stupid delay routine
vdet_delay:
	nop
	loop	vdet_delay
	in	al,dx			;read it back to see if '66' actually stored
	mov	bh,al
	mov	al,bl
	out	dx,al			;restore old value
	cmp	bh,66h			;compare & exit
	ret

cpu_detect_:
	cli				;no interrupts!!
	pushfd
	pop	eax
	push	eax			;save old AC setting
	and	eax,0ffffcfffh
	or	eax,000040000h
	push	eax
	popfd
	pushfd
	pop	eax
	test	eax,000040000h
	jnz	cpud_not_386
	popfd				;pop off EFLAGS
	sti				;restore interrupts
	mov	al,3			;386 CPU
	ret
cpud_not_386:
	popfd
	pushfd
	sti				;restore interrupts
	pop	eax
	and	eax,0ffdfffffh		;clear ID flag
	push	eax
	popfd
	pushfd
	pop	eax
	test	eax,000200000h		;ID flag cleared?
	jnz	cpud_is_486		;it's a 486 if not
	or	eax,000200000h		;set ID flag
	push	eax
	popfd
	pushfd
	pop	eax
	test	eax,000200000h		;ID flag set?
	jz	cpud_is_486		;it's a 486 if not

;	mov	eax,1			;at least a Pentium now
;	xCPUID
;	xchg	al,ah			;return bits 8-11
;	and	al,15

	mov	al,5

	ret
cpud_is_486:
	mov	al,4			;486 CPU
	ret


cpus_486_loops	=	65536
;cpus_386_loops	=	32768
cpus_386_loops	=	512

cpus_486_fudge	=	98304

cpu_speed_:
	push	ebx
	push	ecx
	push	edx
	push	esi
	push	edi

; make sure speaker is gated but off

	push	eax

	in	al,61h
	or	al,1			;gate high
	and	al,0fdh			;speaker low
	out	61h,al

; set speaker for max period, interrupt mode

	mov	al,0B0h			;timer2 msb-then-lsb mode 0 binary
	out	43h,al
	xor	al,al
	out	42h,al
	out	42h,al

	pop	eax

; determine CPU

	cmp	al,3			;is it a 386 CPU?
	jz	cpus_is_386
	cmp	al,4			;is it a 486 CPU?
	jnz	cpus_not_486

;	it's a 486... do a test loop
	cli				;disable interrupts
	mov	ebx,cpus_486_loops
cpus_486_retry:
	mov	ecx,ebx
	mov	eax,00000080h
	out	43h,al			;latch counter 2 (11)
	in	al,42h			;9 cycles
	mov	dl,al			;1 cycle
	in	al,42h			;9 cyc,es
	mov	dh,al			;1 cycle

;I would normally use dec...jne instead of a loop, but branches
;seem a tad slower on a Cx486, but loop seems a bit steadier.
;(branches seem to take a cycle longer on a Cyrix)

cpus_486_loop:
	inc	eax			;1 cycle
	loop	cpus_486_loop		;7 taken, 6 not taken
;	dec	ecx			;1 cycle
;	jne	cpus_486_loop		;3 cycles taken, 1 cycle not taken

	mov	eax,00000080h		;1 cycle
	out	43h,al			;latch counter 2 (11)
	in	al,42h
	xchg	al,ah			;1 cycle
	in	al,42h
	xchg	al,ah			;1 cycle
	sub	ax,dx			;ax=# of clock ticks
	neg	ax
	and	eax,0000ffffh
	sti				;reenable interrupts
	mov	ecx,eax
	cmp	eax,00007800h
	jae	cpus_486_enough_cycles
	add	ebx,ebx
	jmp	cpus_486_retry

cpus_486_enough_cycles:

;	eax holds # of clock ticks (1193181/s)... # of cycles for an i486
;	is 1048576*3+22=3145721 cycles. 3145721(c)/clockrate(cps)=seconds,
;	cycles/speed=seconds, cycles*1193181/speed=ticks, cycles*1193181/ticks=speed

	mov	eax,8
	mul	ebx
	add	eax,31+cpus_486_fudge
	mov	ebx,1193181
	mul	ebx
	div	ecx

	jmp	cpus_exit

cpus_not_486:

; check to see if this CPU can CPUID; if so, check for Pentium RDTSC compatibility

	pushfd
	pop	ecx
	mov	eax,ecx
	xor	eax,200000h
	push	eax
	popfd
	pushfd
	pop	eax
	xor	eax,ecx
	test	eax,200000h
	jz	cpus_exit		;didn't flip, doesn't support RDTSC

; run CPU independent test

	spkoff
	setup_timer2
	xor	ebx,ebx
	xor	ecx,ecx
	cli
	rdtmr2	bl,bh
	xRDTSC

	mov	esi,eax
	mov	edi,edx

time_not_elapsed:
	rdtmr2	cl,ch
	xRDTSC
	test	bh,ch
	js	time_not_elapsed

	sti
	sub	bx,cx

	sub	eax,esi
	sbb	edx,edi
	mov	edi,edx

	mov	ecx,1193181
	mul	ecx
	mov	esi,eax
	mov	eax,edi
	mov	edi,edx
	mul	ecx
	add	edi,eax
	mov	edx,edi
	mov	eax,esi
	div	ebx

	jmp	cpus_exit

cpus_is_386:
;	it's a 386... do a test loop
	cli				;disable interrupts
	mov	ebx,cpus_386_loops
cpus_386_retry:
	mov	ecx,ebx
	mov	eax,00000080h
	out	43h,al			;latch counter 2 (4)
	in	al,42h			;6 cycles
	mov	dl,al			;2 cycles
	in	al,42h			;6 cycles
	mov	dh,al			;2 cycles

cpus_386_loop:
	inc	eax			;2 cycles 
	dec	ecx			;2 cycles
	jne	cpus_386_loop		;7+1 cycles taken, 3 cycles not taken

	mov	eax,00000080h		;2 cycles
	out	43h,al			;latch counter 0 (4)
	in	al,42h
	xchg	al,ah
	in	al,42h
	xchg	al,ah
	sub	ax,dx			;ax=# of clock ticks
	neg	ax
	and	eax,0000ffffh
;	cwde				;convert to doubleword
	sti				;reenable interrupts

	mov	ecx,eax
	cmp	eax,00007800h		;>=32768 yet?
	jae	cpus_386_enough_cycles
	add	ebx,ebx			;do twice the cycles
	jmp	cpus_386_retry

cpus_386_enough_cycles:

;	eax holds # of clock ticks (1193181/s)... # of cycles for an i386
;	is 524288*12+17=6291473 cycles. 6291473(c)/clockrate(cps)=seconds,
;	cycles/speed=seconds, cycles*1193181/speed=ticks, cycles*1193181/ticks=speed

	mov	eax,12
	mul	ebx
	add	eax,17
	mov	ebx,1193181
	mul	ebx
	div	ecx

;	mov	eax,1193181
;	mov	ecx,cpus_386_loops*12+17
;	mul	ecx
;	div	ebx			;eax=speed in Hz

cpus_exit:
	pop	edi
	pop	esi
	pop	edx
	pop	ecx
	pop	ebx
	ret


asm_mouse_disable_:

	inc	[mouse_disable_count]
	ret

asm_mouse_enable_:
	mov	eax,mouse_disable_count
	or	eax,eax
	jz	asm_mouse_enable@1
	cmp	eax,1
	jnz	asm_mouse_enable@2

	mov	al,mouse_called
	or	al,al
	jz	asm_mouse_enable@2

	pushad
	mov	eax,mouse_EAX
	mov	ebx,mouse_EBX
	mov	ecx,mouse_ECX
	mov	edx,mouse_EDX
	mov	esi,mouse_ESI
	mov	edi,mouse_EDI
	call	mouse_pointerfunc_
	popad

	mov	mouse_called,0

asm_mouse_enable@2:
	dec	mouse_disable_count
asm_mouse_enable@1:
	ret

asm_mouse_ptrfunc_:
	cli
	push	ds
	push	es
	call	__GETDS
	push	ds
	pop	es

	test	[mouse_disable_count],0ffffffffh
	jz	reenter_ok

	mov	mouse_EAX,eax
	mov	mouse_EBX,ebx
	mov	mouse_ECX,ecx
	mov	mouse_EDX,edx
	mov	mouse_ESI,esi
	mov	mouse_EDI,edi
	mov	mouse_called,1

	jmp	asfexit
reenter_ok:
	inc	[mouse_disable_count]

	sti

	mov	word ptr [_mouse_stack_ptrsave+4],ss
	mov	dword ptr [_mouse_stack_ptrsave],esp

	lss	esp,fword ptr [_mouse_stack_pointer]

	push	fs
	push	gs

	mov	mouse_called,0

	call	mouse_pointerfunc_

	pop	gs
	pop	fs

	lss	esp,fword ptr [_mouse_stack_ptrsave]

	dec	[mouse_disable_count]
asfexit:
	pop	es
	pop	ds
	sti
	retf

	public	_mouse_stack_pointer

mouse_disable_count	dd	0
_mouse_stack_ptrsave	df	0
_mouse_stack_pointer	df	0


;*** asm_mouse_ptrf2(): for real DPMI servers

asm_mouse_ptrf2_:
 	push	es		;save ES:EDI structure pointer
	push	edi
	push	ds		;save DS:ESI rm stack pointer
	push	esi

	call	__GETDS

	test	[mouse_disable_count],0ffffffffh
	jnz	asf2exit
	inc	[mouse_disable_count]

	mov	eax,es:[edi+1ch]	;get EAX
	mov	ebx,es:[edi+10h]	;get EBX
	mov	ecx,es:[edi+18h]	;get ECX
	mov	edx,es:[edi+14h]	;get EDX
	mov	esi,es:[edi+04h]	;get ESI
	mov	edi,es:[edi]	;get EDI

	push	ds
	pop	es

	mov	word ptr [_mouse_stack_ptrsave+4],ss
	mov	dword ptr [_mouse_stack_ptrsave],esp

	lss	esp,fword ptr [_mouse_stack_pointer]

	call	mouse_pointerfunc_

	lss	esp,fword ptr [_mouse_stack_ptrsave]

	dec	[mouse_disable_count]
asf2exit:
	
	pop	esi		;restore DS:ESI rm stack pointer
	pop	ds
	pop	edi		;restore ES:EDI structure pointer
	pop	es

; fetch [SS:SP] from data structure and place into CS:IP
	mov	eax,[esi]			;get return address (CS:IP)
	mov	es:[edi+2ah],eax		;store new return address
	add	es:word ptr [edi+2eh],4		;increment real mode SP (RETF)

	iretd


;*******************************  VIDEO 4X ROUTINES ****************************

;ESI	source starting address
;EDI	destination starting address
;EBX	destination width in bytes
;ECX	copy width in bytes
;EDX	source width in bytes
;EAX	copy height

asm_4xblit_fwd_:
	push	ebp
	sub	edx,ecx			;turn src width into modulo
	mov	ebp,eax
a4xf2:
	push	edi
	push	ecx
	push	edx
	xor	eax,eax
a4xf1:
	mov	al,[esi]		;(u) get byte
	inc	esi			;(v)
	mov	ah,al			;(u) expand to word
	mov	edx,eax			;(u)
	add	edi,ebx			;(v)
	shl	edx,16			;(u)
	or	edx,eax			;(u)
	mov	[edi+ebx],edx		;(u) write two rows
	mov	[edi+ebx*2],edx		;(v)
	sub	edi,ebx			;(u)
	add	edi,4			;(v)
	mov	[edi-4],edx		;(u) write two rows
	mov	[edi+ebx-4],edx		;(v)
	dec	ecx			;(u)
	jne	a4xf1			;(v) do all bytes in a row

	pop	edx
	pop	ecx
	pop	edi

	lea	edi,[edi+ebx*4]
	add	esi,edx
	dec	ebp
	jne	a4xf2
	pop	ebp
	ret

;ESI	source starting address
;EDI	destination starting address
;EBX	destination width in bytes
;ECX	copy width in bytes
;EDX	source width in bytes
;EAX	copy height

asm_2xblit_fwd_:

	push	ebp
	mov	ebp,eax
	sub	edx,ecx
asm_2xblit_fwd@2:
	push	ecx
	push	edi
asm_2xblit_fwd@1:
	mov	al,[esi]		;(u)
	inc	esi			;(v)
	mov	[edi],al		;(u)
	mov	[edi+1],al		;(v)
	mov	[edi+ebx],al		;(u)
	mov	[edi+ebx+1],al		;(v)
	add	edi,2			;(u)
	dec	ecx			;(v)
	jne	asm_2xblit_fwd@1	;(v)
	pop	edi
	pop	ecx
	lea	edi,[edi+ebx*2]
	add	esi,edx
	dec	ebp
	jne	asm_2xblit_fwd@2
	pop	ebp
	ret


;ESI	source starting address
;EDI	destination starting address
;EBX	destination width in bytes
;ECX	copy width in bytes
;EDX	source width in bytes
;EAX	copy height

asm_8xblit_fwd_:
	push	ebp
	sub	edx,ecx			;turn src width into modulo
	mov	ebp,eax
a8xf2:
	push	edi
	push	ecx
	push	edx
	xor	eax,eax
a8xf1:
	mov	al,[esi]		;(u) get byte
	inc	esi			;(v)
	mov	ah,al			;(u) expand to word
	mov	edx,eax			;(u)
	add	edi,8			;(v)
	shl	edx,16			;(u)
	push	edi			;(v)
	or	edx,eax			;(u)
	mov	[edi-8],edx		;(u) write row 0
	mov	[edi-4],edx		;(v)
	mov	[edi+ebx-8],edx		;(u) write row 1
	mov	[edi+ebx-4],edx		;(v)
	mov	[edi+ebx*2-8],edx	;(u) write row 2
	mov	[edi+ebx*2-4],edx	;(v)
	mov	[edi+ebx*4-8],edx	;(u) write row 4
	mov	[edi+ebx*4-4],edx	;(v)
	lea	edi,[edi+ebx*4]		;(u)
	sub	edi,ebx			;(u)
	mov	[edi-8],edx		;(u) write row 3
	mov	[edi-4],edx		;(v)
	mov	[edi+ebx*2-8],edx	;(u) write row 5
	mov	[edi+ebx*2-4],edx	;(v)
	mov	[edi+ebx*4-8],edx	;(u) write row 7
	mov	[edi+ebx*4-4],edx	;(v)
	add	edi,ebx
	mov	[edi+ebx*2-8],edx	;(u) write row 6
	mov	[edi+ebx*2-4],edx	;(v)
	pop	edi
	dec	ecx			;(u)
	jne	a8xf1			;(v) do all bytes in a row

	pop	edx
	pop	ecx
	pop	edi

	lea	edi,[edi+ebx*8]
	add	esi,edx
	dec	ebp
	jne	a8xf2
	pop	ebp
	ret

;ESI	source starting address
;EDI	destination starting address
;EBX	destination width in bytes
;ECX	copy width in bytes
;EDX	source width in bytes
;EAX	copy height

asm_16xblit_fwd_:
	push	ebp
	sub	edx,ecx			;turn src width into modulo
	mov	ebp,eax
a16xf2:
	push	edi
	push	ecx
	push	edx
	xor	eax,eax
a16xf1:
	mov	al,[esi]		;(u) get byte
	inc	esi			;(v)
	mov	ah,al			;(u) expand to word
	mov	edx,eax			;(u)
	add	edi,16			;(v)
	shl	edx,16			;(u)
	push	edi			;(v)
	or	edx,eax			;(u)
	mov	[edi-16],edx		;(u) write row 0
	mov	[edi-12],edx		;(v)
	mov	[edi-8],edx		;(u)
	mov	[edi-4],edx		;(v)
	mov	[edi+ebx-16],edx	;(u) write row 1
	mov	[edi+ebx-12],edx	;(v)
	mov	[edi+ebx-8],edx		;(u)
	mov	[edi+ebx-4],edx		;(v)
	mov	[edi+ebx*2-16],edx	;(u) write row 2
	mov	[edi+ebx*2-12],edx	;(v)
	mov	[edi+ebx*2-8],edx	;(u)
	mov	[edi+ebx*2-4],edx	;(v)
	mov	[edi+ebx*4-16],edx	;(u) write row 4
	mov	[edi+ebx*4-12],edx	;(v)
	mov	[edi+ebx*4-8],edx	;(u)
	mov	[edi+ebx*4-4],edx	;(v)
	mov	[edi+ebx*8-16],edx	;(u) write row 8
	mov	[edi+ebx*8-12],edx	;(v)
	mov	[edi+ebx*8-8],edx	;(u)
	mov	[edi+ebx*8-4],edx	;(v)
	lea	edi,[edi+ebx*4]		;(u) EDI -> row 4
	sub	edi,ebx			;(u) EDI -> row 3
	mov	[edi-16],edx		;(u) write row 3
	mov	[edi-12],edx		;(v)
	mov	[edi-8],edx		;(u)
	mov	[edi-4],edx		;(v)
	mov	[edi+ebx*2-16],edx	;(u) write row 5
	mov	[edi+ebx*2-12],edx	;(v)
	mov	[edi+ebx*2-8],edx	;(u)
	mov	[edi+ebx*2-4],edx	;(v)
	mov	[edi+ebx*4-16],edx	;(u) write row 7
	mov	[edi+ebx*4-12],edx	;(v)
	mov	[edi+ebx*4-8],edx	;(u)
	mov	[edi+ebx*4-4],edx	;(v)
	mov	[edi+ebx*8-16],edx	;(u) write row 11
	mov	[edi+ebx*8-12],edx	;(v)
	mov	[edi+ebx*8-8],edx	;(u)
	mov	[edi+ebx*8-4],edx	;(v)
	lea	edi,[edi+ebx*2]		;(u) EDI -> row 5
	mov	[edi+ebx-16],edx	;(u) write row 6
	mov	[edi+ebx-12],edx	;(v)
	mov	[edi+ebx-8],edx		;(u)
	mov	[edi+ebx-4],edx		;(v)
	mov	[edi+ebx*4-16],edx	;(u) write row 9
	mov	[edi+ebx*4-12],edx	;(v)
	mov	[edi+ebx*4-8],edx	;(u)
	mov	[edi+ebx*4-4],edx	;(v)
	mov	[edi+ebx*8-16],edx	;(u) write row 13
	mov	[edi+ebx*8-12],edx	;(v)
	mov	[edi+ebx*8-8],edx	;(u)
	mov	[edi+ebx*8-4],edx	;(v)
	lea	edi,[edi+ebx*4]		;(u) EDI -> row 9
	add	edi,ebx			;(u) EDI -> row 10
	mov	[edi-16],edx		;(u) write row 10
	mov	[edi-12],edx		;(v)
	mov	[edi-8],edx		;(u)
	mov	[edi-4],edx		;(v)
	mov	[edi+ebx*2-16],edx	;(u) write row 12
	mov	[edi+ebx*2-12],edx	;(v)
	mov	[edi+ebx*2-8],edx	;(u)
	mov	[edi+ebx*2-4],edx	;(v)
	mov	[edi+ebx*4-16],edx	;(u) write row 14
	mov	[edi+ebx*4-12],edx	;(v)
	mov	[edi+ebx*4-8],edx	;(u)
	mov	[edi+ebx*4-4],edx	;(v)
	lea	edi,[edi+ebx*4]		;(u) EDI -> row 14
	mov	[edi+ebx-16],edx	;(u) write row 15
	mov	[edi+ebx-12],edx	;(v)
	mov	[edi+ebx-8],edx		;(u)
	mov	[edi+ebx-4],edx		;(v)
	pop	edi
	dec	ecx			;(u)
	jne	a16xf1			;(v) do all bytes in a row

	pop	edx
	pop	ecx
	pop	edi

	lea	edi,[edi+ebx*8]
	add	esi,edx
	lea	edi,[edi+ebx*8]
	dec	ebp
	jne	a16xf2
	pop	ebp
	ret


;///////////////////////////////// INTERRUPT HANDLING ROUTINES

list_next	=	0
list_prevnext	=	4
list_prev	=	8

node_next	=	0
node_prev	=	4

clist_node	=	0
clist_list	=	8

call_node	=	0
call_func	=	8
call_data	=	12

ihndlr_call	=	0
ihndlr_rmc	=	16
ihndlr_counter	=	56
ihndlr_time	=	60

CALL_LIST	MACRO	clist,oldrout
		local	$1,$2,$3
		pushad
		push	ds
		push	es
		call	__GETDS
		mov	ax,ds
		mov	es,ax
		mov	esi,dword ptr clist + clist_list + list_prev
$1:		mov	edi,[esi + node_prev]
		or	edi,edi
		jz	$2
		mov	eax,[esi+call_data]
		call	dword ptr [esi+call_func]
		or	eax,eax
		jnz	$3
$2:
		mov	esi,edi
		jmp	short $1
$3:
		mov	ecx,dword ptr oldrout
		mov	ax,word ptr oldrout+4
		xchg	ecx,[esp+20h]
		xchg	eax,[esp+24h]
		pop	es
		pop	ds
		pop	edi
		pop	esi
		pop	ebp
		pop	ebx
		pop	ebx
		pop	edx
		retf

		ENDM

		public	asm_int08_handler_
		public	asm_int09_handler_
		public	asm_int0a_handler_
		public	asm_int0b_handler_
		public	asm_int0c_handler_
		public	asm_int0d_handler_
		public	asm_int0e_handler_
		public	asm_int0f_handler_

		extrn	_IntCallList	: near
		extrn	_IntOldHandlers : near
		extrn	_Int08TimerPeriod : near
		extrn	_Int08TimerCounter: near
		extrn	_IntStacks	: near
		extrn	_IntOldStackSegments : near

asm_int08_handler_:
		pushad
		push	ds
		push	es
		push	fs
		push	gs
		cld
		call	__GETDS
		mov	ax,ds
		mov	es,ax
		
;stack switch to big 8K stack
		xchg	esp,dword ptr _IntStacks
		mov	word ptr _IntOldStackSegments,ss
		mov	ss,ax

		sti			;go ahead & enable ints (none will come, since we are IRQ 0)

		mov	esi,dword ptr _IntCallList + clist_list + list_prev
$1:		mov	edi,[esi + node_prev]
		or	edi,edi
		jz	$3
		mov	ebx,dword ptr [esi + ihndlr_time]
		or	ebx,ebx
		jz	$5		;if timer period is zero, call every tick
		mov	eax,dword ptr _Int08TimerPeriod
		sub	dword ptr [esi + ihndlr_counter],eax
 		jnc	$2
		add	dword ptr [esi + ihndlr_counter],ebx
$5:
		mov	eax,[esi+call_data]
		call	dword ptr [esi+call_func]
		or	eax,eax
		jnz	$3
$2:
		mov	esi,edi
		jmp	short $1
$3:

;stack switch back down to teeny stack
		cli			;don't interrupt during task switch

		mov	ss,word ptr _IntOldStackSegments
		xchg	esp,dword ptr _IntStacks

		mov	eax,dword ptr _Int08TimerPeriod
		sub	dword ptr _Int08TimerCounter,eax
		jc	$4
		mov	al,60h
		out	20h,al
		pop	gs
		pop	fs
		pop	es
		pop	ds
		popad
		iretd
$4:
		inc	word ptr _Int08TimerCounter+2

		mov	ecx,dword ptr _IntOldHandlers
		mov	ax,word ptr _IntOldHandlers+4

		xchg	ecx,[esp+28h]
		xchg	eax,[esp+2ch]
		pop	gs
		pop	fs
		pop	es
		pop	ds
		pop	edi
		pop	esi
		pop	ebp
		pop	ebx
		pop	ebx
		pop	edx
		retf


asm_int09_handler_:	CALL_LIST	_IntCallList+20,_IntOldHandlers+6
asm_int0a_handler_:	CALL_LIST	_IntCallList+40,_IntOldHandlers+12
asm_int0b_handler_:	CALL_LIST	_IntCallList+60,_IntOldHandlers+18
asm_int0c_handler_:	CALL_LIST	_IntCallList+80,_IntOldHandlers+24
asm_int0d_handler_:	CALL_LIST	_IntCallList+100,_IntOldHandlers+30
asm_int0e_handler_:	CALL_LIST	_IntCallList+120,_IntOldHandlers+36
asm_int0f_handler_:	CALL_LIST	_IntCallList+140,_IntOldHandlers+42

	public	CBS_IntRoutine_
;	extrn	_prev_int_12	: fword
	public	_prev_int_12
	extrn	_realmem	: byte

_prev_int_12	dd	0
		dw	0

CBS_IntRoutine_:
	push	ds
	push	esi
	call	__GETDS
	mov	esi,dword ptr _realmem
	test	byte ptr [esi],0ffh
	jz	CBS_IntRoutine_Abort
	pop	esi
	push	gs
	push	fs
	push	es
	pushad
	push	ds
	pop	es
	cld
	mov	esi,dword ptr _realmem
	mov	byte ptr [esi],0h
	call	ebp
	popad
	pop	es
	pop	fs
	pop	gs
	pop	ds
	iretd

CBS_IntRoutine_Abort:
	pop	esi
	pop	ds
	jmp	cs:fword ptr [_prev_int_12]



;********************* LZ DECOMPRESSION
;
; void LZDecompMem(void *dst,void *src);
;		      EAX       EDX
;
; Decompresses an LZ compressed data block.
;
; The LZ data must be compressed with the LZ compression program version
; designed for in-memory decompression, lzprog.  The block compression
; format, used by lzss, will not work with this routine.
;
; This particular routine writes out 4078 null bytes before the actual data
; is decompressed.  You must provide this extra space yourself.  Remember,
; the actual decompressed data is at <src+4078>.

	public	LZDecompMem_

LZDecompMem_:
	push	ebp
	push	edi
	push	esi

	mov	edi,eax			;dst->edi
	mov	esi,edx			;src->esi
	mov	ecx,(4096-20)/4		;write out 4078 clear bytes
	xor	eax,eax
	rep	stosd
	stosw

	mov	ebp,[esi]
	add	esi,4

	xor	edx,edx
lzdcm1:
	shr	edx,1
	test	edx,0100h
	jnz	lzdcm2
	mov	dl,[esi]
	inc	esi
	mov	dh,0ffh
lzdcm2:
	test	edx,1
	jz	lzdcm3
	mov	al,[esi]
	inc	esi
	mov	[edi],al
	inc	edi
	jmp	short lzdcm4
lzdcm3:
	xor	eax,eax
	mov	ax,[esi]
	add	esi,2
	rol	ah,4
	mov	ecx,eax
	and	ah,0fh
	shr	ecx,12
	add	ecx,3

	mov	ebx,esi
	mov	esi,edi
	add	esi,eax
	sub	esi,1000h

	rep	movsb
	mov	esi,ebx
lzdcm4:
	dec	ebp
	jne	lzdcm1
	
	pop	esi
	pop	edi
	pop	ebp
	ret

;*********************************************************

	public	asm_kbd_check_
	extern	kbhit_: near

asm_kbd_check_:
	call	kbhit_			;probably redundant
	or	eax,eax
	jz	asm_kbd_check@1		;exit if no keypress
	mov	ah,1			;check for key
	int	16h
	jz	asm_kbd_check@1		;exit if no key
	xor	ah,ah			;get & remove key
	int	16h
	or	al,al
	jz	asm_kbd_check@2		;return plainkey
	and	eax,0ffh
	ret
asm_kbd_check@2:
	cmp	ah,0e0h			;return extended AT keys as $2xx
	je	asm_kbd_check@3
	mov	al,ah
	mov	ah,1			;normal specials are $1xx
	and	eax,0ffffh
	ret
asm_kbd_check@3:
	mov	ah,1			;this is probably not needed, since not calling xtended function
	int	16h
	mov	al,ah
	mov	ah,2
	and	eax,0ffffh
	ret
asm_kbd_check@1:
	mov	eax,-1
	ret

;*********************************************************
;
;	void	init_timer2_counter(void);
;
;	Initializes PIC timer 2 to count down with a full cycle
;	of 64K.  Also shuts off the speaker output.

	public	init_timer2_counter_

init_timer2_counter_:
	push	eax

	;shut off speaker
	in	al,61h
	and	al,0fdh
	or	al,1
	out	61h,al

	;timer 2, int mode, full cycle
	mov	al,0b0h
	out	43h,al

	xor	al,al
	out	42h,al
	out	42h,al

	pop	eax
	ret

;*********************************************************
;
;	void	VESA_Display_Window_16(void);
;
;	VESA functions for video BIOSes that do not support VESA VBE 2.0
;	32-bit protected mode functions.
;

	public	VESA_Display_Window_16_

VESA_Display_Window_16_:
	mov	ax,4f05h
	xor	bh,bh
	int	10h
	ret

;	void	byte_histogram(uchar *mem [EAX], ulong len [EDX], ulong *hmem [EBX]);
;
;	Take a histogram of a block of data.

	public	byte_histogram_
byte_histogram_:
	push	ecx
	xor	ecx,ecx
	add	edx,eax
byte_histogram@1:
	mov	cl,[eax]
	inc	dword ptr [ebx+ecx*4]
	inc	eax
	cmp	eax,edx
	jb	byte_histogram@1
	pop	ecx
	ret

_TEXT	ENDS

	END
