#ifndef	VGAPAINT_AVERAGE_H
#define	VGAPAINT_AVERAGE_H

#if 0
#define	_MARK_ON
#include <wsample.h>
#endif

#include <a/types.h>
#include "list.h"
#include "video.h"
#include "vgapaint.h"

#ifdef VGAPAINT_AVERAGE_C
#define	EXTERN
#define	INIT(x)	=x
#else
#define	EXTERN	extern
#define	INIT(x)
#endif

#define NULL 0

typedef	void	(SepFunc)(uchar *);

struct Octree {
	struct Node levlst;
	struct Octree *Parent;
	struct Octree *Next[8];
	ulong pixcnt;
	ulong rsum,gsum,bsum;
	uchar level;
	uchar creg;
	boolean leaf;
	uchar	leafcnt;
};

EXTERN uchar *sepred INIT(NULL); 		/* red separation pointer */
EXTERN uchar *sepgrn INIT(NULL); 		/* green separation pointer */
EXTERN uchar *sepblu INIT(NULL); 		/* blue separation pointer */
EXTERN struct Octree OctRoot;			/* Octree root */
EXTERN ushort leafcnt;
EXTERN uchar curcreg;
EXTERN struct List OctList[8];			/* depth list */
EXTERN ushort OctDepthCnt[8];			/* depth node count list */

boolean	Separate(SepFunc *proc);
void	Separate_Remap2(uchar *r,uchar *g,uchar *b,boolean interactive);
void	Separate_Remap3(uchar *r,uchar *g,uchar *b,boolean interactive);
void	Separate_Free(void);
void	sumrow(uchar *dt,ushort *sm);
void	AvRGBFunc(uchar *);
void	AvRGBFunc5(uchar *);
void	AverageRGB(boolean);
void	medianrow(uchar *dt,uchar *sum,ulong lsize);
void	MedianFunc(uchar *);
void	MedianRGB(void);

void	InvertRGB(void);
void	SortPictureColors(boolean reverse);
void	PCXOptimizeColors(void);
void	DeltaH(void);
void	UnDeltaH(void);
void	DeltaV(void);
void	UnDeltaV(void);

boolean	ObtainPalette(void);
boolean ObtainPalette2(uchar *r,uchar *g,uchar *b,boolean interactive,ushort maxcol);
boolean ObtainPalette3(uchar *r,uchar *g,uchar *b,boolean interactive,boolean addpal,int maxcol,int placement);

void	ObtainGreyPalette(const uchar *d,long xs,long ys,long bpr,uchar *lvls,int maxlevels,uchar *invpal);

void	OctreeInit(void);
struct Octree *InitOctree(short level);
boolean	InsertColor(struct Octree *oct,uchar r,uchar g,uchar b,uchar depth);
void	ReduceOctree(int maxcol);
void	FreeOctree(void);
void	FreeOctree2(struct Octree *oct);
void	AssignOctree(int placement);
void	AssignOctree2(struct Octree *oct,int placement);
uchar	SearchOctree(uchar r,uchar g,uchar b);
uchar	SearchOctree2(struct Octree *oct,uchar r,uchar g,uchar b);

uchar medianswap(uchar,uchar,uchar,uchar,uchar,uchar,uchar,uchar,uchar*);
#pragma aux medianswap= \
	"cmp  al,bh",	\
	"jae  l0",	\
	"xchg al,bh",	\
	"l0:",		\
	"cmp  ah,cl",	\
	"jae  l1",	\
	"xchg ah,cl",	\
	"l1:",		\
	"cmp  bl,ch",	\
	"jae  l2",	\
	"xchg bl,ch",	\
	"l2:",		\
	"cmp  al,ah",	\
	"jae  l3",	\
	"xchg al,ah",	\
	"l3:",		\
	"cmp  al,bl",	\
	"jae  l4",	\
	"xchg al,bl",	\
	"l4:",		\
	"cmp  cl,ch",	\
	"jae  l5",	\
	"xchg cl,ch",	\
	"l5:",		\
	"cmp  bh,ch",	\
	"jae  l6",	\
	"xchg bh,ch",	\
	"l6:",		\
	"cmp  ah,bl",	\
	"jae  l7",	\
	"xchg ah,bl",	\
	"l7:",		\
	"cmp  bh,cl",	\
	"jae  l8",	\
	"xchg bh,cl",	\
	"l8:",		\
	"cmp  ah,bh",	\
	"jae  l9",	\
	"xchg ah,bh",	\
	"l9:",		\
	"cmp  ah,dl",	\
	"jae  l10",	\
	"xchg ah,dl",	\
	"l10:",		\
	"cmp  cl,dl",	\
	"jae  l11",	\
	"xchg cl,dl",	\
	"l11:",		\
	"cmp  bl,dl",	\
	"jae  l12",	\
	"xchg bl,dl",	\
	"l12:",		\
	"cmp  bl,bh",	\
	"jae  l13",	\
	"xchg bl,bh",	\
	"l13:",		\
	"cmp  cl,dh",	\
	"jae  l14",	\
	"xchg cl,dh",	\
	"l14:",		\
	"cmp  bl,cl",	\
	"jae  l15",	\
	"xchg bl,cl",	\
	"l15:",		\
	"cmp  bh,dh",	\
	"jae  l16",	\
	"xchg bh,dh",	\
	"l16:",		\
	"mov  dl,[esi]",\
	"cmp  cl,dl",	\
	"jae  l17",	\
	"xchg cl,dl",	\
	"l17:",		\
	"cmp  bh,dl",	\
	"jae  l18",	\
	"xchg bh,dl",	\
	"l18:",		\
	"cmp  bh,cl",	\
	"jae  l19",	\
	"xchg bh,cl",	\
	"l19:"		\
	parm [al] [ah] [bl] [bh] [cl] [ch] [dl] [dh] [esi] \
	value [cl]	\
	modify [ax bx cx dx];

#undef	EXTERN
#undef	INIT

#endif


