	.386p
	.model	flat
	.code

;	EAX checksum = checksum1(EAX checksum,EDX memory,EBX seedptr,ECX lwords);
;
;	Checksums an area of memory using random-add-xor algorithm.

	public	checksum1_

;linear feedback shift register - 32-bit mask 0xA3000000
;this code fragment

gen16	macro	seed32,temp32,seed16,temp16
	mov	temp32,seed32
	shl	seed32,2
	xor	temp32,seed32
	shl	seed32,4
	xor	temp32,seed32
	add	seed32,seed32
	xor	temp32,seed32
	shl	seed32,9
	rol	temp32,16
	mov	seed16,temp16
	endm

checksum1_	proc	near
	push	esi
	mov	esi,[ebx]
	push	ebx
$1:
	gen16	esi,ebx,si,bx
	gen16	esi,ebx,si,bx
	mov	ebx,[edx]
	add	edx,4
	add	ebx,esi
	xor	eax,ebx
	rol	eax,1
	dec	ecx
	jnz	$1

	pop	ebx
	mov	[ebx],esi
	pop	esi

	ret

checksum1_	endp

;	EAX checksum = checksum2(EAX checksum,EDX memory,EBX lwords);
;
;	Checksums an area of memory (method 2).
;
;	There is no real mathematical basis for this function that makes it less crackable, but I
;	think using primes lessens the chance that patterns will develop...

	public	checksum2_

checksum2_	proc	near
	add	eax,926f8c45h		; a prime
	rol	eax,11
	ror	al,3
	rol	eax,5
	xor	eax,17a8b2e3h		;another prime
	ror	eax,15
	rol	al,6
	ror	eax,9
	add	eax,[edx]
	add	edx,4
	dec	ebx
	jne	checksum2_
	ret
checksum2_	endp


;	EAX finish_key = endecode1(EAX start_key,EDX memory,EBX seedptr,ECX lwords);
;
;	Encodes/decodes an area of memory using random-add-xor algorithm.
;
;	I have no doubt that some of you crackerjack codebreakers will find some way to
;	break this encryption easily.  I just hope you don't lose too much sleep
;	doing it!

	public	endecode1_

endecode1_	proc	near
	push	esi
	mov	esi,[ebx]
	push	ebx
$1:
	gen16	esi,ebx,si,bx
	gen16	esi,ebx,si,bx
	mov	ebx,[edx]
	add	edx,4
	add	ebx,esi
	xor	eax,ebx
	mov	[edx-4],eax
	rol	eax,1
	dec	ecx
	jnz	$1

	pop	ebx
	mov	[ebx],esi
	pop	esi

	ret
endecode1_	endp

	end

