#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>

#include <a/types.h>

#include "toolicon.h"
#include "font.h"

// Easter Eggs!
//
// If you want to find some of these yourself, don't look in here!
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

//	DisplayAlert() function.
//
//	Amiga KS2.0+ users should recognize this one.
//
//	I had to crash a real Amiga to remember how it looked.  Didn't realize how *******
//	hard it is to get the recoverable alert!  Had to do a little POKEing with AMOSPro...

static void dea_renderfont(uchar *pt,uchar *s) {
	uchar c;
	uchar *dm,*vm;
	int i;

	while(c=*s++) {
		dm = sys8x8->data + (uchar)c;
		vm = pt++;

		for(i=0;i<8;i++) {
			vm[0] = *dm;
			vm[80] = *dm;
			dm+=256;
			vm+=160;
		}
	}
}

void	DisplayEasterAlert(void) {
	union REGS regs;
	uchar *vm = (uchar *)0xa0000;
	uchar *dm;
	int i;
	ulong	time,ntime;
	boolean phase=FALSE;

	if (!sys8x8) return;

	regs.x.eax = 0x00000012;
	int386(0x10,&regs,&regs);

	vid_setpreg(1,1);
	vid_setpreg(2,2);
	vid_setRGB6(1,255,167,0);
	vid_setRGB6(2,255,167,0);

	outp(0x3c4,2); outp(0x3c5,1);

	for(i=0;i<84*80;i+=80)	{	vm[i]=0xfc;	vm[i+79]=0x3f;	}
	for(i=0;i<8*80;i++)		vm[i]=0xff;
	for(i=76*80;i<84*80;i++)	vm[i]=0xff;

	outp(0x3c4,2); outp(0x3c5,2);

	dea_renderfont(vm + 80*2*10 + 4,"Recoverable Alert.");
	dea_renderfont(vm + 80*2*10 + 31,"Press left mouse button to continue.");
	dea_renderfont(vm + 80*2*26 + 18,"Error:  0000 000C   Task:  004B6B20");

	ntime=*(ulong *)0x46c;

	while(!mouse_buttons_direct()) {
		kbhit();
		time = *(ulong *)0x46c;
		if (((slong)(ntime-time))>0) continue;
		ntime+=9;
		if (phase=!phase)
			vid_setRGB6(1,255,167,0);
		else
			vid_setRGB6(1,0,0,0);
	}
}


extern	ulong __checksum[3];


void	DecodeEasterPicture(ulong seed) {
#if 1
	Message("Sorry, picture removed - but Pallas Athena is watching.");
#else
	FILE *handle;
	uchar *buf;
	ulong	key;
	ulong	usize;

	// first, some versions of VP386 don't have easter pictures
	// the easter picture is at the end of the LE

	if (!(handle = VPfopen(program_name,"rb"))) return;

	if (-1==fseek(handle,__checksum[2],SEEK_SET)) goto rderr;	// seek to program end

	// check the next longword -- it should be 0xA540E4EA

	if (1!=fread(&key,4,1,handle)) goto rderr;
	if (key!=0xA540E4EA) goto rderr;	//ack!

	// find out uncompressed size
	if (1!=fread(&usize,4,1,handle)) goto rderr;

	if (!(buf=malloc(usize+4078))) goto rderr;

	// load in the easter egg

	if (1!=fread(&key,4,1,handle)) goto abort1;
	if (1!=fread(buf+usize+4078-key,key,1,handle)) goto abort1;

	// attempt to decrypt the easter egg

//	if (endecode1(0x5A4E4EA8,buf+usize+4078-key,&seed,key>>2)) goto abort1;

	// LZ decompress the easter egg

	LZDecompMem(buf,buf+usize+4078-key);

	// change picture size to 644,933

//	if (!resize_picture(644,943,0)) goto abort1;
	if (!resize_picture(644,933,0)) goto abort1;

	// decompress the easter egg picture

	{
		ulong	*bitmem;
		uchar	*rlemem;
		uchar	*vm = picmem;
		ulong	codes;
		ulong	mask=0x80000000,bits;
		uchar	c;
		int	t;

		bitmem	= (ulong *)(buf+4078+*(ulong *)(buf+4078));
		rlemem	= buf+4078+*(ulong *)(buf+4078+4);
		codes	= *(ulong *)(buf+4078+8);
		bits	= *bitmem++;

		do {
			c=(bits & mask)?15:0;
			for(t=1+*rlemem++;t;t--)	*vm++ = c;
			if (!(mask>>=1)) {
				mask = 0x80000000;
				bits = *bitmem++;
			}
		} while(--codes);
	}

	restore_screen();

	free(buf);
	fclose(handle);

	// construct message box

	{
		int x1,y1,xs,ys;

		xs = sysfontwidth*42 + 4*vdrv_cur->x_aspect;
		ys = sysfontheight*5 + 4*vdrv_cur->y_aspect;
		x1 = vidbm.x1 + ((vidbm.width - xs)>>1);
		y1 = vidbm.y1 + ((vidbm.height - ys)>>1);

		mouse_hide();
		vd->bar(&vidbm,x1,y1,xs,ys,St2);
		vid_draw3d(&vidbm,x1,y1,x1+xs-1,y1+ys-1);

		x1 += 2*vdrv_cur->x_aspect;
		y1 += 2*vdrv_cur->y_aspect;

		SysText(&vidbm,x1,y1+0*sysfontheight,"Athena smiled and her bright eyes flashed,",St0,St2);
		SysText(&vidbm,x1,y1+1*sysfontheight,"and she stroked him  with  her  hand.  Now",St0,St2);
		SysText(&vidbm,x1,y1+2*sysfontheight,"she looked like a tall and majestic woman,",St0,St2);
		SysText(&vidbm,x1,y1+3*sysfontheight,"clever and intelligent, and she  spoke  to",St0,St2);
		SysText(&vidbm,x1,y1+4*sysfontheight,"the point...  --Homer's Odyssey, book XIII",St0,St2);
		mouse_show();

		vd->refresh();	// arg!!!

		while(-1==kbd_check() && !mouse_buttons()) { kbhit(); DPMI_Yield(); }

	}
	restore_screen();

	return;

abort1:
	free(buf);
rderr:
	fclose(handle);

	Message("Error reading easter egg.");
#endif
}

