#define	EXTENSION

#include <stdio.h>

#include <a/types.h>
#include <a/mem.h>
#include "loadlib.h"
#include "toolicon.h"
#include "video.h"
#include "menu.h"
#include "extdata.h"
#include "io.h"
#include "file.h"
#include "listbox.h"
#include "request.h"
#include "mouse.h"
#include "vpalias.h"
#include "font.h"

/////////////////////////////////

long	MPickCall(void *data,va_list val);

/////////////////////////////////

static int	ext_menu_address1;
static int	ext_menu_address2;
static int	ext_menu_address3;

/////////////////////////////////

static struct Menu fontmenu[]={
	{ MN_SOLO,NULL,"Make Font Grid",NULL,NULL },
};

static struct Menu our_extmenu={
	MN_SOLO,fontmenu,"Font Editor",NULL,NULL
};

static struct Menu loadopt={
	MN_SOLO,NULL,".VFN Font",NULL,NULL
};

static struct Menu saveopt={
	MN_SOLO,NULL,".VFN Font",NULL,NULL
};

struct Call mpickcall={
	{NULL},&MPickCall,NULL
};

/////////////////////////////////

long main(struct Extension *ext,enum ExtCommand comm,long xval,long yval) {
	struct Menu *menu;
	struct CallList *mpicklist;

	switch(comm) {
	case	EC_STARTUP:
		return (long)&main;

	case	EC_STARTUP1:
		ext->name = ".VFN font editor";

		// add our menu options

		if (!(menu = menu_item_address(_barmenu+1,5,0,-1))) return TRUE;
		ext_menu_address1 = menu_add_to_end(menu,&our_extmenu);

		if (!(menu = menu_item_address(_barmenu+1,0,1,0,-1))) return TRUE;
		ext_menu_address2 = menu_add_to_end(menu,&loadopt);

		if (!(menu = menu_item_address(_barmenu+1,0,3,0,-1))) return TRUE;
		ext_menu_address3 = menu_add_to_end(menu,&saveopt);

		// add to call list

		if (!(mpicklist = FindCallList('MPck'))) return NULL;		// pmud!

		AddCall(mpicklist,&mpickcall);

		return FALSE;

	case	EC_CLEANUP:

		return 0;

	default:
		return -1;	// whatever it was, we didn't do it
	};
}

//////////////////////////////

static struct Text SSR_Texts[]={
	{ "Width"			,  4, 16,St0,St2 },
	{ "Height"			,  4, 27,St0,St2 },
	{ "Baseline"			,  4, 38,St0,St2 },
	{ NULL }
};

static struct Rectangle SSR_Neg[]={
	{  98, 14, 51, 11 },
	{  98, 25, 51, 11 },
	{  98, 36, 51, 11 },
	{ RECT_END }
};

static struct Zone SSR_Z1[]={
	{   4, 55, 64, 24 ,ZN_3D+ZN_TEXTRENDER,NULL,"Ok" },
	{ 123, 55, 64, 24 ,ZN_3D+ZN_TEXTRENDER,NULL,"Cancel" },
	{  -1, -1, -1, -1 }
};

static struct ZoneRange SSR_ZR[]={
	{	NULL	,SSR_Z1	,NULL	,-1	,ZR_TAP	},
};

static char SSRFBuf1[14];
static char SSRFBuf2[14];
static char SSRFBuf3[14];

static struct Field SSR_FLD[]={
	{ 100, 16, 47,  8, NULL, SSRFBuf1, 0, 0,(sizeof SSRFBuf1)-1,8,St0,St2,FLD_NUMERIC,4,1024 },
	{ 100, 27, 47,  8, NULL, SSRFBuf2, 0, 0,(sizeof SSRFBuf2)-1,8,St0,St2,FLD_NUMERIC,4,1024 },
	{ 100, 38, 47,  8, NULL, SSRFBuf3, 0, 0,(sizeof SSRFBuf3)-1,8,St0,St2,FLD_NUMERIC,0,1024 },
	{ -1 }
};

static struct Requester MakeGridRq={
	0,0,204,85,
	REQ_BORDER,
	"Make Font Grid",
	St2,
	NULL,
	SSR_FLD,
	SSR_ZR,
	NULL,
	NULL,		/* rendering */
	SSR_Neg,
	SSR_Texts
};

uchar tmem[8*8];
struct BitMap textbm;

void	MakeFontGrid(void) {
	mouse_coord x,y,b;
	ulong msg;
	int xit=0;
	int wid,hei,base;
	int i;

	strcpy(SSRFBuf1,"6");
	strcpy(SSRFBuf2,"8");
	strcpy(SSRFBuf3,"6");

	if (!OpenRequester(&MakeGridRq,0,0)) return;
	do {
		mouse_wait_key();
		mouse_read2(&x,&y,&b);
		switch(msg=CheckRequester(&MakeGridRq,x,y,b)) {
		case RZoneMsg(0,0):	/* Ok */
			xit=1;
			break;
		case RZoneMsg(0,1):	/* Cancel */
			xit=2;
			break;
		}
	} while(xit==0);
	mouse_wait_unkey();
	CloseRequester(&MakeGridRq);

	wid = atoi(SSRFBuf1);
	hei = atoi(SSRFBuf2);
	base= atoi(SSRFBuf3);

	vid_initBitMap(&textbm,tmem,0,0,6,8,8,NULL);

	(*_vd)->set(*_picbm,0);

	x=y=0;

	for(i=0;i<256;i++) {
		(*_vd)->box(*_picbm,x,y,x+wid+1,y+hei+1,5);
		(*_vd)->plot(*_picbm,x,y+1+base,2);
		(*_vd)->plot(*_picbm,x+wid+1,y+1+base,2);
		(*_vd)->text6lim(&textbm,0,0,(char*)&i,7,0,1);
		vid13_scale(&textbm,0,0,6,8,*_picbm,x+1,y+1,wid,hei);
		x += wid+1;
		if (x+wid+1 >= (*_picbm)->x2) {
			x=0;
			y += hei+1;
		}
	}
}

void	LoadVFNFont(void) {
}

struct VFNMonoDiskFont {
	ulong	tag;
	ulong	id;
	ulong	width;
	ulong	height;
	ulong	baseline;
	uchar	lowchar;
	uchar	highchar;
	ushort	misschar;
	ushort	totalchar;
};

void	SaveVFNFont(void) {
	int x,y,b,xcells,ycells;
	char *fname;
	FILE *f;
	struct VFNMonoDiskFont vmdf;

	for(x=1;x<(*_picbm)->width;x++)
		if ((*_vd)->point(*_picbm,x,1)==5)
			break;

	--x;

	for(y=1;y<(*_picbm)->height;y++)
		if ((*_vd)->point(*_picbm,1,y)==5)
			break;

	--y;

	for(b=0;b<y;b++) {
		if ((*_vd)->point(*_picbm,0,b+1)==2)
			break;
	}

	xcells = ((*_picbm)->width  - 1)/(x+1);
	ycells = ((*_picbm)->height - 1)/(y+1);

	if (x<4 || y<4 || xcells*ycells<256) {
		Message("Not a VFN grid.");
		return;
	}

	fname = GetFileNameSave("Save VFN file.","vfn");
	if (!fname) return;
	if (!*fname) return;

	if (!(f=fopen(fname,"wb"))) {
		Message("Unable to open file.");
		return;
	}

	vmdf.tag	= 'FFPV';
	vmdf.id		= 0;
	vmdf.width	= x;
	vmdf.height	= y;
	vmdf.baseline	= b;
	vmdf.lowchar	= 0;
	vmdf.highchar	= 255;
	vmdf.misschar	= 0x80;
	vmdf.totalchar	= 0x100;

	if (1!=fwrite(&vmdf,sizeof vmdf,1,f)) goto wrerr;

	// this is really slow, needs work

	{
		int row,xp,yp,xc,yc,xo,i;
		uchar accum,bits=8;

		for(row=0;row<y;row++) {
			xc=yc=0;
			for(i=0;i<256;i++) {
				xp = 1+xc*(x+1);
				yp = 1+yc*(y+1);

				for(xo=0;xo<x;xo++) {
					if ((*_vd)->point(*_picbm,xp+xo,yp+row) == 7) accum|=1;
					if (!--bits) {
						putc(accum,f);
						bits=8;
						accum=0;
					} else {
						accum<<=1;
					}
				}

				if (++xc>=xcells) {
					xc=0;
					++yc;
				}
			}
			if (bits<8) putc(accum<<(8-bits),f);
		}
	}

	fclose(f);
	return;
wrerr:
	Message("Write error.");
	fclose(f);
}

long	MPickCall(void *data,va_list val) {
	//choice = va_arg(val,int *);
//	choice = *_choice;

	switch(_choice[0]) {
	case 0:
		switch(_choice[1]) {
		case 1:	if (_choice[2]==ext_menu_address2) {
				LoadVFNFont();
			}
			break;
		case 3:	if (_choice[2]==ext_menu_address3) {
				SaveVFNFont();
			}
			break;
		}
		break;
	case 5:
		if (_choice[1]==ext_menu_address1) {
			if (_choice[2]==0)
				MakeFontGrid();
			
			return 1;
		}
		break;
	};
	return 0;
}
