#ifndef VGAPAINT_HELP_H
#define VGAPAINT_HELP_H

#include <stdio.h>

#include <a/types.h>

struct HelpFileHandle {
	FILE *f;
	ulong	hash_table[256];
};

struct HelpLine {
	char *s;
	ulong l;
};

struct HelpLineChain {
	struct HelpLineChain *next;
	ulong	line_cnt;
	struct HelpLine lines[256];
};

struct HelpTopic {
	uchar	*topic_mem;
	struct	HelpLineChain *hlc;
	ulong	total_lines;
};

struct HelpFileHandle *OpenHelpFile(char *name);
void	CloseHelpFile(struct HelpFileHandle *);
uchar	HashHelpTopicName(char *s);
char *	DistillHelpTopicName(char *dest,char *src);
ulong	FindHelpTopic(struct HelpFileHandle *hfh,char *topic,ulong *len_ptr);
struct HelpTopic *LoadHelpTopic(struct HelpFileHandle *hfh,ulong pos,ulong len,ulong wrap);
int	DisplayHelpTopic(struct HelpFileHandle *,char *topic);

#endif

