#ifndef	VGAPAINT_IO_H
#define	VGAPAINT_IO_H

#include <stdio.h>
#include <stdarg.h>

#include <a/types.h>

#include "list.h"

#ifdef	VGAPAINT_IO_C
#define	EXTERN
#define	INIT(x)		=x
#else
#define	EXTERN		extern
#define	INIT(x)
#endif

typedef	void	(*VPpassup_fptr)(void);

//EXTERN void (__interrupt __far *prev_int_12)(void);
extern void (__interrupt __far *prev_int_12)(void);

EXTERN	struct List	GlobCallList;


struct DPMIMemInfo {
    unsigned LargestBlockAvail;
    unsigned MaxUnlockedPage;
    unsigned LargestLockablePage;
    unsigned LinAddrSpace;
    unsigned NumFreePagesAvail;
    unsigned NumPhysicalPagesFree;
    unsigned TotalPhysicalPages;
    unsigned FreeLinAddrSpace;
    unsigned SizeOfPageFile;
    unsigned Reserved[3];
};

// VPfindfirst defines

#define VPFFA_HIDDEN		(0x02)
#define	VPFFA_SYSTEM		(0x04)
#define	VPFFA_VOLUME_LABELS	(0x08)
#define	VPFFA_DIRECTORIES	(0x10)

#define	VPFFA_TEMP		(0x00000100L)

struct VPFileFind {
	union {
		struct {

// the padding pushes this structure near the end
// of the <lfname> field of the LongFileName search
// structure

			uchar	__padding[128];
			uchar	_reserved[21];
			uchar	attrib;
			ushort	time;
			ushort	date;
			ulong	size;
			uchar	name[13];
		} std;
		struct {
			ulong	attrib;
			uquad	time_create;
			uquad	time_access;
			uquad	time_modify;
			ulong	fsize_high;
			ulong	fsize_low;
			uchar	_reserved[8];
			uchar	lfname[260];
			uchar	sfname[14];
		} lfn;
	};
};

struct VPAssign {
	struct VPAssign *next,*prev;
	char *name,*path;
};


struct RealIntByte {
	uchar	__00,__01,__02,__03;
	uchar	__10,__11,__12,__13;
	uchar	__20,__21,__22,__23;
	uchar	__30,__31,__32,__33;
	uchar	bl,bh,__42,__43;
	uchar	dl,dh,__52,__53;
	uchar	cl,ch,__62,__63;
	uchar	al,ah,__72,__73;
};

struct RealIntWord {
	ushort	di,__0;
	ushort	si,__1;
	ushort	bp,__2;
	ushort	__3l,__3h;
	ushort	bx,__4;
	ushort	dx,__5;
	ushort	cx,__6;
	ushort	ax,__7;
};

struct RealIntLong {
	ulong edi,esi,ebp,__0,ebx,edx,ecx,eax;
};

struct RealInt {
	union {
		struct RealIntLong x;
		struct RealIntWord w;
		struct RealIntByte b;
	};
	ushort eflags;
	ushort es,ds,fs,gs;
	ushort ip,cs;
	ushort sp,ss;
};

// WARNING: struct RealModeCallback is also defined in <asmfunc.asm>

struct	RealModeCallback {
	ulong	RMkey;		// key to call routine with in DOS/4GW
	ushort	off,seg;	// real mode address to call
	uchar	DPMI_buf[32];	// 32 byte buffer for DPMI callbacks
};

// WARNING: struct CallList is also defined in <asmfunc.asm>

struct	CallList {
	struct Node node;
	struct List list;
	ulong	id;
};

// WARNING: struct Call is also defined in <asmfunc.asm>

typedef	long	(*CallFunc)(void *,va_list val);

struct	Call {
	struct	Node	node;		// node
	long	(*func)(void *,va_list val);		// function to call
	void	*data;			// data to pass
};

// WARNING: struct IHandler is also defined in <asmfunc.asm>

struct	IHandler {
	struct	Call	call;		// how to call this handler
	struct	RealModeCallback rmc;	// -not currently used-  real mode callback for high ints
	long		counter;	// counter used if you are a timer
	long		time;		// period to call you at if you are a timer
};

typedef	long	(*IntFuncPtr)(void);

enum {
	INT_TIMER	=0,		// IRQ0: Timer channel 0
	INT_KEYBOARD	=1,		// IRQ1: Keyboard
	INT_CASCADE	=2,		// IRQ2: Cascade interrupt
	INT_COM2	=3,		// IRQ3: COM2/COM4
	INT_COM4	=3,
	INT_COM1	=4,		// IRQ4: COM1/COM3
	INT_COM3	=4,
	INT_LPT2	=5,		// IRQ5: LPT2
	INT_FLOPPY	=6,		// IRQ6: Floppy
	INT_LPT1	=7,		// IRQ7: LPT1
	INT_CLOCK	=8,		// IRQ8: Clock
	INT_VBLANK	=9,		// IRQ9: VBL - doesn't exist on many VGA cards
	INT_MATHCO	=13,		// IRQ13: Coprocessor error
	INT_HD		=14,		// IRQ14: Hard drive event
	INT_DOSOK	=15,		// Int28h, or DOSOK
};

EXTERN	long	Int08TimerPeriod	INIT(0x10000);
EXTERN	long	Int08TimerCounter	INIT(0);
EXTERN	ulong	*IntStackPtrs[17];
EXTERN	ulong	*IntStacks[17];
EXTERN	ushort	IntOldStackSegments[17];

// 8253 defines

enum {
	TIMER_COUNTER0	= 0x00,
	TIMER_COUNTER1	= 0x40,
	TIMER_COUNTER2	= 0x80,
	TIMER_LATCH	= 0x00,
	TIMER_MSBONLY	= 0x20,
	TIMER_LSBONLY	= 0x10,
	TIMER_LSBMSB	= 0x30,
	TIMER_INTERRUPT	= 0x00,
	TIMER_ONESHOT	= 0x02,
	TIMER_RATEGEN	= 0x04,
	TIMER_SQWAVE	= 0x06,
	TIMER_SOFTSTRB	= 0x08,
	TIMER_HARDSTRB	= 0x0A,
	TIMER_BINARY	= 0x00,
	TIMER_BCD	= 0x01,
	TIMER_0		= 0x40,
	TIMER_1		= 0x41,
	TIMER_2		= 0x42,
	TIMER_CTRL	= 0x43,
};

ushort DetectMWindows(void);

int	kbd_check(void);
uchar	kbd_shift(void);
ulong	read_tick(void);

void *	DosMemoryAllocate(ushort,ushort *);
void	DosMemoryFree(ushort);

void	DPMIRealInt(uchar i,struct RealInt *ri);

boolean	Detect_True_DPMI(void);
ulong	DPMI_AllocCBack(void (*PMProc)(void),void *buf32);
void	DPMI_FreeCBack(ulong CBack);
void	DPMI_Yield(void);
ulong	DPMI_MemFree(void);
void *DPMIPhysMapAttempt(ulong addr,ulong len);
ushort	DPMIAllocateSelector(void);
void	DPMIFreeSelector(ushort);
void	DPMISetSelector(ushort,ulong,ulong,ushort);

boolean		VPAssign(char *name,char *path);
void		VPAssignDestroy(char *name);
struct VPAssign *VPAssignFind(char *name);
char *		VPAssignResolve(char *outbuffer,char *name);
struct VPAssign *VPAssignEnum(struct VPAssign *vpa);
int		VPAssignCount(void);

void	VP_Set_Start_Path(char *argv0);
FILE *	VPfopen(char *name,char *usage);
ulong	VPfindfirst(char *spec,uchar attrib,struct VPFileFind *vpff);
int	VPfindnext(ulong handle,struct VPFileFind *vpff);
void	VPfindclose(ulong handle);
int	VPsopen(const char *path,int access,int share,...);
int	VPfilesize(FILE *f);

boolean	InitCallbackSystem(void);
void	DeinitCallbackSystem(void);

ushort	AllocCallback(VPpassup_fptr vpf,boolean interrpt);
void	FreeCallback(ushort callback);

struct CallList *FindCallList(ulong id);
void		 AddCallList(struct CallList *cl,ulong id);
void		 RemCallList(struct CallList *cl);
void		 AddCall(struct CallList *cl,struct Call *c);
void		 RemCall(struct Call *c);
long		 ExecuteCallList(struct CallList *cl, ...);
boolean		 InitInterruptHandler(void);
void		 DeinitInterruptHandler(void);
void		 AddInterruptHandler(uchar intnum,struct IHandler *ih);
void		 RemInterruptHandler(uchar intnum,struct IHandler *ih);
void		 LockInterruptHandler(uchar intnum);
void		 UnlockInterruptHandler(uchar intnum);
void		 InstallInterruptHandler(uchar intnum);
void		 DeinstallInterruptHandler(uchar intnum);
void		 DeinstallAllInterruptHandlers(void);

void		 SetTimerPeriod(ushort period);
void		 _InternalSetTimerPeriod(ushort period);

#undef EXTERN
#undef INIT

#endif
