#ifndef	VGAPAINT_MOUSE_H
#define	VGAPAINT_MOUSE_H

#include <a/types.h>

#ifdef	VGAPAINT_MOUSE
#define	EXTERN
#define	INIT(x)	=x
#else
#define	EXTERN	extern
#define	INIT(x)
#endif

#define chop(a,b,c) ((c)<(a) ? (a) : ( (c)>(b) ? (b) : (c) ))

typedef	long		mouse_coord;

struct	Rectangle2 {
	mouse_coord	x1;
	mouse_coord	y1;
	mouse_coord	x2;
	mouse_coord	y2;
};

typedef	struct Rectangle2	MouseBound;

void	mouse_bounds_reset(void);
int	mouse_init(void);
void	mouse_show(void);
void	mouse_hide(void);
void	mouse_setpointer(uchar *cdata,mouse_coord xh,mouse_coord yh,color h,color l);
boolean	mouse_setpointer2(uchar *cursdata,mouse_coord xhot,mouse_coord yhot,mouse_coord width,mouse_coord height,color high,color low);
int	mouse_buttons_direct(void);
int	mouse_buttons(void);
void	mouse_read(mouse_coord *xptr,mouse_coord *yptr,mouse_coord *button);
void	mouse_read2(mouse_coord *xptr,mouse_coord *yptr,mouse_coord *button);
void	mouse_readmove(mouse_coord *xptr,mouse_coord *yptr,mouse_coord *button);
void	mouse_wait_key(void);
void	mouse_wait_unkey(void);
void	mouse_setlimits(mouse_coord x1,mouse_coord y1,mouse_coord x2,mouse_coord y2);
void	mouse_readlimits(MouseBound *mbs);
void	mouse_writelimits(MouseBound *mbs);
void	mouse_suspend(void);
void	mouse_resume(void);
void	mouse_move(mouse_coord x,mouse_coord y);
void	mouse_set_split(mouse_coord y1,mouse_coord y2);


void	mouse_ptrinit(void);
void	mouse_ptrdispose(void);
void	mouse_pointerfunc(ushort cmask,ushort bstate,short choriz,short cvert,short hcnts,short vcnts);
#pragma aux mouse_pointerfunc parm [EAX] [EBX] [ECX] [EDX] [EDI] [ESI];
void	mouse_erase_ptr(void);
void	mouse_draw_ptr(mouse_coord,mouse_coord);

EXTERN uchar	ms_hideflag	INIT(0);	/* hide counter */
EXTERN boolean	ms_ptrinst	INIT(FALSE);	/* pointer installed flag */
EXTERN long	ms_bias		INIT(256);	// bias to get around some mouse drivers
EXTERN long	ms_pan		INIT(64);

EXTERN struct	MousePointerInfo {
	uchar	*image;		// pointer image
	uchar	*vdp;		// pointer to video memory
	uchar	*backup;	// image backup memory
	uchar	*blitmem;
	long	s_width;	// sprite width
	long	s_height;	// sprite height
	ulong	width;		// width of saved image
	ulong	height;		// height of saved image
	coord	saved_x,saved_y;// saved positions (for some video drivers)
	coord	cur_x,cur_y;	// mouse position, unadjusted for hot-spot
	boolean	drawn;		// has image been drawn?
	boolean	changed;	// has image changed?
	uchar	high,low;	// high and low colors
	coord	last_x,last_y;	// parms last time vd->drawptr called
	coord	hot_x,hot_y;	// position of hot-spot
	coord	split_1,split_2;// split positions (1: pos of split, 2:height of split sec)
	coord	scr_x,scr_y;	// bitmap positions
	uchar	dynamic_image;
	boolean	detect_window;	// check for running in a Win95 window
	boolean	in_window;	// are we currently in a window
	boolean	winstate_chgd;	// the window state has changed
	boolean	pad[1];
} ms_mpi
#ifdef	VGAPAINT_MOUSE
	={ NULL,NULL,NULL,NULL,0,0,0,0,0,0,FALSE,FALSE,7,0 }
#endif
;

EXTERN struct	MouseStateInfo {
	volatile long	pos_x;		// x mouse position
	volatile long	pos_y;		// y mouse position
	volatile long	scr_x;		// x mouse position (screen)
	volatile long	scr_y;		// y mouse position (screen)
	volatile uchar	buttons;	// button state
	uchar	pad[3];
} ms_msi;

EXTERN ulong	ms_oldmask;			/* save area for old mouse routine */
EXTERN ulong	ms_oldseg;
EXTERN ulong	ms_oldoff;

EXTERN ulong	ms_cback;
EXTERN uchar	ms_cbackbuf[0x32];

EXTERN struct	Rectangle2	ms_savelimits;	/* save area for limits */

EXTERN long	ms_xscroll	INIT(0);	/* x scroll */
EXTERN long	ms_yscroll	INIT(0);	/* y scroll */

EXTERN volatile	mouse_coord	ms_oldx,ms_oldy;	/* old positions */
EXTERN volatile	boolean		ms_moved	INIT(FALSE);	/* moved flag */

boolean	mouse_readmoveflag(void);
#pragma aux mouse_readmoveflag=	\
	"xor al,al",		\
	"xchg ms_moved,al"	\
	modify exact [al]	\
	value [al];

#undef	INIT
#undef	EXTERN

#endif

