#include "vgapaint.h"

#define C0	0
#define	C1	8
#define	C2	7
#define	C3	15
#define A0      74

uchar	palette_save[25],
	palette_knob[]={
	C0,C3,C3,C3,C0,
	C3,C2,C2,C2,C1,
	C3,C2,C0,C2,C1,
	C3,C2,C2,C2,C1,
	C0,C1,C1,C1,C0,
};

uchar   palette_brightsave[42],
	palette_brightknob[42]={
		C0,C0,C1,C3,C1,C0,C0,
		C0,C0,C1,C3,C1,C0,C0,
		C0,C1,C2,C3,C2,C1,C0,
		C0,C1,C2,C3,C2,C1,C0,
		C1,C2,C3,C3,C3,C2,C1,
		C1,C2,C3,C3,C3,C2,C1,
};

uchar	palette_transsave[256],
	palette_transcurs[256]={
	C3,C3,C3,C0,C0,C0,C0,C0,C0,C0,C0,C0,C0,C0,C0,C0,
	C3,C0,C0,C0,C0,C0,C0,C0,C0,C0,C0,C0,C0,C0,C0,C0,
	C3,C0,C2,C2,C2,C2,C2,C2,C2,C2,C2,C2,C2,C2,C2,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,A0,C2,
	C0,C0,C2,C2,C2,C2,C2,C2,C2,C2,C2,C2,C2,C2,C2,C2,
};

struct Sprite p_knob_sprite={
	NULL,NULL,
	{ (uchar *)palette_knob },
	{ (uchar *)palette_save },
	NULL,
	0,0,5,5,0,0,
	NULL,
	0,0,
};

struct Sprite p_bknob_sprite={
	NULL,NULL,
	{ (uchar *)palette_brightknob },
	{ (uchar *)palette_brightsave },
	NULL,
	0,0,7,6,0,0,
	NULL,
	0,0,
};

struct Sprite p_trans_sprite={
	NULL,NULL,
	{ (uchar *)palette_transcurs },
	{ (uchar *)palette_transsave },
	NULL,
	0,0,16,16,0,0,
	NULL,
	0,0,
};

struct Rectangle palette_rects[]={
	240,  2, 20, 20,	/* current color box */
	190,118,128, 80,	/* palette box */
	186, 28, 19,  9,	/* up red */
	204, 28, 19,  9,	/* up grn */
	222, 28, 19,  9,	/* up blu */
	246, 28, 19,  9,	/* up hue */
	264, 28, 19,  9,	/* up sat */
	282, 28, 19,  9,	/* up val */
	186, 46, 19,  9,	/* down red */
	204, 46, 19,  9,	/* down grn */
	222, 46, 19,  9,	/* down blu */
	246, 46, 19,  9,	/* down hue */
	264, 46, 19,  9,	/* down sat */
	282, 46, 19,  9,	/* down val */
	RECT_END,NULL,NULL,NULL,
};

ushort packed_uparrow[]={
	0x0800,0x1C00,0x3E00,0x7F00,0xFF80
};

ushort packed_downarrow[]={
	0xFF80,0x7F00,0x3E00,0x1C00,0x0800
};
