#include "inifile.h"

enum {
	PRINT_INIDEN_NAME=0,
	PRINT_INIDEN_RESWIDTH,
	PRINT_INIDEN_RESHEIGHT,
	PRINT_INIDEN_TOTALWIDTH,
	PRINT_INIDEN_TOTALHEIGHT,
	PRINT_INIDEN_PINCOUNT,
	PRINT_INIDEN_ROWSTART,
	PRINT_INIDEN_LINESTART,
	PRINT_INIDEN_LINEEND,
	PRINT_INIDEN_PRINTSTART,
	PRINT_INIDEN_PRINTEND
};

static struct IniItem print_ini_density[8][12]={
	{	{ "Name"		,NULL,0,   64,INI_DSTRING,0,"" },
		{ "ResWidth"		,NULL,0,16384,INI_SLONG,80,0 },
		{ "ResHeight"		,NULL,0,16384,INI_SLONG,72,0 },
		{ "TotalWidth"		,NULL,0,16384,INI_SLONG,640,0 },
		{ "TotalHeight"		,NULL,0,16384,INI_SLONG,0,0 },
		{ "PinCount"		,NULL,0,   64,INI_SLONG,0,0 },
		{ "RowStart"		,NULL,0,0,INI_DSTRLIT,0,0 },
		{ "LineStart"		,NULL,0,0,INI_DSTRLIT,0,"" },
		{ "LineEnd"		,NULL,0,0,INI_DSTRLIT,0,"" },
		{ "PrintStart"		,NULL,0,0,INI_DSTRLIT,0,"" },
		{ "PrintEnd"		,NULL,0,0,INI_DSTRLIT,0,"" },
		{NULL}
	},
};

enum {
	PRINT_INI_INITIALIZE=0,
	PRINT_INI_TERMINATE,
	PRINT_INI_LINESTART,
	PRINT_INI_LINEEND,
	PRINT_INI_MODEL,
	PRINT_INI_REDPASS,
	PRINT_INI_GRNPASS,
	PRINT_INI_BLUPASS,
	PRINT_INI_BLKPASS,
	PRINT_INI_DATAFORMAT,
	PRINT_INI_BLKMUTEX,
};

static struct IniItem print_ini_general[]={
	{ "PrinterInitialize"	,NULL,0,0,INI_DSTRLIT,0,"" },	// printer initialization string
	{ "PrinterTerminate"	,NULL,0,0,INI_DSTRLIT,0,"" },	// printer termination string
	{ "PrinterLineStart"	,NULL,0,0,INI_DSTRLIT,0,"" },	// printer start line string (color: only once)
	{ "PrinterLineEnd"	,NULL,0,0,INI_DSTRLIT,0,"" },	// printer end line string
	{ "PrinterName"		,NULL,0,0,INI_DSTRING,0,"" },	// printer name (not necessary)
	{ "PrinterRedPass"	,NULL,0,0,INI_DSTRLIT,0,"" },	// printer start red (cyan) pass
	{ "PrinterGreenPass"	,NULL,0,0,INI_DSTRLIT,0,"" },	// printer start green (magenta) pass
	{ "PrinterBluePass"	,NULL,0,0,INI_DSTRLIT,0,"" },	// printer start blue (yellow) pass
	{ "PrinterBlackPass"	,NULL,0,0,INI_DSTRLIT,0,"" },	// printer start black pass
	{ "PrinterDataFormat"	,NULL,0,1,INI_SLONG,0,0 },	// printer bitmap data format
	{ "PrinterBlackMutex"	,NULL,0,1,INI_SLONG,0,1 },	// printer black ink is mutually exclusive to other colors
	{NULL}
};

static struct IniGroup print_inigroups[]={
	{ "PrinterGeneral"	,print_ini_general	},
	{ "Density0"		,print_ini_density[0]	},
	{ "Density1"		,print_ini_density[1]	},
	{ "Density2"		,print_ini_density[2]	},
	{ "Density3"		,print_ini_density[3]	},
	{ "Density4"		,print_ini_density[4]	},
	{ "Density5"		,print_ini_density[5]	},
	{ "Density6"		,print_ini_density[6]	},
	{ "Density7"		,print_ini_density[7]	},
	{NULL}
};

