#include <a/types.h>
#include <a/mem.h>
#include "loadlib.h"
#include "toolicon.h"
#include "video.h"
#include "extdata.h"
#include "io.h"

long	IdleCall(void *data,va_list val);

struct Call idlecall={
	{NULL},&IdleCall,NULL
};


long main(struct Extension *ext,enum ExtCommand comm,long xval,long yval) {
	struct CallList *idlelist;

	switch(comm) {
	case	EC_STARTUP:

		// add our idle driver to the list

		if (!(idlelist = FindCallList('IDLE'))) return NULL;

		AddCall(idlelist,&idlecall);

		return (long)&main;

	case	EC_CLEANUP:

		// remove our idle driver

		RemCall(&idlecall);

		return 0;

	default:
		return -1;	// whatever it was, we didn't do it
	};
}

long	IdleCall(void *data,va_list val) {

	static	ulong		last_tick=0;
		ulong		this_tick;
	static  mouse_coord	omx=-0x8000,omy=-0x8000;
		mouse_coord	mx,my,mb;
	BLOCK	blk;
	coord	x[4],y[4];
	coord	xd[4],yd[4];
	uchar	savepal[33*3];
	uchar	newpal[64*3];
	uchar	c;
	int	i;


	this_tick = *(ulong *)0x46c;

	// read the mouse

	mouse_read2(&mx,&my,&mb);

	if (mx!=omx || my!=omy || mb || VPkbhit() || (kbd_shift()&0x0F)) {
		omx=mx;
		omy=my;
		last_tick=this_tick;
		return 0;
	}

	// okay, nothing has happened

	if (this_tick-last_tick >= 91) {

		// yahoo, blank the screen!

		mouse_hide();

		if (!(blk = (*_vd)->blocksave(_vidbm,0,0,_vidbm->width,_vidbm->height))) {
			last_tick = this_tick;
			return 0;
		}

		vid_saveRGB6(0,savepal,33);
		vid_setRGB6(0,0,0,0);

		{
			uchar *pp=newpal;
			for(i=0;i<32;i++) {
				pp[0]=pp[1]=pp[2]=pp[96]=pp[97]=pp[98]=i*3;
				pp+=3;
			}
		}

		(*_vd)->set(_vidbm,0);


		// come up with stupid coordinates for the lines

		x[0]=76; y[0]=12; x[1]=274; y[1]=182;
		x[2]=237; y[2]=38; x[3]=87; y[3]=171;
		xd[0]=yd[0]=1; xd[1]=yd[1]=-1;
		xd[2]=yd[3]=1; xd[3]=yd[2]=-1;


		for(;;) {
			mouse_read2(&mx,&my,&mb);
			if (mx!=omx || my!=omy || mb || VPkbhit() || (kbd_shift()&0x0F)) {
				omx=mx;
				omy=my;
				last_tick=*(ulong *)0x46c;
				(*_vd)->blockrestore(_vidbm,blk);
				vid_loadRGB6(0,savepal,33);
				mouse_show();
				return 0;
			}
			WaitVBL();
#if 0
			(*_vd)->line(_vidbm,x[0]  ,y[0],x[1]  ,y[1],c+1);
			(*_vd)->line(_vidbm,x[2]  ,y[2],x[3]  ,y[3],c+1);
			(*_vd)->line(_vidbm,x[0]+1,y[0],x[1]-1,y[1],c+1);
			(*_vd)->line(_vidbm,x[2]+1,y[2],x[3]-1,y[3],c+1);
#else
			vid13_line(_vidbm,x[0]  ,y[0],x[1]  ,y[1],c+1);
			vid13_line(_vidbm,x[2]  ,y[2],x[3]  ,y[3],c+1);
			vid13_line(_vidbm,x[0]+1,y[0],x[1]-1,y[1],c+1);
			vid13_line(_vidbm,x[2]+1,y[2],x[3]-1,y[3],c+1);
#endif
			(*_vd)->refresh();
			c=++c&31;
			vid_loadRGB6(1,newpal+3*(c^31),32);

			for(i=0;i<4;i++) {
				x[i]+=xd[i];
				if (x[i]<0) { x[i]=0; xd[i]=1; } else if (x[i]>=_vidbm->width) { x[i]=_vidbm->width-1; xd[i]=-1; }

				y[i]+=yd[i];
				if (y[i]<0) { y[i]=0; yd[i]=1; } else if (y[i]>=_vidbm->height) { y[i]=_vidbm->height-1; yd[i]=-1; }
			}
		}

	}

	return 0;
}

