#include "listbox.h"
#include "scrsize.h"
#include "toolicon.h"
#include "picture.h"

static struct Text SSR_Texts[]={
	{ "Screen Width"		,  4, 16,St0,St2 },
	{ "Screen Height"		,  4, 27,St0,St2 },
	{ "Page Width"			,  4, 38,St0,St2 },
	{ "Page Height"			,  4, 49,St0,St2 },
	{ "Horiz DPI"			,  4, 60,St0,St2 },
	{ "Vert DPI"			,  4, 71,St0,St2 },
	{ "Ok"				, 30, 96,St0,St2 },
	{ "Cancel"			,137, 96,St0,St2 },
	{ NULL }
};

static struct Rectangle SSR_Neg[]={
	{  98, 14, 51, 11 },
	{  98, 25, 51, 11 },
	{  98, 36, 51, 11 },
	{  98, 47, 51, 11 },
	{  98, 58, 51, 11 },
	{  98, 69, 51, 11 },
	{ RECT_END }
};

static struct Zone SSR_Z1[]={
	{   4, 88, 64, 24 ,ZN_3D },
	{ 123, 88, 64, 24 ,ZN_3D },
	{ 150, 14, 50, 11 ,ZN_3D+ZN_TEXTRENDER,NULL,"Video" },
	{ 150, 25, 50, 11 ,ZN_3D+ZN_TEXTRENDER,NULL,"Max" },
	{ 150, 36, 50, 11 ,ZN_3D+ZN_TEXTRENDER,NULL,"Screen" },
	{ 150, 47, 50, 11 ,ZN_3D+ZN_TEXTRENDER,NULL,"Screen" },
	{  -1, -1, -1, -1 }
};

static struct ZoneRange SSR_ZR[]={
	{	NULL	,SSR_Z1	,NULL	,-1	,ZR_TAP	},
};

static char SSRFBuf1[14];
static char SSRFBuf2[14];
static char SSRFBuf3[14];
static char SSRFBuf4[14];
static char SSRFBuf5[14];
static char SSRFBuf6[14];

static struct Field SSR_FLD[]={
	{ 100, 16, 47,  8, NULL, SSRFBuf1, 0, 0,(sizeof SSRFBuf1)-1,8,St0,St2,FLD_NUMERIC,320,320 },
	{ 100, 27, 47,  8, NULL, SSRFBuf2, 0, 0,(sizeof SSRFBuf2)-1,8,St0,St2,FLD_NUMERIC,200,200 },
	{ 100, 38, 47,  8, NULL, SSRFBuf3, 0, 0,(sizeof SSRFBuf3)-1,8,St0,St2,FLD_NUMERIC,16,32764 },
	{ 100, 49, 47,  8, NULL, SSRFBuf4, 0, 0,(sizeof SSRFBuf4)-1,8,St0,St2,FLD_NUMERIC,16,32764 },
	{ 100, 60, 47,  8, NULL, SSRFBuf5, 0, 0,(sizeof SSRFBuf5)-1,8,St0,St2,FLD_NUMERIC,16,32764 },
	{ 100, 71, 47,  8, NULL, SSRFBuf6, 0, 0,(sizeof SSRFBuf6)-1,8,St0,St2,FLD_NUMERIC,16,32764 },
	{ -1 }
};

static struct Requester ScrSizeRq={
	0,0,204,118,
	REQ_BORDER,
	"Bitmap Size",
	St2,
	NULL,
	SSR_FLD,
	SSR_ZR,
	NULL,
	NULL,		/* rendering */
	SSR_Neg,
	SSR_Texts
};


void ScrSizeReq(void) {
	mouse_coord x,y,b;
	ulong msg;
	short xit=0;
	int	key;

	SSR_FLD[0].low =vds->minx;
	SSR_FLD[0].high=vds->o_maxx;
	SSR_FLD[1].low =vds->miny;
	SSR_FLD[1].high=vds->o_maxy;

	if (!OpenRequester(&ScrSizeRq,0,0)) return;

	NumIntoField(&SSR_FLD[0],vidbm.width  );
	NumIntoField(&SSR_FLD[1],vidbm.height );
	NumIntoField(&SSR_FLD[2],picbm->width );
	NumIntoField(&SSR_FLD[3],picbm->height);
	NumIntoField(&SSR_FLD[4],picbm->xdpi  );
	NumIntoField(&SSR_FLD[5],picbm->ydpi  );

	do {
		mouse_wait_unkey();
		do
			kbhit();
		while(!mouse_buttons() && -1==(key=kbd_check()));

		if (key==' ' || key==0x1b) break;

		mouse_read2(&x,&y,&b);
		if (b & 1)
			switch(msg=CheckRequester(&ScrSizeRq,x,y,b)) {
			case RZoneMsg(0,0):	/* Ok */
				xit=1;
				break;
			case RZoneMsg(0,1):	/* Cancel */
				xit=2;
				break;
			case RZoneMsg(0,2):	// video overscan
				NumIntoField(&SSR_FLD[0],vds->o_vidx);
				NumIntoField(&SSR_FLD[1],vds->o_vidy);
				break;
			case RZoneMsg(0,3):	// max overscan
				NumIntoField(&SSR_FLD[0],vds->o_maxx);
				NumIntoField(&SSR_FLD[1],vds->o_maxy);
				break;
			case RZoneMsg(0,4):	// screen width
				NumIntoField(&SSR_FLD[2],SSR_FLD[0].lval);
				break;
			case RZoneMsg(0,5):	// screen height
				NumIntoField(&SSR_FLD[3],SSR_FLD[1].lval);
				break;
			};
	} while(xit==0);
	mouse_wait_unkey();
	CloseRequester(&ScrSizeRq);

	if (xit==1) {
		if (SSR_FLD[0].lval!=vidbm.width || SSR_FLD[1].lval!=vidbm.height)
			if (!vd->init(VD_RESIZE,SSR_FLD[0].lval,SSR_FLD[1].lval))
				exit(15);
		if (SSR_FLD[2].lval!=picbm->width || SSR_FLD[3].lval!=picbm->height) {
			int action;

			action=RequestBoolean("Resize picture","Rescale","Clip","Junk",
					"%ld,%ld to %ld,%ld",picbm->width,picbm->height,SSR_FLD[2].lval,SSR_FLD[3].lval);

			if (action>0 && pict_cur->total_frames>1)	// rescaling/clipping anim!
				VP_RescaleAnimation(SSR_FLD[2].lval,SSR_FLD[3].lval,action==2);
			else
				resize_picture(SSR_FLD[2].lval,SSR_FLD[3].lval,action);
		}
		picbm->xdpi = SSR_FLD[4].lval;
		picbm->ydpi = SSR_FLD[5].lval;
	};
//	recalc_offsets();
//	restore_screen();
	set_tools_mode(toolmode);
}


/******** Gridding requester ********/

static struct Text GR_Texts[]={
	{ "X Offset"		,  4, 16,St0,St2 },
	{ "Y Offset"		,  4, 27,St0,St2 },
	{ "X Spacing"		,  4, 38,St0,St2 },
	{ "Y Spacing"		,  4, 49,St0,St2 },
	{ NULL }
};

static struct Rectangle GR_Neg[]={
	{  80, 14, 51, 11 },
	{  80, 25, 51, 11 },
	{  80, 36, 51, 11 },
	{  80, 47, 51, 11 },
	{ RECT_END }
};

static struct Zone GR_Z1[]={
	{   4, 73, 48, 24 ,ZN_3D+ZN_TEXTRENDER,NULL,"Ok"	 },
	{  83, 73, 48, 24 ,ZN_3D+ZN_TEXTRENDER,NULL,"Cancel"	 },
	{  36, 61, 65, 11 ,ZN_3D+ZN_TEXTRENDER,NULL,"Pick point" },
	{  -1, -1, -1, -1 }
};

static struct ZoneRange GR_ZR[]={
	{	NULL	,GR_Z1	,NULL	,-1	,ZR_TAP	},
};

static struct Field GR_FLD[]={
	{ 82, 16, 47,  8, NULL, SSRFBuf1, 0, 0,(sizeof SSRFBuf1)-1,8,St0,St2,FLD_NUMERIC,-0x80000000,0x7FFFFFFF },
	{ 82, 27, 47,  8, NULL, SSRFBuf2, 0, 0,(sizeof SSRFBuf2)-1,8,St0,St2,FLD_NUMERIC,-0x80000000,0x7FFFFFFF },
	{ 82, 38, 47,  8, NULL, SSRFBuf3, 0, 0,(sizeof SSRFBuf3)-1,8,St0,St2,FLD_NUMERIC,1,0x7FFFFFFF },
	{ 82, 49, 47,  8, NULL, SSRFBuf4, 0, 0,(sizeof SSRFBuf4)-1,8,St0,St2,FLD_NUMERIC,1,0x7FFFFFFF },
	{ -1 }
};

static struct Requester GridRq = {
	0,0,136,100,
	REQ_BORDER,
	"Grid Specs",
	St2,
	NULL,
	GR_FLD,
	GR_ZR,
	NULL,
	NULL,
	GR_Neg,
	GR_Texts
};

void GridRequest(void) {
	mouse_coord x,y,b;
	ulong msg;
	short xit=0;

	OpenRequester(&GridRq,0,0);
	NumIntoField(&GR_FLD[0],grid.xoff);
	NumIntoField(&GR_FLD[1],grid.yoff);
	NumIntoField(&GR_FLD[2],grid.xspc);
	NumIntoField(&GR_FLD[3],grid.yspc);

	do {
		mouse_wait_unkey();
		mouse_wait_key();
		mouse_read2(&x,&y,&b);
		if (b & 1)
			switch(msg=CheckRequester(&GridRq,x,y,b)) {
			case RZoneMsg(0,0):	/* Ok */
				xit=1;
				break;
			case RZoneMsg(0,1):	/* Cancel */
				xit=2;
				break;
			case RZoneMsg(0,2):
				{
					coord px,py;
					boolean change;

					HideRequester(&GridRq);
					mouse_wait_unkey();
					change = pick_point(&px,&py);
					ShowRequester(&GridRq);
//					printf("%ld,%ld,%d\n",px,py,change);
					if (change) {
						NumIntoField(&GR_FLD[0],px % GR_FLD[2].lval);
						NumIntoField(&GR_FLD[1],py % GR_FLD[3].lval);
					}
				}
				break;
			};
	} while(xit==0);
	mouse_wait_unkey();
	CloseRequester(&GridRq);

	grid.xoff=GR_FLD[0].lval;
	grid.yoff=GR_FLD[1].lval;
	grid.xspc=GR_FLD[2].lval;
	grid.yspc=GR_FLD[3].lval;
}

