#ifndef VGAPAINT_SPRITE_H
#define	VGAPAINT_SPRITE_H

#include "video.h"

#define SPR_HIDDEN	(0x0001)
#define	SPR_DRAWMODE	(0x0006)
#define	SPR_MATTE	(0x0000)
#define	SPR_NOPATTERN	(0x0002)
#define	SPR_REPLACE	(0x0004)
#define	SPR_NOIMAGE	(0x0006)
#define	SPR_NOSAVEBACK	(0x0008)
#define	SPR_GLOBAL	(0x0010)
#define SPR_DISPLAYED	(0x0020)

struct Sprite {
	struct Sprite *prev;
	struct Sprite *next;
	struct BitMap imgbm;
	struct BitMap savebm;
	struct BitMap *dstbm;
	short x,y;
	short width,height;
	short dispx,dispy;
	ushort flags;
	uchar colr;
	uchar trans_colr;
};


void	sprite_init(struct Sprite *spr,uchar *img,uchar *savemem,struct BitMap *dstbm,long imagebpr);
void	sprite_reinit(struct Sprite *spr);
void	sprite_add(struct Sprite *spr);
void	sprite_rem(struct Sprite *spr);
void	sprite_draw(struct Sprite *spr);
void	sprite_erase(struct Sprite *spr);
void	sprite_drawall(void);
void	sprite_eraseall(void);
void	sprite_hide(struct Sprite *spr);
void	sprite_hide2(struct Sprite *spr);
void	sprite_show(struct Sprite *spr);
void	sprite_show2(struct Sprite *spr);
void	sprite_quikmove(struct Sprite *spr,short x,short y);
void	sprite_quikmove2(struct Sprite *spr,short x,short y);
void	sprite_paste(BMP bm,struct Sprite *spr,short x,short y);
boolean	sprite_pointcoll(struct Sprite *spr,short x,short y);
void	sprite_3dtranslate(uchar *dst,uchar *src,ulong size);

#endif

