#define VGAPAINT_TOOLICON_C

#include <dos.h>
#include <stdarg.h>

#include "video.h"
#include "mouse.h"
#include "vgapaint.h"
#include "toolicon.h"
#include "videoz.h"
#include "request.h"
#include "listbox.h"
#include "tools.h"
#include "zones.h"
#include "list.h"
#include "font.h"
#include "picture.h"
#include "menu.h"
#include "inifile.h"
#include "io.h"

extern char version_str[];

struct VDev	vd_in_use;

void clipOff(void) {
	vd->refresh();
	brush_sprite.dstbm=winbm=&unclipbm;
	zoombm=&zoomubm;
	zoomboxbm = &zoomboxubm;
	winbm->syncrect=zoomstate || vidbm.syncrect;
	winbm->syncx1=winbm->syncy1=0x7FFF;
	winbm->syncx2=winbm->syncy2=-0x8000;
	boxbm = &boxbmu;
};

void clipOn(void) {
	vd->refresh();
	brush_sprite.dstbm=winbm=&clipbm;
	zoombm=&zoomcbm;
	zoomboxbm = &zoomboxcbm;
	winbm->syncrect=zoomstate || vidbm.syncrect;
	winbm->syncx1=winbm->syncy1=0x7FFF;
	winbm->syncx2=winbm->syncy2=-0x8000;
	boxbm = &boxbmc;
};

void clipReset(void) {
	if (winbm==&clipbm)	clipOn();
	else			clipOff();
};


//	void set_tools_mode(int mode);
//
//	Remake all the tool zones to fit the new mode.
//
//	Mode may either be TOOLMODE_RIGHT or TOOLMODE_TOP.

void set_tools_mode(int mode) {
	struct Zone *z;
	coord x,y;

	// determine if we can use high resolution tools

	if (XPOINT>=2 && YPOINT>=2 && opt.useHiresTools) {
		toolpos.tools_xmult  = XPOINT>>1;
		toolpos.tools_ymult  = YPOINT>>1;
		toolpos.tools_xpoint = XPOINT & 0xfffffffe;
		toolpos.tools_ypoint = YPOINT & 0xfffffffe;
		toolpos.use_hires = TRUE;
	} else {
		toolpos.tools_xmult = toolpos.tools_xpoint = XPOINT;
		toolpos.tools_ymult = toolpos.tools_ypoint = YPOINT;
		toolpos.use_hires = FALSE;
	}

	toolpos.b_width  = vidbm.width - 17 * vdrv_cur->x_aspect;
	toolpos.b_height = sysfontheight + 4*vdrv_cur->y_aspect - 1;
	toolpos.i_width	 = 13 * toolpos.tools_xpoint;
	toolpos.i_height = 12 * toolpos.tools_ypoint;

	toolmode = mode;
	switch(mode) {
	case TOOLMODE_RIGHT:
#if 0
		toolpos.t_width	 = toolpos.i_width * 2;
#else
		toolpos.t_width	 = 13*2*XPOINT;
#endif
		toolpos.t_height = toolpos.i_height * 9;
		toolpos.t_x1	 = vidbm.x2 - toolpos.t_width;
		toolpos.t_y1	 = toolpos.b_height;
		toolpos.c_width	 = 3 * vdrv_cur->x_aspect;
		toolpos.c_height = 4 * vdrv_cur->y_aspect;

		y = toolpos.t_y1;

		z = ZTool1;
		while(z->xs>=0) {
			z[0].x = toolpos.t_x1;  			z[0].y = y;
			z[1].x = toolpos.t_x1 + toolpos.i_width;	z[1].y = y;
			z[0].xs = z[1].xs = toolpos.i_width;
			z[0].ys = z[1].ys = toolpos.i_height;
			y+=toolpos.i_height;
			z+=2;
		}
		z = ZTool2;
		while(z->xs>=0) {
			z[0].x = toolpos.t_x1;  			z[0].y = y;
			z[1].x = toolpos.t_x1 + toolpos.i_width;	z[1].y = y;
			z[0].xs = z[1].xs = toolpos.i_width;
			z[0].ys = z[1].ys = toolpos.i_height;
			y+=toolpos.i_height;
			z+=2;
		}

		z = ZTool3;
		while(z->xs>=0) {
			z[0].x = toolpos.t_x1;			z[0].y = y;
			z[1].x = toolpos.t_x1 + toolpos.i_width;	z[1].y = y;
			z[0].xs = z[1].xs = toolpos.i_width;
			z[0].ys = z[1].ys = toolpos.i_height;
			y+=toolpos.i_height;
			z+=2;
		}

		ZTool4[0].x	= toolpos.t_x1 + XPOINT;
		ZTool4[0].y	= toolpos.t_y1 + 9*toolpos.i_height + 12*YPOINT;
		ZTool4[0].xs	= 8*toolpos.c_width;
		ZTool4[0].ys	= 8*toolpos.c_height;

		ZTool5[0].x	= toolpos.t_x1 + XPOINT;
		ZTool5[0].y	= vidbm.y2 - 15*YPOINT;
		ZTool5[0].xs	= 10 * vdrv_cur->x_aspect;
		ZTool5[0].ys	= 15 * vdrv_cur->y_aspect;

		ZTool5[1].x	= vidbm.x2 - 11*XPOINT;
		ZTool5[1].y	= vidbm.y2 - 15*YPOINT;
		ZTool5[1].xs	= 10 * vdrv_cur->x_aspect;
		ZTool5[1].ys	= 15 * vdrv_cur->y_aspect;

		ZTool5[2].xs	= toolpos.t_width-2*XPOINT;
		ZTool5[2].ys	= sysfontheight+4*YPOINT-1;
		ZTool5[2].x	= ZTool5[0].x;
		ZTool5[2].y	= ZTool5[0].y - ZTool5[2].ys;

		tool_x = toolpos.t_x1;
		tool_y = toolpos.b_height;

		palrect_large.x1	= toolpos.t_x1;
		palrect_large.y1	= toolpos.t_y1 + 9*toolpos.i_height;
		palrect_large.x2	= vidbm.x2-1;
		palrect_large.y2	= palrect_large.y1 + 12*vdrv_cur->y_aspect-1;
#if 0
		ToolRects[1].x		= vidbm.x2-26*vdrv_cur->x_aspect;
		ToolRects[1].width	= 26*vdrv_cur->y_aspect;
		ToolRects[1].height	= vidbm.height - 11*vdrv_cur->y_aspect;
#endif
		ToolRects[1].height	= vidbm.y2 - toolpos.b_height;
		break;
	case TOOLMODE_TOP:
		toolpos.t_width  = toolpos.i_width * 18;
		toolpos.t_height = toolpos.i_height;
		toolpos.t_x1	 = 0;
		toolpos.t_y1	 = toolpos.b_height;
		toolpos.c_width	 = 3 * vdrv_cur->x_aspect;
		toolpos.c_height = 2 * vdrv_cur->y_aspect;

		x = 0;

		z = ZTool1;
		while(z->xs>=0) {
			z->xs = toolpos.i_width;
			z->ys = toolpos.i_height;
			z->x = x;	z++->y = toolpos.t_y1;
			x+=13*vdrv_cur->x_aspect;
		}
		z = ZTool2;
		while(z->xs>=0) {
			z->xs = toolpos.i_width;
			z->ys = toolpos.i_height;
			z->x = x;	z++->y = toolpos.t_y1;
			x+=13*vdrv_cur->x_aspect;
		}
		z = ZTool3;
		while(z->xs>=0) {
			z->xs = toolpos.i_width;
			z->ys = toolpos.i_height;
			z->x = x;	z++->y = toolpos.t_y1;
			x+=13*vdrv_cur->x_aspect;
		}

		tool_x = vidbm.x2;
		tool_y = toolpos.b_height+toolpos.t_height;

		ZTool4[0].x	= toolpos.t_x1 + 18*toolpos.i_width + 27*vdrv_cur->x_aspect;
		ZTool4[0].y	= toolpos.t_y1 + 2*vdrv_cur->x_aspect;
		ZTool4[0].xs	= 16*toolpos.c_width;
		ZTool4[0].ys	= 4*toolpos.c_height;

		palrect_large.x1	= toolpos.t_x1 + 18*toolpos.i_width;
		palrect_large.y1	= toolpos.t_y1;
		palrect_large.x2	= palrect_large.x1 + 26*vdrv_cur->x_aspect - 1;
		palrect_large.y2	= palrect_large.y1 + toolpos.i_height - 1;
#if 0
		ToolRects[1].x		= 0;
		ToolRects[1].width	= vidbm.width;
		ToolRects[1].height	= 12*vdrv_cur->y_aspect;
#endif
		ToolRects[1].height	= toolpos.t_height;
		break;
	}

	ToolRects[0].width	= vidbm.width - 17*vdrv_cur->x_aspect;
	ToolRects[0].height	= toolpos.b_height;
	ToolRects[1].x		= toolpos.t_x1;
	ToolRects[1].y		= toolpos.t_y1;
	ToolRects[1].width 	= vidbm.x2 - toolpos.t_x1;
	ToolRects[2].x		= vidbm.x2 - 17*vdrv_cur->x_aspect;
	ToolRects[2].width	= 17*vdrv_cur->x_aspect;
	ToolRects[2].height	= toolpos.b_height;

	remake_clip_bitmaps();

	restore_screen();
}


//	remake_clip_bitmaps: remake the bitmaps if picture/frame dimensions have changed

void remake_clip_bitmaps() {
	long cx1,cy1,cxs,cys,cym;
	long ux1,uy1,uxs,uys,uym;

	if (zoomstate) {
		ux1=0; uy1=     0; uxs=(vidbm.width-4)/(zoom_x+1); uys=vidbm.height		    ; uym = uys/zoom_x;
		cx1=0; cy1=tool_y; cxs=(tool_x-4)     /(zoom_y+1); cys=vidbm.height-toolpos.b_height; cym = cys/zoom_y;

		// align the magnified window on a longword boundary for speed
		// if we can't, decrease size by 1

		if (uxs*(zoom_x+1)+4+((4-uxs)&3) > vidbm.width) --uxs;
		if (cxs*(zoom_y+1)+4+((4-cxs)&3) > tool_x) --cxs;

#if 0
vid_initBitMap(&zoomboxubm,vidbm.vm,(uxs+7)&~3,uy1,uxs,uym,vidbm.bpr,vidbm.pal);
vid_initBitMap(&zoomboxcbm,vidbm.vm,(cxs+7)&~3,cy1,cxs,cym,vidbm.bpr,vidbm.pal);
#else
vid_initBitMap(&zoomboxubm,vidbm.vm,(uxs+7)&~3,uy1,uxs*zoom_x,uym*zoom_x,vidbm.bpr,vidbm.pal);
vid_initBitMap(&zoomboxcbm,vidbm.vm,(cxs+7)&~3,cy1,cxs*zoom_x,cym*zoom_y,vidbm.bpr,vidbm.pal);
#endif
vid_initBitMap(&zoomubm,vidbm.vm,(uxs+7)&~3,uy1,min(uxs,picbm->width),min(uym,picbm->height),vidbm.bpr,vidbm.pal);
vid_initBitMap(&zoomcbm,vidbm.vm,(cxs+7)&~3,cy1,min(cxs,picbm->width),min(cym,picbm->height),vidbm.bpr,vidbm.pal);

		zoomboxubm.syncrect=zoomboxcbm.syncrect=TRUE;
	} else {
		ux1=0; uy1=     0; uxs=vidbm.width   ; uys=vidbm.height   ;
		cx1=0; cy1=tool_y; cxs=tool_x        ; cys=vidbm.height-tool_y;
	};

	// clear existing region

	if (winbm==&clipbm)	vd->bar(&vidbm,cx1,cy1,cxs,cys,0);
	else			vd->bar(&vidbm,ux1,uy1,uxs,uys,0);

	vid_initBitMap(&boxbmc,vidbm.vm,cx1,cy1,cxs,cys,vidbm.bpr,vidbm.pal);
	vid_initBitMap(&boxbmu,vidbm.vm,ux1,uy1,uxs,uys,vidbm.bpr,vidbm.pal);

	if (uxs>picbm->width ) {	ux1+=(uxs-picbm->width )>>1;	uxs=picbm->width ;	};
	if (uys>picbm->height) {	uy1+=(uys-picbm->height)>>1;	uys=picbm->height;	};
	if (cxs>picbm->width ) {	cx1+=(cxs-picbm->width )>>1;	cxs=picbm->width ;	};
	if (cys>picbm->height) {	cy1+=(cys-picbm->height)>>1;	cys=picbm->height;	};

	if (winbm==&clipbm)
		vd->box(&boxbmc,cx1-2,cy1-2,cx1+cxs+1,cy1+cys+1,0xFF);
	else
		vd->box(&boxbmu,ux1-2,uy1-2,ux1+uxs+1,uy1+uys+1,0xFF);

	vid_initBitMap(&unclipbm,vidbm.vm,ux1,uy1,uxs,uys,vidbm.bpr,vidbm.pal);
	vid_initBitMap(&clipbm  ,vidbm.vm,cx1,cy1,cxs,cys,vidbm.bpr,vidbm.pal);

	vid_tap_bitmap(&vidbm,(winbm==&clipbm) ? &boxbmc : &boxbmu);
	clipReset();
}

void SetTitle(char *f, ...) {
	va_list val;
	char temp[192];

	if (!toolgrid) return;

	mouse_hide();
	vd->bar(&vidbm,vdrv_cur->x_aspect,vdrv_cur->y_aspect*2,toolpos.b_width-2*vdrv_cur->x_aspect,sysfontheight,St2);
	va_start(val,f);
	if (!f) {
		sprintf(temp,"VGAPaint 386 %s %s:(%ld/%ld)"
			,(ms_mpi.detect_window)?(ms_mpi.in_window?"Win":"F/S"):NULL
			,(pict_cur->flags & PICT_HASNAME) ? pict_cur->name_ptr : "unnamed"
			,pict_cur->current_num
			,pict_cur->total_frames
			);
		if (pict_cur->current->frame_pal)
			sprintf(temp+strlen(temp),"  P[%ld]",pict_cur->current->frame_pal->usecount);

		if (brush)
			sprintf(temp+strlen(temp)," b(%ld/%ld)",brush_picture.current_num,brush_picture.total_frames);
	} else
		vsprintf(temp,f,val);
	va_end(val);
	SysText(&vidbm,2*vdrv_cur->x_aspect,2*vdrv_cur->y_aspect,temp,St0,St2);
	vd->refresh();
	mouse_show();
	// if using Windows 95, change title bar

	if (!opt.wimp_mode && sys.Win95) {
		struct RealInt r;

		strcpy(realtmp,temp);
		r.x.eax = 0x168e;
		r.es	= ((ulong)realtmp)>>4;
		r.w.di	= (ulong)realtmp & 15;
		r.w.dx	= 0;
		DPMIRealInt(0x2f,&r);
	}

}

void display_tools(void) {
	if (!toolgrid) {
		toolgrid=TRUE;
		clipOn();
		vposy+=11;
		mouse_hide();
		if (picbm->width<tool_x || picbm->height<vidbm.height-11)
			vd->set(&vidbm,0);
		redraw_picture();
		draw_tools();
		mouse_show();
		vd->refresh();
	};
}

void draw_tools(void) {
	coord x;
	ulong *grptr;

	mouse_hide();
	vd->bar(&vidbm,toolpos.t_x1,toolpos.t_y1,vidbm.x2-toolpos.t_x1,vidbm.y2-toolpos.t_y1,ST0);
	switch(toolmode) {
	case TOOLMODE_RIGHT:
		if (toolpos.use_hires)
			vid13_bltpattern3dscale(&vidbm,tools3d_hires,toolpos.t_x1,toolpos.t_y1,52,216,toolpos.tools_xmult,toolpos.tools_ymult);
		else
			vid13_bltpattern3dscale(&vidbm,tools3d,toolpos.t_x1,toolpos.t_y1,26,108,toolpos.tools_xmult,toolpos.tools_ymult);
		break;
	case TOOLMODE_TOP:
		grptr = tools3d;
		for(x=0;x<2*9*toolpos.i_width;x+=toolpos.i_width*2) {
			vid13_bltpattern3dscale(&vidbm,grptr,x,toolpos.t_y1,26,12,vdrv_cur->x_aspect,vdrv_cur->y_aspect);
			grptr += 2*12;
		}
		break;
	}

	vd->bar(&vidbm,0,0,vidbm.width,toolpos.b_height,St2);
	vid_draw3d(&vidbm,0,0,toolpos.b_width-1,toolpos.b_height-1);
	vid_draw3d(&vidbm,toolpos.b_width		      ,0,vidbm.x2-1		        ,toolpos.b_height-1);
	vid_draw3d(&vidbm,toolpos.b_width+3*vdrv_cur->x_aspect,2,vidbm.x2-1-6*vdrv_cur->x_aspect,toolpos.b_height-5);
	vid_draw3d(&vidbm,toolpos.b_width+6*vdrv_cur->x_aspect,4,vidbm.x2-1-3*vdrv_cur->x_aspect,toolpos.b_height-3);
	SetTitle(NULL);

	vd->bar(&vidbm,palrect_large.x1+1,palrect_large.y1+1,palrect_large.x2-palrect_large.x1-1,
		palrect_large.y2-palrect_large.y1-1,ZRTool1[3].auxhighindex);
	vd->bar(&vidbm,palrect_large.x1+8,palrect_large.y1+4,palrect_large.x2-palrect_large.x1-15,
		palrect_large.y2-palrect_large.y1-7,ZRTool1[3].highindex);

	if(toolmode == TOOLMODE_RIGHT) {
		ZTool5[0].flags &= ~ZN_DISABLED;
		ZTool5[1].flags &= ~ZN_DISABLED;
		ZTool5[2].flags &= ~ZN_DISABLED;

		vd->bar(&vidbm,ZTool5[0].x,ZTool5[0].y,ZTool5[0].xs,ZTool5[0].ys,St2);
		vd->bar(&vidbm,ZTool5[1].x,ZTool5[1].y,ZTool5[1].xs,ZTool5[1].ys,St2);
//		vd->bar(&vidbm,ZTool5[2].x,ZTool5[2].y,ZTool5[2].xs,ZTool5[2].ys,St2);
		vid_draw3d(&vidbm,ZTool5[0].x,ZTool5[0].y,ZTool5[0].x+ZTool5[0].xs-1,ZTool5[0].y+ZTool5[0].ys-1);
		vid_draw3d(&vidbm,ZTool5[1].x,ZTool5[1].y,ZTool5[1].x+ZTool5[1].xs-1,ZTool5[1].y+ZTool5[1].ys-1);
		vid_polyline(&vidbm,ST0,2,
			ZTool5[0].x + ZTool5[0].xs - 2*vdrv_cur->x_aspect - 1,ZTool5[0].y + 2*vdrv_cur->y_aspect,
			ZTool5[0].x + 2*vdrv_cur->x_aspect,ZTool5[0].y + ZTool5[0].ys/2,
			ZTool5[0].x + ZTool5[0].xs - 2*vdrv_cur->x_aspect - 1,ZTool5[0].y + ZTool5[0].ys - 2*vdrv_cur->y_aspect - 1);
		vid_polyline(&vidbm,ST0,2,
			ZTool5[1].x + 2*vdrv_cur->x_aspect,ZTool5[1].y + 2*vdrv_cur->y_aspect,
			ZTool5[1].x + ZTool5[1].xs - 2*vdrv_cur->x_aspect - 1,ZTool5[1].y + ZTool5[1].ys/2,
			ZTool5[1].x + 2*vdrv_cur->x_aspect,ZTool5[1].y + ZTool5[1].ys - 2*vdrv_cur->y_aspect - 1);
	} else {
		ZTool5[0].flags |= ZN_DISABLED;
		ZTool5[1].flags |= ZN_DISABLED;
		ZTool5[2].flags |= ZN_DISABLED;
	}

	ZoneRefresh(&ZRTool1[0]);
	mouse_show();

	vd->refresh();
}

void erase_tools(void) {
	if (toolgrid) {
		clipOff();
		mouse_hide();
		vd->set(&vidbm,0);
//		vd->bar(&vidbm,0,0,vidbm.width,11,ST0);
//		vd->bar(&vidbm,tool_x,11,26,189,ST0);
		toolgrid=FALSE;
		vposy-=11;
		redraw_picture();
		mouse_show();
		vd->refresh();
	};
}

void restore_tools(void) {
	if (toolgrid) draw_tools();
}

void restore_screen(void) {
//	vid_loadRGB6(0,piccol,256);
	LoadFramePalette(pict_cur,pict_cur->current);
	mouse_hide();
	vd->set(&vidbm,0);
	remake_clip_bitmaps();
	if (colors_reset) reset_colors();
	else restore_colors();
	restore_tools();
	redraw_picture();
	change_palette_set(pict_cur->current_palset);
	mouse_show();
	ms_xscroll=ms_yscroll=0;
	vd->refresh();
}

//	void reblit_screen(void);
//
//	Reblit a changed image of same size to the screen.

void reblit_screen(void) {
	mouse_hide();
	vd->bitblt(picbm,vposx,vposy,winbm,winbm->x1,winbm->y1,winbm->width,winbm->height);
	vd->refresh();
	mouse_show();
}

void syncbitmap(void) {
	UndoInvalidate();
}

void Undo(void) {
	coord picx1,picy1,picxs,picys;

	if (!rectmodified) return;
	if (rectx1>rectx2 || recty1>recty2) return;

	picx1=rectposx+rectx1;
	picy1=rectposy+recty1;
	picxs=rectx2+1-rectx1;
	picys=recty2+1-recty1;

	mouse_hide();
	vd->bitbltswap(&undobm,0,0,picbm,picx1,picy1,picxs,picys);
	vd->bitblt(picbm,picx1,picy1,winbm,winbm->x1+picx1-vposx,winbm->y1+picy1-vposy,picxs,picys);
	mouse_show();
	vd->refresh();
}

void UndoInvalidate(void) {
	rectmodified=FALSE;
	rectx1=winbm->x2; recty1=winbm->y2;
	rectx2=recty2=-1;
	if (undomem) {
		free(undomem);
		undomem=FALSE;
	};
}

void UndoSave(void) {
	coord picx1,picy1,picxs,picys;

	rectx1=max(0,rectx1-winbm->x1);
	recty1=max(0,recty1-winbm->y1);
	rectx2=min(winbm->width-1,rectx2-winbm->x1);
	recty2=min(winbm->height-1,recty2-winbm->y1);

	picx1=rectposx+rectx1;
	picy1=rectposy+recty1;
	picxs=rectx2+1-rectx1;
	picys=recty2+1-recty1;

	if (undomem) free(undomem);

	if (!(undomem=(uchar *)malloc(vd->rassize(picxs,picys)))) {
		rectmodified=FALSE;
		return;
	};

	vid_initBitMap(&undobm,undomem,0,0,picxs,picys,vd->bpr(picxs),vidbm.pal);

	mouse_hide();
//vid_printf6(&vidbm,0,0,7,0,"%d,%d,%d,%d,%d,%d ",rectx1,recty1,picx1,picy1,rectposx,rectposy);
	vd->bitblt(picbm,picx1,picy1,&undobm,0,0,picxs,picys);
	vd->bitblt(winbm,winbm->x1+rectx1,winbm->y1+recty1,picbm,picx1,picy1,picxs,picys);
	mouse_show();
	vd->refresh();
}

#define xabs	abs

uchar request_color(uchar *piccols,uchar red,uchar grn,uchar blu,short orgcol) {
	uchar colval;
	ushort x;
	short reddif,grndif,bludif;
	ulong rmsdif,mindif=0xFFFFFFFF;	/* impossible value */

	for (x=0;x<maxclr;x++) {
		reddif=(short)red-(short)*piccols++;
		grndif=(short)grn-(short)*piccols++;
		bludif=(short)blu-(short)*piccols++;
		rmsdif=reddif*(long)reddif+grndif*(long)grndif+bludif*(long)bludif;
		if (x!=orgcol)
			if (rmsdif<mindif) {
				colval=x;
				if (!(mindif=rmsdif)) break;	// don't bother looking for alternate match if exact
			};
	};
	return colval;
}

///////////////////////

#define	RGswap(x,y) { t=x; x=y; y=t; }

uchar request_grey(uchar *piccols,ulong lum,int orgcol) {
	uchar colval;
	ushort x;
	int red,grn,blu,avg;
	ulong rmsdif,mindif=0xFFFFFFFF;	/* impossible value */

	for (x=0;x<maxclr;x++) {
		red=*piccols++;		grn=*piccols++;		blu=*piccols++;

		rmsdif = abs((30*red + 59*grn + 11*blu)-lum);
//		rmsdif *= rmsdif;	// rmsdif = square of luminance diffs

		avg = (red+grn+blu)/3;
		red -= avg;	grn -= avg;	blu -= avg;
		rmsdif += red*red+grn*grn+blu*blu;	// add in square of "saturation"

		if (x!=orgcol)
			if (rmsdif<mindif) {
				colval=x;
				if (!(mindif=rmsdif)) break;	// don't bother looking for alternate match if exact
			};
	};
	return colval;
}

#undef RGswap

////////////////////

#if 0
ulong rmsdif(uchar cnum1,uchar cnum2) {
	ulong rd,gd,bd;

	rd=xabs(piccol[cnum1*3  ]-piccol[cnum2*3  ]);
	gd=xabs(piccol[cnum1*3+1]-piccol[cnum2*3+1]);
	bd=xabs(piccol[cnum1*3+2]-piccol[cnum2*3+2]);
	return rd*rd+gd*gd+bd*bd;
}
#else
ulong	luminance(uchar cnum) {
	uchar *pal = piccol;
	return 30L*pal[cnum*3] + 59L*pal[cnum*3] + 11L*pal[cnum*3];
}
#endif

// choose_colors: pick system colors from a palette

void	choose_colors(uchar *palette) {
#if 0
	col.black=request_color(palette,  0,  0,  0,-1);
	col.white=request_color(palette,255,255,255,col.black);
	col.lgrey=request_color(palette,170,170,170,col.black);
	col.dgrey=request_color(palette, 85, 85, 85,col.white);
#else
	col.black=request_grey(palette,  0*100,-1);
	col.white=request_grey(palette,255*100,col.black);
	col.lgrey=request_grey(palette,170*100,col.black);
	col.dgrey=request_grey(palette, 85*100,col.white);
#endif
}

// repick_colors: colors have been changed

void repick_colors(void) {
	choose_colors(pict_cur->palette);

#if 0
	if (	(rmsdif(ST0,ST1)< 1200) ||
		(rmsdif(ST0,ST2)< 8192) ||
		(rmsdif(ST2,ST3)<10240)) {
#else
	if (	((luminance(ST1)-luminance(ST0))<3200) ||
		((luminance(ST2)-luminance(ST1))<3200) ||
		((luminance(ST3)-luminance(ST2))<3200)) {
#endif
			flip_colors=TRUE;
			col=col_std;
	} else {
		flip_colors=FALSE;
		col.invert=col.black ^ col.white;
		col.unused=0;
		while(	(col.unused == col.black) ||
			(col.unused == col.dgrey) ||
			(col.unused == col.lgrey) ||
			(col.unused == col.white)) col.unused++;
	};
	col_back=col;
	if (colors_reset) {
		colors_reset=FALSE;
		reset_colors();
	} else {
		colors_reset=TRUE;
		restore_colors();
	};
	FPick_Initialize(fpcol,0,256,piccol);

	change_palette_set(pict_cur->current_palset);
}

void reset_colors(void) {
	colors_reset=TRUE;
	vid_loadRGB6(0,stdcol,32);
	col=col_std;
	ms_mpi.high=col.white;
	ms_mpi.low=col.dgrey;
}

void restore_colors(void) {
	colors_reset=FALSE;
	vid_loadRGB6(0,pict_cur->cur_pal,32);
	col=col_back;
	ms_mpi.high=col.white;
	ms_mpi.low=col.dgrey;
}


//	boolean success = pick_point(coord *x_ptr,coord *y_ptr);
//
//	Pick a point from the current drawing.
//
//	Returns TRUE for success, FALSE for failure.
//
//	Note that any requesters on screen must be hidden.

boolean pick_point(coord *x_ptr,coord *y_ptr) {
	mouse_coord mx,my,mb;

	ms_xscroll = ms_yscroll = 0;
	do {
		check_scroll();
		mouse_read_draw(&mx,&my,&mb,NULL);
	} while(!mb);
	mouse_wait_unkey();

	if (mb&1) {
		*x_ptr = mx;
		*y_ptr = my;
		return TRUE;
	} else	return FALSE;
}


//	void check_scroll(void);
//
//	Check to see if the user has pushed the mouse past the screen boundaries,
//	and thus requested scrolling; if so, scroll the viewport

void	check_scroll(void) {
	static long	accum_scroll_x = 0;
	static long	accum_scroll_y = 0;
	static ulong	last_tick;
	ulong		new_tick;
	int	xscroll=0,yscroll=0;
	int	xdelta,ydelta;

	if (scroll_mode) {	// tablet
		new_tick = read_tick();
		if (new_tick==last_tick) return;
		last_tick = new_tick;

		if (ms_xscroll<0) xscroll=-1; else if (ms_xscroll>0) xscroll=+1;
		if (ms_yscroll<0) yscroll=-1; else if (ms_yscroll>0) yscroll=+1;
	} else {	// mouse
		xscroll = ms_xscroll;
		yscroll = ms_yscroll;
	}
	ms_xscroll=0;
	ms_yscroll=0;

	if (xscroll || yscroll) {
		// if zooming, slice movement by <zoomlevel>

		if (zoomstate) {
			accum_scroll_x += xscroll*(scroll_speed/zoom_x);
			accum_scroll_y += yscroll*(scroll_speed/zoom_y);
		} else {
			accum_scroll_x += xscroll*scroll_speed;
			accum_scroll_y += yscroll*scroll_speed;
		}

		if (!(kbd_shift() & KBD_SCROLL)) {

			if (accum_scroll_x<0)	xdelta = -((-accum_scroll_x)>>16);
			else			xdelta = accum_scroll_x>>16;
			if (accum_scroll_y<0)	ydelta = -((-accum_scroll_y)>>16);
			else			ydelta = accum_scroll_y>>16;

			if (xdelta || ydelta) {
				if (accum_scroll_x<0) accum_scroll_x=-(-accum_scroll_x & 0xffffL); else accum_scroll_x &= 0xffffL;
				if (accum_scroll_y<0) accum_scroll_y=-(-accum_scroll_y & 0xffffL); else accum_scroll_y &= 0xffffL;

				OffBrush();
				scroll_viewport(xdelta,ydelta);
			}
		} else {
			accum_scroll_x = accum_scroll_y = 0;
		}
	}
}


void	scroll_speed_req_updater(struct Slider *sld) {
	if (sld->cposx>=56 && sld->cposx)
		sprintf(packmem,"%08lx: %8.2fx (%8.2f pixels/sec)",sld->cposx,sld->cposx/1024.0,sld->cposx*(18.2/1024.0));
	else
		sprintf(packmem,"%08lx: %8.2fx (%8.2f secs/pixel)",sld->cposx,sld->cposx/1024.0,(1024.0/18.2)/sld->cposx);
	mouse_hide();
	SysText(sld->destbm,(sld->destbm->width-sysfontwidth*38)>>1,YPOINT,packmem,St0,St2);
	mouse_show();
}

void	scroll_speed_req(void) {
	struct SliderRequester *sldr;
	mouse_coord mx,my,mb;
	boolean quit=FALSE;
	int	key;

	if (sldr=MakeSliderRequester(320)) {
		sldr->req.title		= "Adjust Scroll Speed";
		sldr->sld.xclicks	= 0x10000L;
		sldr->sld.cposx		= (scroll_speed+0x0020)>>6;
		sldr->sld.xbump		= 0x400;
		sldr->sld.arrow1tapx	= -1;
		sldr->sld.arrow2tapx	= +1;
		sldr->sld.updater	= scroll_speed_req_updater;

		if (OpenRequester(&sldr->req,0,0)) {
			for(;;) {
				mouse_wait_unkey();
				do
					kbhit();
				while(!mouse_buttons() && -1==(key=kbd_check()));

				if (key==' ' || key==0x1b) break;

				mouse_read2(&mx,&my,&mb);
				if (mb&2) break;
				CheckRequester(&sldr->req,mx,my,mb);
			}
			mouse_wait_unkey();
			CloseRequester(&sldr->req);
		}

		scroll_speed = sldr->sld.cposx<<6;

		DisposeSliderRequester(sldr);
	}
}


void scroll_viewport(long xdelta,long ydelta) {
	long newxvp,newyvp;
	long newxzs,newyzs;
	long xblitsize,yblitsize;

	if (zoomstate) {
		newxzs=zposx+xdelta;
		newyzs=zposy+ydelta;

		if (newxzs<0) newxzs=0; else if (newxzs>picbm->width -zoombm->width ) newxzs=picbm->width -zoombm->width ;
		if (newyzs<0) newyzs=0; else if (newyzs>picbm->height-zoombm->height) newyzs=picbm->height-zoombm->height;

		if (newxzs==zposx && newyzs==zposy) return;

		newxvp=vposx;
		newyvp=vposy;

		zposx=newxzs;
		zposy=newyzs;

		if (newxvp>zposx) newxvp=zposx;
		else if (zposx+zoombm->width>newxvp+winbm->width) newxvp=zposx+zoombm->width-winbm->width;
		if (newyvp>zposy) newyvp=zposy;
		else if (zposy+zoombm->height>newyvp+winbm->height) newyvp=zposy+zoombm->height-winbm->height;

		if (newxvp==vposx && newyvp==vposy) {
			mouse_hide();
			vidZblitzoom(picbm,zposx,zposy,zoomboxbm,zoombm->x1,zoombm->y1,zoombm->width,zoombm->height);
			mouse_show();

			vid_tap_rect(&vidbm,zoomboxbm->x1,zoomboxbm->y1,zoomboxbm->width,zoomboxbm->height);
	 		vd->refresh();
		};
	} else {
		newxvp=vposx+xdelta;
		newyvp=vposy+ydelta;
	};

	if (newxvp<0) newxvp=0;
	else if (newxvp>picbm->width-winbm->width) newxvp=picbm->width-winbm->width;
	if (newyvp<0) newyvp=0;
	else if (newyvp>picbm->height-winbm->height) newyvp=picbm->height-winbm->height;

	if (newxvp==vposx && newyvp==vposy) return;

	/* correct deltas */

	xdelta=newxvp-vposx;
	ydelta=newyvp-vposy;

	/* scroll the old picture off as needed.  If it scrolls too far,
	** don't bother to copy it! */

	xblitsize=min(abs(xdelta),winbm->width);
	yblitsize=min(abs(ydelta),winbm->height);

	mouse_hide();

    vd->bitblt(picbm,
    		newxvp,
		newyvp,
    		winbm,
		winbm->x1,
		winbm->y1,
		winbm->width,
		winbm->height);

	vposx=newxvp;
	vposy=newyvp;

	mouse_show();
	vd->refresh();
}


void	redraw_picture(void) {
	long maxx,maxy;

	// chances are that the viewport/picture dimensions have changed, so clip
	// the viewport offset position...

	maxx=max(0,picbm->width -winbm->width );
	maxy=max(0,picbm->height-winbm->height);

	if (vposx<0) vposx=0; else if (vposx>maxx) vposx=maxx;
	if (vposy<0) vposy=0; else if (vposy>maxy) vposy=maxy;

	vd->bitblt(picbm,vposx,vposy,winbm,winbm->x1,winbm->y1,winbm->width,winbm->height);

	if (zoomstate) {
		coord x1,y1,x2,y2;

//		vidZblitzoom(picbm,zposx,zposy,zoomboxbm,zoombm->x1,zoombm->y1,zoombm->width,zoombm->height);
		x1=winbm->x2;
		y1=winbm->y1;
		x2=zoombm->x1-1;
		y2=winbm->y2-1;

		vd->box(&vidbm,winbm->x2,winbm->y1,zoombm->x1-1,winbm->y2-1,ST3);

		vid13_grey(&vidbm,winbm->x2,boxbm->y1,zoombm->x1-winbm->x2,boxbm->height,ST2,ST1);
	};

	vd->box(boxbm,winbm->x1-2,winbm->y1-2,winbm->x2+1,winbm->y2+1,0xFF);
	vid_tap_bitmap(&vidbm,boxbm);
	vd->refresh();
}


boolean resize_picture(long x,long y,short action) {
	struct BitMap oldpicbm;

	if (pict_cur->total_frames>1 && action>0)	// Anims can only be junked
		return FALSE;

	if (x<16) x=16;
	if (y<16) y=16;

	// save existing memory

	if (action) pict_cur->frame_buf = NULL;	// save the memory if we need to transform

//	if (action) {
//		if (!(t=(uchar *)malloc(x*y))) {
//			Message("Not enough memory to resize picture!");
//			return FALSE;
//		};
//	} else {
//		if (!(t=(uchar *)realloc(picmem,x*y))) {
//			Message("Not enough memory to resize picture!");
//			return FALSE;
//		};
//	};

	memcpy(&oldpicbm,picbm,sizeof(struct BitMap));
	if (!PictureReinit(pict_cur,x,y)) {
		Message("Not enough memory to resize picture!");
		return FALSE;
	}

//	vid_initBitMap(&newpicbm,t,0,0,x,y,x,picbm->pal);
	vd->set(picbm,0);

	switch(action) {
	case 2:		/* rescale */
		vid13_scale(&oldpicbm,0,0,oldpicbm.width,oldpicbm.height,picbm,0,0,picbm->width,picbm->height);
		free(picmem);
		break;
	case 1:		/* copy */
		vd->bitblt(&oldpicbm,0,0,picbm,0,0,picbm->width,picbm->height);
		free(picmem);
		break;
	};

	picmem=pict_cur->frame_buf;
	piccol=pict_cur->palette;
	cyclerange = pict_cur->cyclerange;
	PictureMarkDirty(pict_cur);

//	mouse_show();

	return TRUE;
}

boolean translate_picture_start(struct BitMap *bmtemp,long x,long y) {
	uchar *t;
	long xt;

	if (x<16) x=16;
	if (y<16) y=16;

	xt=(x+3) & 0xFFFFFFFC;

	if (!(t=(uchar *)malloc(xt*y))) {
		Message("Not enough memory to resize picture!");
		return FALSE;
	};

	memcpy(bmtemp,picbm,sizeof(struct BitMap));
	vid_initBitMap(picbm,t,0,0,x,y,xt,picbm->pal);
	vd->set(picbm,0);
	picmem=pict_cur->frame_buf=t;
	return TRUE;
}

void	translate_picture_end(struct BitMap *bmold) {
	free(bmold->vm);
}

boolean	pic_flip_x_function(struct Picture *pict) {
	vid13_flipx(pict->bm,0,0,pict->bm->width,pict->bm->height);
	return TRUE;
}

void	pic_flip_x(void) {
	PictureProcessFrames(pict_cur,pic_flip_x_function,"Flipping Picture Horizontally");
}

boolean	pic_flip_y_function(struct Picture *pict) {
	vid13_flipy(pict->bm,0,0,pict->bm->width,pict->bm->height);
	return TRUE;
}

void	pic_flip_y(void) {
	PictureProcessFrames(pict_cur,pic_flip_y_function,"Flipping Picture Vertically");
}

boolean	pic_rotate_right(void) {
	struct BitMap tempbm;

	if (translate_picture_start(&tempbm,picbm->height,picbm->width)) {
		vid13_rotateright(&tempbm,0,0,picbm,0,0,tempbm.width,tempbm.height);
		translate_picture_end(&tempbm);
		return TRUE;
	}
	return FALSE;
}

///////////////////////////////////////////////////////////////

void	ZoomOff(void) {
	zoomstate=FALSE;
	remake_clip_bitmaps();

	mouse_hide();
	restore_tools();
	scroll_viewport(0,0);
	mouse_show();

	vd->refresh();
}

void	ZoomOn(coord zx,coord zy) {

	zoomstate=TRUE;

	remake_clip_bitmaps();

	// center unmagnified screen upon magnified area

	zx -= zoombm->width>>1;
	zy -= zoombm->height>>1;

	zposx=zx;
	zposy=zy;

	vposx = max(0,min(picbm->width -winbm->width ,zposx-((winbm->width -zoombm->width )>>1)));
	vposy = max(0,min(picbm->height-winbm->height,zposy-((winbm->height-zoombm->height)>>1)));

	vd->set(&vidbm,0);

	restore_screen();
	scroll_viewport(0,0);
	vd->refresh();
}

void	ZoomHandler(void) {
	mouse_coord x,y,b;
	coord ox,oy;
	boolean hitstate=TRUE;

	if (zoomstate)		/* have we already zoomed? */
		ZoomOff();
	else {

		/* we haven't zoomed, so request a zoom rectangle */

		mouse_read2(&x,&y,&b);

		x-=11;
		y-=23;

		if (x<winbm->x1) x=winbm->x1; else if (x>=winbm->x2-23) x=winbm->x2-23;
		if (y<winbm->y1) y=winbm->y1; else if (y>=winbm->y2-47) y=winbm->y2-23;

		do {
			mouse_hide();
			vd->box(winbm,x,y,x+60,y+46,-1);
			vd->refresh();
			mouse_show();
			ox=x; oy=y;
			do {
				mouse_read2(&x,&y,&b);
				b&=1;
				x-=30;
				y-=23;
				if (x<winbm->x1) x=winbm->x1; else if (x>=winbm->x2-61) x=winbm->x2-62;
				if (y<winbm->y1) y=winbm->y1; else if (y>=winbm->y2-47) y=winbm->y2-48;
			} while(ox==x && oy==y && (b ^ hitstate));
			if (b) hitstate=FALSE;
			mouse_hide();
			vd->box(winbm,ox,oy,ox+60,oy+46,-1);
			mouse_show();
		} while(b || hitstate);

		ZoomOn(vposx+x+30-winbm->x1,vposy+y+23-winbm->y1);

	}
	vd->refresh();
}

void	ZSetHandler1(void) {
//	if (zoombits<4) ++zoombits;
//	zoomsize = 1<<zoombits;

	if (zoom_x<32) ++zoom_x;
	if (zoom_y<32) ++zoom_y;

	restore_screen();
	scroll_viewport(0,0);
}

void	ZSetHandler2(void) {
//	if (zoombits>1) --zoombits;
//	zoomsize = 1<<zoombits;

	if (zoom_x>1) --zoom_x;
	if (zoom_y>1) --zoom_y;

	restore_screen();
	scroll_viewport(0,0);
}


void	ZoomRefreshHandler(void) {
	coord dif;
	coord x1,y1,xs,ys;

	// clip the winbm to the zoombm bitmap and then blast that to zoom rectangle

	x1=vposx+winbm->syncx1-winbm->x1;
	y1=vposy+winbm->syncy1-winbm->y1;
	xs=winbm->syncx2+1-winbm->syncx1;
	ys=winbm->syncy2+1-winbm->syncy1;

	if (x1<zposx) { dif=zposx-x1; x1+=dif; xs-=dif; };
	if (y1<zposy) { dif=zposy-y1; y1+=dif; ys-=dif; };
	if (x1+xs>zposx+zoombm->width) xs=zposx+zoombm->width-x1;
	if (y1+ys>zposy+zoombm->height) ys=zposy+zoombm->height-y1;
	if (xs>0)
		if (ys>0) {
			mouse_hide();
vidZblitzoom(winbm,winbm->x1+x1-vposx,winbm->y1+y1-vposy,zoomboxbm,zoombm->x1+((x1-zposx)*zoom_x),zoombm->y1+((y1-zposy)*zoom_y),xs,ys);
			mouse_show();
		};


	// blast the refresh rectangle from the current zoom rectangle into the winbm bitmap

	vid_tap_rect(winbm,zoomboxbm->syncx1,zoomboxbm->syncy1,zoomboxbm->syncx2+1-zoomboxbm->syncx1,zoomboxbm->syncy2+1-zoomboxbm->syncy1);

	vid_tap_reset(zoombm);
}


void Overview(void) {
	/* scale it evenly */

	mouse_hide();
	restore_colors();
	if (picbm->width*vidbm.height < picbm->height*vidbm.width)	/* picture taller */
		vid13_scale(picbm,0,0,picbm->width,picbm->height,&vidbm,0,0,(picbm->width*vidbm.height)/picbm->height,vidbm.height);
	else								/* picture wider */
		vid13_scale(picbm,0,0,picbm->width,picbm->height,&vidbm,0,0,vidbm.width,(picbm->height*vidbm.width)/picbm->width);
	mouse_show();
	vd->refresh();
	mouse_wait_key();
	restore_screen();
};

//////////////////////////// VIDEO DRIVER REQUESTER /////////////////////////////

/* wanna see a big kludge? look at all the vd->refresh()'es all over the code
** to get the Mode X driver up and running... */

static struct List	VDList;		// list of video drivers installed
static ulong		VDCount=0;	// number of video drivers

boolean	AddVideoDriver(struct VideoDriver *vdvr) {
	long i;
	void (**fp1)(void);
	void (**fp2)(void);

	// scan the <vd> entry in the driver's structure; fill in the NULL entries
	// with vid13 entries

	fp1=(void (**)(void))&vd_std;
	fp2=(void (**)(void))vdvr->vd;

	for (i=min(vdvr->VDsize,sizeof(struct VDev)>>2);i;i--) {
		if (!*fp2) *fp2=*fp1;
		++fp2;
		++fp1;
	}

	AddTail(&VDList,&vdvr->node);
	++VDCount;
	return TRUE;			// oooh, that was hard
}

boolean	RemVideoDriver(struct VideoDriver *vdvr) {
	Remove(&vdvr->node);
	--VDCount;
	return TRUE;			// always succeeds
}

struct VideoDriver *FindVideoDriver(char *name) {
	struct Node *np=VDList.prev,*next;
		
	while(next=np->prev) {
		if (!stricmp(name,((struct VideoDriver *)np)->name))
			return np;
		np	= next;
	};

	return NULL;
}

static struct VideoDriverInitCall builtin_vd13_inits[]={
	{ VD_GODIRECT,0,0 },{ NULL,0,0 }
};

static struct VideoDriverInitCall builtin_vd13alt_inits[]={
	{ VD_GOBUFFER,0,0 },{ NULL,0,0 }
};

static struct VideoDriverInitCall builtin_vd13x_inits[]={
	{	VD_SETSIZE,	VD_SETSIZE,	0	},
	{	NULL,		0,		0	},
	{	VD_SETSIZE,	VD_SETSIZE,	1	},
	{	NULL,		0,		0	},
	{	VD_SETSIZE,	VD_SETSIZE,	2	},
	{	NULL,		0,		0	},
	{	VD_SETSIZE,	VD_SETSIZE,	3	},
	{	NULL,		0,		0	},
};

static struct VideoDriverInitCall builtin_vdvesa_inits[]={
	{	VD_SETSIZE,	VESA_640x400,	0	},
	{	NULL,		0,		0	},
	{	VD_SETSIZE,	VESA_640x480,	0	},
	{	NULL,		0,		0	},
	{	VD_SETSIZE,	VESA_800x600,	0	},
	{	NULL,		0,		0	},
	{	VD_SETSIZE,	VESA_1024x768,	0	},
	{	NULL,		0,		0	},
	{	VD_SETSIZE,	VESA_1280x1024,	0	},
	{	NULL,		0,		0	},
};

static struct VideoDriver builtin_video_drivers[]={

{ {0},"Mode 13h (320x200)"	   ,&vd13 ,&builtin_vd13_inits	  ,VDF_FONT6x8+VDF_VHADJUST+VDF_RATIO+VDF_NOBUFFER+VDF_HASTAG
			,256,VDEV_SIZE,VDRV_SIZE,1,1,0x11c71,0x0e666,"vga320x200" },

{ {0},"Mode 13h (320x200) buffered",&vd13 ,&builtin_vd13alt_inits ,VDF_FONT6x8+VDF_VHADJUST+VDF_RATIO+VDF_NOBUFFER+VDF_HASTAG
			,256,VDEV_SIZE,VDRV_SIZE,1,1,0x11c71,0x0e666,"vga320x200b" },

{ {0},"Mode 13X (320x400)"	   ,&vd13x,&builtin_vd13x_inits[0],VDF_NONSTD+VDF_OKAY+VDF_FONT6x8+VDF_RATIO+VDF_HASTAG
			,256,VDEV_SIZE,VDRV_SIZE,1,2,0x11c71,0x0e666,"vga320x400x" },

{ {0},"Mode 13X (360x400)"	   ,&vd13x,&builtin_vd13x_inits[2],VDF_NONSTD+VDF_HACK+VDF_FONT6x8+VDF_RATIO+VDF_HASTAG
			,256,VDEV_SIZE,VDRV_SIZE,1,2,0x14385,0x0c78e,"vga360x400x" },

{ {0},"Mode 13X (320x480)"	   ,&vd13x,&builtin_vd13x_inits[4],VDF_NONSTD+VDF_HACK+VDF_FONT6x8+VDF_RATIO+VDF_HASTAG
			,256,VDEV_SIZE,VDRV_SIZE,1,2,0x10000,0x10000,"vga320x480x" },

{ {0},"Mode 13X (360x480)"	   ,&vd13x,&builtin_vd13x_inits[6],VDF_NONSTD+VDF_HACK+VDF_FONT6x8+VDF_RATIO+VDF_HASTAG
			,256,VDEV_SIZE,VDRV_SIZE,1,2,0x12800,0x0dd67,"vga360x480x" },

{ {0},"13 Hires (640x200 16 color)",&vdh  ,NULL			  ,VDF_NONSTD+VDF_HACK+VDF_FONT8x8+VDF_VHADJUST+VDF_HASTAG
			, 16,VDEV_SIZE,VDRV_SIZE,2,1,0x238e2,0x07333,"vga640x200h16" },
{ {0},NULL }

};

static struct VideoDriver builtin_VESA_video_drivers[]={

{ {0},"VESA  640x 400x256"		,&vdvesa,&builtin_vdvesa_inits[0]	,VDF_VESA + VDF_FONT8x8+VDF_RATIO+VDF_HASTAG
			,256,VDEV_SIZE,VDRV_SIZE,2,2,0x10000,0x10000,"vesa640x400" },
{ {0},"VESA  640x 480x256"		,&vdvesa,&builtin_vdvesa_inits[2]	,VDF_VESA + VDF_FONT8x8+VDF_RATIO+VDF_HASTAG
			,256,VDEV_SIZE,VDRV_SIZE,2,2,0x10000,0x10000,"vesa640x480" },
{ {0},"VESA  800x 600x256"		,&vdvesa,&builtin_vdvesa_inits[4]	,VDF_VESA + VDF_FONT8x12+VDF_RATIO+VDF_HASTAG
			,256,VDEV_SIZE,VDRV_SIZE,3,3,0x10000,0x10000,"vesa800x600" },
{ {0},"VESA 1024x 768x256"		,&vdvesa,&builtin_vdvesa_inits[6]	,VDF_VESA +VDF_FONT12x16+VDF_RATIO+VDF_HASTAG
			,256,VDEV_SIZE,VDRV_SIZE,4,3,0x10000,0x10000,"vesa1024x768" },
{ {0},"VESA 1280x1024x256"		,&vdvesa,&builtin_vdvesa_inits[8]	,VDF_VESA +VDF_FONT12x16+VDF_RATIO+VDF_HASTAG
			,256,VDEV_SIZE,VDRV_SIZE,4,5,0x10000,0x10000,"vesa1280x1024" },
{ {0},NULL }

};

void	InitBuiltinVideoDrivers(void) {
	struct VideoDriver *vd=builtin_video_drivers;

	NewList(&VDList);

	while(vd->name) {
//		if (!(vd->flags & VDF_VESA) || sys.VESA) {
			AddVideoDriver(vd);
			vd->vd->init(VD_INITMAXSIZE,0,0);
//		}
		++vd;
	}

//	if (sys.VESA && !sys.VESA2_0) {
	if (sys.VESA && !opt.noVESA) {
		if (opt.noVESAmodesearch) {
			vd = builtin_VESA_video_drivers;

			while(vd->name) {
				AddVideoDriver(vd);
				vd->vd->init(VD_INITMAXSIZE,0,0);
				++vd;
			}
		} else
			VESA_Scan_Modes();
	}
}

void	SelectVideoDriver(void) {
	struct ListRequester *lr;
	char	**VDNameList;
	int	sel;

	if (!(VDNameList=(char**)malloc((VDCount+2)<<2))) return;

	VDNameList[0]=(char*)(void*)-1L;
	VDNameList[VDCount+1]=NULL;
	
	{
		char **vdt=VDNameList+1;
		struct Node *np=VDList.prev,*next;
		
		while(next=np->prev) {
			*vdt++	= ((struct VideoDriver *)np)->name;
			np	= next;
		};
	}

	if (!(lr = MakeListRequester(30,8,"Select Video Driver"))) goto fmem;

	lr->tbox->table = VDNameList;
	TextboxCreate(lr->tbox,TRUE);

	if (-1 == (sel=ActivateListRequesterAutosize(lr)))
		goto fmem;

	mouse_ptrdispose();

	if (sel!=-1) {
		struct VideoDriver *vdvr;

		vdvr=(struct VideoDriver *)VDList.prev;

		while(sel--) vdvr=(struct VideoDriver *)vdvr->node.prev;

		if (SwitchVideoDriver(vdvr,TRUE)==VDSF_SWITCH_NOVIDEO) exit(10);
	};

	mouse_bounds_reset();

	set_tools_mode(toolmode);

fmem:
	free(VDNameList);

}

extern struct Menu prefsmenu[];
extern struct Menu sizemenu[];
extern struct IniGroup vp_inigroup_videodriver[];
extern struct IniItem vp_ini_videodriver_opts[];

int	SwitchVideoDriver(struct VideoDriver *vdvr,boolean report) {
	struct VideoDriverInitCall *vdic;
	char *msgptr;

	if (vd)
		vd->init(VD_CLOSEDOWN,0,0);

//	vd=vdvr->vd;

	// copy driver's function call list to vd_in_use, then fill in unused entries with those
	// from the mode 13h driver

	memcpy(&vd_in_use,vdvr->vd,min(vdvr->VDsize<<2,sizeof(struct VDev)));
	if ((vdvr->VDsize<<2) < sizeof(struct VDev))
		memcpy((ulong *)&vd_in_use + vdvr->VDsize,(ulong *)&vd_std + vdvr->VDsize,sizeof(struct VDev) - (vdvr->VDsize<<2));

	vd  = &vd_in_use;
	vdic=vdvr->vdiclist;

	if (vdic) while(vdic->vdic) { vd->init(vdic->vdic,vdic->x,vdic->y); ++vdic; };

	maxclr = vdvr->maxcol;

	switch(vdvr->flags & VDF_FONTMASK) {
	case VDF_FONT12x16:	if (sys12x16) { SetSystemFont(sys12x16); break; }
	case VDF_FONT8x12:	if (sys8x12) { SetSystemFont(sys8x12); break; }
	case VDF_FONT8x8:	if (sys8x8) { SetSystemFont(sys8x8); break; }
	case VDF_FONT6x8:
	default:		SetSystemFont(NULL);
	}

	msgptr = NULL;
	vdrv_cur = vdvr;

	x_aspect = vdrv_cur->x_aspect;
	y_aspect = vdrv_cur->y_aspect;

	// set default usedirectVGA flag

	opt.usedirectVGA = opt.nodirect_pal;

	if (!vd->init(VD_STARTUP,(long)&msgptr,0)) {
		if (report) {
			
			// <report> also means to try to re-initialize VGA driver upon failure

			if (!SwitchVideoDriver(&builtin_video_drivers[0],FALSE)) return VDSF_SWITCH_NOVIDEO;

			Message(msgptr ? msgptr : "Video driver initialization failed!");
		}
		return VDSF_SWITCH_FAILED;
	}

	// change the state of the "Screen Density" menu option

	if (vdrv_cur->flags & VDF_VHADJUST)
		prefsmenu[11].flags &= ~MF_DISABLED;
	else
		prefsmenu[11].flags |=  MF_DISABLED;

	// change the state of the "No flicker brush" menu option

	if (vdrv_cur->flags & VDF_NOBUFFER)
		prefsmenu[7].flags &= ~MF_DISABLED;
	else {
		prefsmenu[7].flags |= MF_DISABLED;
		prefsmenu[7].name[0] = ' ';
		opt.brushflickerfree = FALSE;
	}

	// reset current menu density option to 400 lines

	menu_choose(sizemenu,0,3,0);

	// set aspect ratios

	if (vdrv_cur->flags & VDF_RATIO) {
		x_ratio = vdrv_cur->x_ratio;
		y_ratio = vdrv_cur->y_ratio;
	}

	// scan VP386.INI for a group with options for this video driver

	vp_inigroup_videodriver[0].name = vdrv_cur->name;
	IniClearItemFoundFlags(vp_inigroup_videodriver);
	IniProcessFileMem(main_vp386_ini,vp_inigroup_videodriver);

	if (vp_ini_videodriver_opts[0].type & INI_FOUND) monitor_rgamma = 1.0/vp_ini_videodriver_opts[0].fvalue;
	if (vp_ini_videodriver_opts[1].type & INI_FOUND) monitor_ggamma = 1.0/vp_ini_videodriver_opts[1].fvalue;
	if (vp_ini_videodriver_opts[2].type & INI_FOUND) monitor_bgamma = 1.0/vp_ini_videodriver_opts[2].fvalue;
	if (vp_ini_videodriver_opts[3].type & INI_FOUND)
		menu_set_toggle_option(menu_item_address(barmenu+1,4,12,0,-1),opt.gamma_adjust = vp_ini_videodriver_opts[3].ivalue);

	MonitorGammaSet(monitor_rgamma,monitor_ggamma,monitor_bgamma);

	return VDSF_SWITCH_OK;
}

boolean	SwitchBuiltinVideoDriver(long vd_code,boolean report) {
	return SwitchVideoDriver(&builtin_video_drivers[vd_code],report);
}

boolean	SwitchVideoDriverByName(char *name,boolean report) {
	struct VideoDriver *vdrv;

	if (vdrv = FindVideoDriver(name))
		return SwitchVideoDriver(vdrv,report);
	else
		return VDSF_SWITCH_UNKNOWN;
}

////////////////////////////// PALETTE SETS ////////////////////////////////////

void	refresh_palette_set(struct ZoneRange *zr,struct Zone *z,short ind,short frame) {
	int ps;
	char b[4];

	if (toolmode != TOOLMODE_RIGHT || !toolgrid) return;

	mouse_hide();
	vd->bar(zonebm,z->x+1,z->y+1,z->xs-2,z->ys-2,St2);
	if (frame)
		vid_inv3d(zonebm,z->x,z->y,z->x+z->xs-1,z->y+z->ys-1);
	else
		vid_draw3d(zonebm,z->x,z->y,z->x+z->xs-1,z->y+z->ys-1);

	ps = pict_cur->current_palset;
	if (ps==PALSET_DEFAULT)
		*(ulong *)b='\0FED';	//okay so call me lazy
	else if (ps>=PALSET_USER) {
		*(ulong *)b='\0SU'+0x010000L*(ps-PALSET_USER);
	} else if (ps>=PALSET_CCYCLE) {
		*(ulong *)b='0CC'+0x0100000L*(ps-PALSET_CCYCLE);
	}
	SysText(zonebm,z->x+2*XPOINT,z->y+2*YPOINT,b,St0,St2);
	mouse_show();
}

void	change_palette_set(int set) {
	int i;

	if (set==PALSET_DEFAULT) {
		for(i=0;i<256;i++) palset[i]=i;
		pict_cur->current_palset = set;
	} else if (set>=PALSET_USER) {
	} else if (set>=PALSET_CCYCLE) {
		uchar *s;

		// unravel the strip

		if (s=CCycle_Unravel(set-PALSET_CCYCLE)) {
			memset(palset,0,256);
			memcpy(palset,s+2,min(*(short*)s,256));

			free(s);

			pict_cur->current_palset = set;
		}
	}
	refresh_palette_set(ZRTool1+4,ZTool5+2,0,0);
}

static char *palset_names[]={
	"Range 1",
	"Range 2",
	"Range 3",
	"Range 4",
	"Range 5",
	"Range 6",
	"Range 7",
	"Range 8",
};

void palset_menu(struct ZoneRange *zr,struct Zone *z,coord x,coord y) {
	int	total_ranges=0;
	int	i;
	struct Menu *menu,*mp;
	struct Rectangle rect;

	if (z->flags & ZN_INVERTED) {

		// ascertain which colorcycle ranges are valid by their length

		for(i=0;i<8;i++)
			if (pict_cur->cyclerange[i].strips)
				++total_ranges;

		// allocate memory for a menu

		if (!(menu = malloc(sizeof(struct Menu)*(total_ranges+2)))) return;
		memset(menu,0,sizeof(struct Menu)*(total_ranges+2));

		// fill out the menu

		mp = menu;
		mp->node.next=(void *)-1L;	mp->node.prev = (void *)0L;	// MN_START
		mp++->name = "Default";
		for(i=0;i<total_ranges;i++) {
			mp->node.next=(void *)-1L;	mp->node.prev = (void *)-1L;	// MN_INIT
			mp++->name = palset_names[i];
		}
		mp->node.next=(void *)0L;	mp->node.prev = (void *)-1L;	// MN_END
		mp++->name = "Define...";

		// popup menu
		rect.x		= ZTool5[2].x;
		rect.y		= ZTool5[2].y;
		rect.width	= ZTool5[2].xs;
		rect.height	= ZTool5[2].ys;
		PopupMenu(menu,&rect,MP_LEFT);
		free(menu);

		if (choice[1]==total_ranges+1)
			palset_requester();
		else if (choice[1]==0)
			change_palette_set(PALSET_DEFAULT);
		else
			change_palette_set(PALSET_CCYCLE+choice[1]-1);
	} else {
		palette_redrawHandler(&ZRTool1[3]);
	}
}

////////////

static uchar	palset_color_1[3];
static uchar	palset_color_2[3];

struct ZoneRange palset_zr[];

void palset_z_handler(struct ZoneRange *zr,struct Zone *z,short x,short y) {
	int	mb;
	ulong	c;
	uchar	r,g,b;
	int	ind;

	mb = mouse_buttons();
	mouse_wait_unkey();
	if (mb&1) {
		ind = PalettePickColor();
		r = pict_cur->palette[ind*3+0];
		g = pict_cur->palette[ind*3+1];
		b = pict_cur->palette[ind*3+2];
	} else if (mb&2) {
		c = PickAbstractColor();
		r = (c>>16)&255;
		g = (c>>8)&255;
		b = c&255;
	}

	if (mb) {
		if (zr == palset_zr) {
			palset_color_1[0] = r;
			palset_color_1[1] = g;
			palset_color_1[2] = b;
		} else {
			palset_color_2[0] = r;
			palset_color_2[1] = g;
			palset_color_2[2] = b;
		}
	}
}

struct Zone palset_z1[]={
	{ 0,0,0,0,ZN_3D+ZN_INSTANT,(ZoneHitHandler)&palset_z_handler },
	{ -1,-1,-1,-1 },
};

struct Zone palset_z2[]={
	{ 0,0,0,0,ZN_3D+ZN_INSTANT,(ZoneHitHandler)&palset_z_handler },
	{ -1,-1,-1,-1 },
};

struct Zone palset_z3[]={
	{ 0,0,0,0,ZN_3D+ZN_TEXTRENDER+ZN_SYSTEXT,NULL,"Ok" },
	{ 0,0,0,0,ZN_3D+ZN_TEXTRENDER+ZN_SYSTEXT,NULL,"Cancel" },
	{ -1,-1,-1,-1 },
};

struct ZoneRange palset_zr[]={
	{ &palset_zr[1] ,palset_z1,NULL,-1,ZR_TAP },
	{ &palset_zr[2] ,palset_z2,NULL,-1,ZR_TAP },
	{ NULL		,palset_z3,NULL,-1,ZR_TAP },
};

struct Slider palset_sld[]={
	{
		&palset_sld[1],{NULL},NULL,{NULL},
		NULL,0,0,4,4,		//knob
		0,0,0,0,0,0,0,0,0,0,
		REQSLD_ONEHIT+SLD_ARROW1HIT+SLD_ARROW2HIT+4*SLD_ARROW1+6*SLD_ARROW2+SLD_OUTLINE3D+SLD_ATTACHX,
		NULL
	},{
		NULL,{NULL},NULL,{NULL},
		NULL,0,0,4,4,		//knob
		0,0,0,0,0,0,0,0,0,0,
		REQSLD_ONEHIT+SLD_ARROW1HIT+SLD_ARROW2HIT+4*SLD_ARROW1+6*SLD_ARROW2+SLD_OUTLINE3D+SLD_ATTACHX,
		NULL
	}
};

struct Requester palset_req={
	0,0,0,0,
	REQ_BORDER+REQ_POPCEN+REQ_COORDBIAS+REQ_SLDREPHIT+REQ_SYSTITLE,
	"Define Palette Set",
	St2,
	NULL,		// lboxes
	NULL,		// fields
	palset_zr,	// zoneranges
	palset_sld,	// sliders
	NULL,		// posrects
	NULL,		// negrects
	NULL,		// texts
};

int	palset_sorter(const int *i1,const int *i2) {
	return (int)(i1[1]>i2[1])-(int)(i1[1]<i2[1]);
}

void palset_requester(void) {
	mouse_coord mx,my,mb;
	boolean quit=FALSE;
	ulong msg;
	int	*sort_array;
	int	i;

	if (!(sort_array = malloc(sizeof(int)*512))) return;

	// adjust requester to system metrics

	palset_sld[0].boundbox.x	= 12*XPOINT+2;
	palset_sld[0].boundbox.y	=  2*YPOINT+2;
	palset_sld[0].boundbox.width	=120*XPOINT-4;
	palset_sld[0].boundbox.height	= 10*YPOINT-4;
	palset_sld[0].arrow1.width	= 10*XPOINT;
	palset_sld[0].arrow1.height	= 10*YPOINT;
	palset_sld[0].arrow2.width	= 10*XPOINT;
	palset_sld[0].arrow2.height	= 10*YPOINT;
	palset_sld[1].boundbox.x	= 12*XPOINT+2;
	palset_sld[1].boundbox.y	= 12*YPOINT+2;
	palset_sld[1].boundbox.width	=120*XPOINT-4;
	palset_sld[1].boundbox.height	= 10*YPOINT-4;
	palset_sld[1].arrow1.width	= 10*XPOINT;
	palset_sld[1].arrow1.height	= 10*YPOINT;
	palset_sld[1].arrow2.width	= 10*XPOINT;
	palset_sld[1].arrow2.height	= 10*YPOINT;
	palset_z1[0].x			=  2*XPOINT;
	palset_z1[0].y			= 23*YPOINT;
	palset_z1[0].xs			= 10*XPOINT;
	palset_z1[0].ys			= 10*YPOINT;
	palset_z2[0].x			=132*XPOINT;
	palset_z2[0].y			= 23*YPOINT;
	palset_z2[0].xs			= 10*XPOINT;
	palset_z2[0].ys			= 10*YPOINT;
	palset_z3[0].x			=  2*XPOINT;
	palset_z3[0].y			= 35*YPOINT;
	palset_z3[0].xs			=  4*XPOINT+6*sysfontwidth;
	palset_z3[0].ys			= sysfontheight+4*YPOINT;
	palset_req.width		=144*XPOINT+10*sysfontwidth;
	palset_req.height		= 41*YPOINT+sysfontheight;
	palset_z3[1].x			= palset_req.width-6*XPOINT-6*sysfontwidth;
	palset_z3[1].y			= 35*YPOINT;
	palset_z3[1].xs			=  4*XPOINT+6*sysfontwidth;
	palset_z3[1].ys			= sysfontheight+4*YPOINT;

	mouse_read2(&mx,&my,&mb);
	if (!OpenRequester(&palset_req,mx,my)) {
		free(sort_array);
		return;
	}

	mouse_hide();
	vid_inv3d(&palset_req.reqbm,12*XPOINT,23*YPOINT,132*XPOINT-1,33*YPOINT-1);
	mouse_show();

	while(!quit) {
		mouse_read2(&mx,&my,&mb);

		switch(msg = CheckRequester(&palset_req,mx,my,mb)) {
		case RZoneMsg(0,0):
		case RZoneMsg(1,0): {
			int a,b,c,d,d1,d2;
			uchar *p = pict_cur->palette;
			int *aptr = sort_array;

			// change in colors, recompute color set

//			Message("start %d,%d,%d end %d,%d,%d",
//				palset_color_1[0],
//				palset_color_1[1],
//				palset_color_1[2],
//				palset_color_2[0],
//				palset_color_2[1],
//				palset_color_2[2]);

			// compute vector (a,b,c) as (x2-x1,y2-y1,z2-z1)
			a = (int)palset_color_2[0] - (int)palset_color_1[0];
			b = (int)palset_color_2[1] - (int)palset_color_1[1];
			c = (int)palset_color_2[2] - (int)palset_color_1[2];

//			Message("vector %d,%d,%d",a,b,c);

			// to keep brightnesses consistent, change RGB cube into a rectangular solid (30,59,11)

			a *= 213;
			b *= 715;
			c *= 072;

			// calculate start and end coordinates

			d1 = a*palset_color_1[0]+b*palset_color_1[1]+c*palset_color_1[2];
			d2 = a*palset_color_2[0]+b*palset_color_2[1]+c*palset_color_2[2];

//			Message("d1 %d  d2 %d",d1,d2);

			// sort colors through the planar equation ax+by+cz=d
			// leave out colors <d1 or >d2

			for(i=0;i<256;i++) {
				d = a*p[0] + b*p[1] + c*p[2];
				if (d>=d1 && d<=d2) {
					*aptr++ = i;
					*aptr++ = d;
				}
				p+=3;
			}

			if (aptr == sort_array) {	// no matching colors!
				vd->bar(&palset_req.reqbm,12*XPOINT+1,23*YPOINT+1,120*XPOINT-2,10*YPOINT-2,0);
			} else {			// matching colors
				qsort(sort_array,(aptr-sort_array)/2,sizeof(int)*2,palset_sorter);

				a = (((aptr-sort_array)/2)*0x10000L) / (120*XPOINT-3);
				b = 0;

				mouse_hide();
				for(i=0;i<120*XPOINT-2;i++) {
					vd->vline(&palset_req.reqbm,12*XPOINT+1+i,23*YPOINT+1,33*YPOINT-2,sort_array[(b>>16)*2]);
					b+=a;
				}
				mouse_show();
			}

			} break;
		case RZoneMsg(2,0):
		case RZoneMsg(2,1):
			quit=TRUE;
			break;
		}
	}

	CloseRequester(&palset_req);
}

/////////////////////////////// SYSTEM FONT ////////////////////////////////////

void	SetSystemFont(struct Font *font) {
	sysfont = font;
	if (font) {
		sysfontwidth  = font->width;
		sysfontheight = font->height;
	} else {
		sysfontwidth  = 6;
		sysfontheight = 8;
	};
}

void	SysText(BMP bm,coord x1,coord y1,char *s,color f,color b) {

	if (sysfont) {
		f=vid_ctran(f);
		b=vid_ctran(b);
		vid13_RenderFont(bm,sysfont,x1,y1,f,b,FRF_FGNORMAL+FRF_BGNORMAL,s,0xFFFFFFFF);
	} else {
		vid13_text6lim(bm,x1,y1,s,f,b,0x7FFF);
	}
}

void	SysTextPrintf(BMP bm,coord x1,coord y1,color f,color b,char *s, ...) {
	char	buf[192];
	va_list	val;

	va_start(val,s);
	vsprintf(buf,s,val);
	va_end(val);

	SysText(bm,x1,y1,buf,f,b);
}

void	SysTextLim(BMP bm,coord x1,coord y1,char *s,color f,color b,ulong lim) {

	if (sysfont) {
		f=vid_ctran(f);
		b=vid_ctran(b);
		vid13_RenderFont(bm,sysfont,x1,y1,f,b,FRF_FGNORMAL+FRF_BGNORMAL,s,lim);
	} else {
		vid13_text6lim(bm,x1,y1,s,f,b,lim);
	}
}

void	SysTextTrans(BMP bm,coord x1,coord y1,char *s,color f) {
	if (sysfont) {
		f=vid_ctran(f);
		vid13_RenderFont(bm,sysfont,x1,y1,f,0,FRF_FGNORMAL+FRF_BGTRANS,s,0xFFFFFFFF);
	} else {
		vid13_text6trans(bm,x1,y1,s,f);
	}
}

ulong	SysTextLength(char *str) {
	if (sysfont) return TextLength(sysfont,str); else return strlen(str)*6;
}

/////////////////////////////////////////////////////////////

static void (__interrupt *old_harderr)(void);
static boolean	harderr_installed = FALSE;

static char *harderrs[]={
	"Write protected disk",
	"Unknown unit",
	"Drive not ready",
	"Unknown command",
	"CRC error",
	"Bad drivereq length",
	"Seek error",
	"Unknown media type",
	"Sector not found",
	"Out of paper",
	"Write fault",
	"Read fault",
	"General failure",
};

static char	harderr_abort[]="Abort";
static char	harderr_retry[]="Retry";
static char	harderr_ignore[]="Ignore";
static char	harderr_fail[]="Fail";

int	__far Harderr_Func(unsigned deverror,unsigned errcode,unsigned __far *devhdr) {
	int	codes[3];
	char	*strs[3]={ NULL,NULL,harderr_abort};
	char	buf[80];
	int	r;

	codes[2] = _HARDERR_ABORT;

	if (!(deverror & 0x8000)) {
		int i=0;
		char	drvletter = (uchar)deverror + 'A';
		char	*rw = deverror&0x100 ? "write" : "read";

		if (deverror & 0x0800) {
			codes[i]=_HARDERR_FAIL;
			strs[i]=harderr_fail;
			++i;
		}
		if (deverror & 0x2000) {
			codes[i]=_HARDERR_IGNORE;
			strs[i]=harderr_ignore;
			++i;
		}
		if (deverror & 0x1000) {
			codes[i]=_HARDERR_RETRY;
			strs[i]=harderr_retry;
		}

		switch(errcode&0xff) {
		case  0: sprintf(buf,"Write protected disk in drive %c:",drvletter); break;
		case  1: strcpy(buf,harderrs[1]); break;
		case  2: sprintf(buf,"Drive %c: not ready",drvletter); break;
		case  3: sprintf(buf,"Unknown command for drive %c:",drvletter); break;
		case  4: sprintf(buf,"CRC error %sing drive %c:",rw,drvletter); break;
		case  5: strcpy(buf,harderrs[5]); break;
		case  6: sprintf(buf,"Seek error %sing drive %c:",rw,drvletter); break;
		case  7: sprintf(buf,"Unknown media type in drive %c:",drvletter); break;
		case  8: sprintf(buf,"Sector not found %sing drive %c:",rw,drvletter); break;
		case  9: strcpy(buf,harderrs[9]); break;
		case 10: sprintf(buf,"Write fault on drive %c:",drvletter); break;
		case 11: sprintf(buf,"Read fault on drive %c:",drvletter); break;
		case 12: sprintf(buf,"General failure %sing drive %c:",rw,drvletter); break;
		default: sprintf(buf,"Unknown error %d %sing drive %c:",errcode&0xff,rw,drvletter); break;
		}
	} else {
		// <retry> <ignore> <fail>

		codes[2]=_HARDERR_RETRY;
		codes[1]=_HARDERR_IGNORE;
		codes[0]=_HARDERR_FAIL;
		strs[2]=harderr_retry;
		strs[1]=harderr_ignore;
		strs[0]=harderr_fail;
		strcpy(buf,harderrs[errcode&0xff]);
	}

	r = codes[RequestBoolean("DOS I/O Error",strs[2],strs[1],strs[0],buf)];

	if (r == _HARDERR_ABORT) {

		// Oh sh*t, we're going to abort VP386.
		// Crash-fix everything as best as we can so we don't reboot
		// the machine.

		if (!opt.wimp_mode)
			_InternalSetTimerPeriod(0);
		mouse_ptrdispose();
	}
	_hardresume(r);
}

void	InstallHarderrHandler(void) {
	if (harderr_installed) return;

	old_harderr = _dos_getvect(0x24);
	_harderr(Harderr_Func);
	harderr_installed = TRUE;
}

void	DeinstallHarderrHandler(void) {
	if (harderr_installed) {
		_dos_setvect(0x24,old_harderr);
		harderr_installed = FALSE;
	}
}

