#ifndef	VGAPAINT_H
#define	VGAPAINT_H

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <math.h>
#include <string.h>

#include "wsample.h"
#include "video.h"
#include "toolicon.h"
#include "tools.h"
#include "zones.h"
#include "brush.h"
#include "sprite.h"
//#include "io.h"
//#include "file.h"
//#include "menu.h"
//#include "pcx.h"
//#include "dither.h"
//#include "average.h"
#include "ccycle.h"
//#include "spare.h"
//#include "arrange.h"
#include "gadgets.h"
#include "request.h"
#include "mouse.h"
#include "asmfunc.h"
#include "videox.h"
#include "videos.h"
#include "vidvesa.h"
#include "videoh.h"
#include "cpoctree.h"
#include "help.h"

#ifdef	VGAPAINT_MAIN
#define	EXTERN
#define	INIT(x)	=x
#else
#define	EXTERN extern
#define	INIT(x)
#endif

#define KBD_UP		(0x148)
#define KBD_LEFT        (0x14B)
#define KBD_RIGHT	(0x14D)
#define KBD_DOWN	(0x150)

#define	KBD_RSHIFT	(0x01)
#define	KBD_LSHIFT	(0x02)
#define	KBD_SHIFT	(0x03)
#define	KBD_CTRL	(0x04)
#define	KBD_ALT		(0x08)
#define	KBD_SCROLL	(0x10)
#define	KBD_NUMLOCK	(0x20)
#define	KBD_CAPSLOCK	(0x40)
#define	KBD_INSTOGG	(0x80)

#define	MRD_WAITMOVE	(1)
#define	MRD_GRID	(2)
#define MRD_DOSPLIT	(4)
#define MRD_SETZOOMFLG	(8)
#define	MRD_USEZOOMFLG	(16)
#define	MRD_USESHIFT	(32)

#define	TOOLDEFINE(x)	void x(coord x1,coord y1,coord x2,coord y2,color colr,boolean preview)
#define	TAP_RECT(x,y)	{ if ((x)<rectx1) rectx1=x; if ((x)>rectx2) rectx2=x; if ((y)<recty1) recty1=y; if ((y)>recty2) recty2=y; }
#define	swap(t,x,y)	{ t temp; temp=x; x=y; y=temp; }
#define	GETCOLOR(r,g,b)	(FPick_Choose(fpcol,256,(r),(g),(b)))

typedef	void TOOL(coord x1,coord y1,coord x2,coord y2,color colr,boolean preview);
typedef	void TOOLDRG(TOOL *,boolean use_preview);

EXTERN	struct IniFile	*main_vp386_ini;
EXTERN	struct Font *sys6x16	INIT(NULL);	// system 6x16 monospace font for mode X
EXTERN	struct Font *sys8x8	INIT(NULL);	// system 8x8 monospace font for higher resolution modes
EXTERN	struct Font *sys8x12	INIT(NULL);	// system 8x12 monospace font
EXTERN	struct Font *sys12x16	INIT(NULL);	// system 12x16 monospace font

EXTERN	struct Font *sysfont	INIT(NULL);	// system font
EXTERN	long	sysfontwidth	INIT(6);
EXTERN	long	sysfontheight	INIT(8);

EXTERN	struct BitMap vidbm;		/* unclipped video bitmap */
EXTERN	struct BitMap *winbm;		/* clipped video bitmap */
EXTERN	struct BitMap clipbm;		/* clipped video bitmap */
EXTERN	struct BitMap unclipbm;		/* unclipped video bitmap */
EXTERN	struct BitMap *picbm;		/* picture bitmap */
EXTERN	struct BitMap *sparebm;		/* spare picture bitmap */
//EXTERN	struct BitMap brushbm;		/* brush bitmap */
EXTERN	struct BitMap *zoombm;		/* current zoom bitmap */
EXTERN	struct BitMap *zoomboxbm;	/* current zoom bitmap */
EXTERN	struct BitMap zoomcbm;		/* clipped zoom bitmap */
EXTERN	struct BitMap zoomubm;		/* unclipped zoom bitmap */
EXTERN	struct BitMap zoomboxcbm;	/* clipped zoom bitmap */
EXTERN	struct BitMap zoomboxubm;	/* unclipped zoom bitmap */
EXTERN	struct BitMap undobm;		/* undo bitmap */
EXTERN	struct BitMap boxbmc;		// clipped box bitmap
EXTERN	struct BitMap boxbmu;		// unclipped box bitmap
EXTERN	struct BitMap *boxbm;		// box bitmap pointer
EXTERN	struct BitMap invizbm;		// "invisible" bitmap

EXTERN	struct Picture *pict_cur INIT(NULL);	// current picture
EXTERN	struct Picture *pict_spare INIT(NULL);	// spare picture list

EXTERN	uchar *undomem INIT(NULL);	/* undo memory */
EXTERN	uchar *picmem INIT(NULL);

EXTERN	union REGS regs;		/* register setup */
EXTERN	struct SREGS sregs;		/* segment registers */

EXTERN	boolean	toolgrid INIT(FALSE);		// toolgrid state
EXTERN	int	toolmode INIT(TOOLMODE_RIGHT);	// toolgrid position
EXTERN	boolean	gridmode INIT(FALSE);		// gridding enabled?
EXTERN	boolean	flip_colors INIT(FALSE);	// flip colors when req?
EXTERN	boolean	colors_reset INIT(FALSE);	// colors have been reset
EXTERN	boolean	quit INIT(FALSE);		// do I have to tell you?
EXTERN	boolean	zoomstate INIT(FALSE);		// zoom mode
//EXTERN	uchar	zoomsize INIT(4);		// multiplier; 4x default; 0 = custom
EXTERN	int	zoom_x INIT(4);
EXTERN	int	zoom_y INIT(4);
//EXTERN	uchar	zoombits INIT(2);		// number of bits to shift coordinates; 2=4x
EXTERN	int	scroll_mode INIT(0);		// scrolling mode
EXTERN	ulong	scroll_speed INIT(0x10000L);	// scrolling speed (tablet)

EXTERN	uchar	fcolor		INIT(15);	// foreground color
EXTERN	uchar	bcolor		INIT(0);	// background color
EXTERN	uchar	fcolorpos	INIT(15);	// "position" of fgcolor in palette box
EXTERN	uchar	bcolorpos	INIT(0);	// "position" of bgcolor in palette box

EXTERN	coord	tool_x	INIT(294);	/* toolicon x coord */
EXTERN	coord	tool_y	INIT(11);

EXTERN	int	maxclr	INIT(256);	/* maximum color */

struct StdColor {			/* standard colors */
	color	black;
	color	dgrey;
	color	lgrey;
	color	white;
	color	invert;
	color	unused;
};

EXTERN struct StdColor col,col_back,col_std
#ifdef	VGAPAINT_MAIN
={
	0,8,7,15,15,255
}
#endif
;

#ifdef	EXTENSION
	#define	COL	(*_col)
#else
	#define	COL	col
#endif

#define	ST0	(COL.black)
#define	ST1	(COL.dgrey)
#define	ST2	(COL.lgrey)
#define	ST3	(COL.white)
#define	STI	(COL.invert)
#define	STT	(COL.unused)

#define	St0	(-0x7fffff00)
#define	St1	(-0x7ffffeff)
#define	St2	(-0x7ffffefe)
#define	St3	(-0x7ffffefd)
#define	StI	(-0x7ffffefc)
#define	StT	(-0x7ffffefb)

/////////////////////////////////////////////////////////

EXTERN	coord	rectx1 INIT( 0x7FFF);	/* modified rectangle */
EXTERN	coord	recty1 INIT(-0x7FFF);
EXTERN	coord	rectx2 INIT( 0x7FFF);
EXTERN	coord	recty2 INIT(-0x7FFF);
EXTERN	boolean	rectmodified INIT(FALSE);	/* modified? */
EXTERN	long	rectposx;		/* position at time of modification */
EXTERN	long	rectposy;

EXTERN	long	vposx INIT(0);		/* viewport x position */
EXTERN	long	vposy INIT(0);		/* viewport y position */
EXTERN	long	zposx INIT(0);		/* zoomport x position */
EXTERN	long	zposy INIT(0);		/* zoomport y position */

EXTERN	struct	FastPick	*fpcol;
EXTERN	uchar	*piccol;
EXTERN	uchar	stdcol[256*3]
#ifdef VGAPAINT_MAIN
={
	  0,  0,  0,	  0,  0,170,	  0,170,  0,	  0,170,170,
	170,  0,  0,	170,  0,170,	170, 85,  0,	170,170,170,
	 85, 85, 85,	 85, 85,255,	 85,255, 85,	 85,255,255,
	255, 85, 85,	255, 85,255,	255,255, 85,	255,255,255,
	  0,  0,  0,	 20, 20, 20,	 32, 32, 32,	 44, 44, 44,
	 56, 56, 56,	 68, 68, 68,	 80, 80, 80,	 97, 97, 97,
	113,113,113,	129,129,129,	145,145,145,	161,161,161,
	182,182,182,	202,202,202,	226,226,226,	255,255,255,
	  0,  0,255,	 64,  0,255,	125,  0,255,	190,  0,255,
	255,  0,255,	255,  0,190,	255,  0,125,	255,  0, 64,
	255,  0,  0,	255, 64,  0,	255,125,  0,	255,190,  0,
	255,255,  0,	190,255,  0,	125,255,  0,	 64,255,  0,
	  0,255,  0,	  0,255, 64,	  0,255,125,	  0,255,190,
	  0,255,255,	  0,190,255,	  0,125,255,	  0, 64,255,
	125,125,255,	157,125,255,	190,125,255,	222,125,255,
	255,125,255,	255,125,222,	255,125,190,	255,125,157,
	255,125,125,	255,157,125,	255,190,125,	255,222,125,
	255,255,125,	222,255,125,	190,255,125,	157,255,125,
	125,255,125,	125,255,157,	125,255,190,	125,255,222,
	125,255,255,	125,222,255,	125,190,255,	125,157,255,
	182,182,255,	198,182,255,	218,182,255,	234,182,255,
	255,182,255,	255,182,234,	255,182,218,	255,182,198,
	255,182,182,	255,198,182,	255,218,182,	255,234,182,
	255,255,182,	234,255,182,	218,255,182,	198,255,182,
	182,255,182,	182,255,198,	182,255,218,	182,255,234,
	182,255,255,	182,234,255,	182,218,255,	182,198,255,
	  0,  0,113,	 28,  0,113,	 56,  0,113,	 85,  0,113,
	113,  0,113,	113,  0, 85,	113,  0, 56,	113,  0, 28,
	113,  0,  0,	113, 28,  0,	113, 56,  0,	113, 85,  0,
	113,113,  0,	 85,113,  0,	 56,113,  0,	 28,113,  0,
	  0,113,  0,	  0,113, 28,	  0,113, 56,	  0,113, 85,
	  0,113,113,	  0, 85,113,	  0, 56,113,	  0, 28,113,
	 56, 56,113,	 68, 56,113,	 85, 56,113,	 97, 56,113,
	113, 56,113,	113, 56, 97,	113, 56, 85,	113, 56, 68,
	113, 56, 56,	113, 68, 56,	113, 85, 56,	113, 97, 56,
	113,113, 56,	 97,113, 56,	 85,113, 56,	 68,113, 56,
	 56,113, 56,	 56,113, 68,	 56,113, 85,	 56,113, 97,
	 56,113,113,	 56, 97,113,	 56, 85,113,	 56, 68,113,
	 80, 80,113,	 89, 80,113,	 97, 80,113,	105, 80,113,
	113, 80,113,	113, 80,105,	113, 80, 97,	113, 80, 89,
	113, 80, 80,	113, 89, 80,	113, 97, 80,	113,105, 80,
	113,113, 80,	105,113, 80,	 97,113, 80,	 89,113, 80,
	 80,113, 80,	 80,113, 89,	 80,113, 97,	 80,113,105,
	 80,113,113,	 80,105,113,	 80, 97,113,	 80, 89,113,
	  0,  0, 64,	 16,  0, 64,	 32,  0, 64,	 48,  0, 64,
	 64,  0, 64,	 64,  0, 48,	 64,  0, 32,	 64,  0, 16,
	 64,  0,  0,	 64, 16,  0,	 64, 32,  0,	 64, 48,  0,
	 64, 64,  0,	 48, 64,  0,	 32, 64,  0,	 16, 64,  0,
	  0, 64,  0,	  0, 64, 16,	  0, 64, 32,	  0, 64, 48,
	  0, 64, 64,	  0, 48, 64,	  0, 32, 64,	  0, 16, 64,
	 32, 32, 64,	 40, 32, 64,	 48, 32, 64,	 56, 32, 64,
	 64, 32, 64,	 64, 32, 56,	 64, 32, 48,	 64, 32, 40,
	 64, 32, 32,	 64, 40, 32,	 64, 48, 32,	 64, 56, 32,
	 64, 64, 32,	 56, 64, 32,	 48, 64, 32,	 40, 64, 32,
	 32, 64, 32,	 32, 64, 40,	 32, 64, 48,	 32, 64, 56,
	 32, 64, 64,	 32, 56, 64,	 32, 48, 64,	 32, 40, 64,
	 44, 44, 64,	 48, 44, 64,	 52, 44, 64,	 60, 44, 64,
	 64, 44, 64,	 64, 44, 60,	 64, 44, 52,	 64, 44, 48,
	 64, 44, 44,	 64, 48, 44,	 64, 52, 44,	 64, 60, 44,
	 64, 64, 44,	 60, 64, 44,	 52, 64, 44,	 48, 64, 44,
	 44, 64, 44,	 44, 64, 48,	 44, 64, 52,	 44, 64, 60,
	 44, 64, 64,	 44, 60, 64,	 44, 52, 64,	 44, 48, 64,
	255,255,255,	255,255,255,	255,255,255,	255,255,255,
	255,255,255,	255,255,255,	255,255,255,	255,255,255,
}
#endif
;

EXTERN uchar crosshairs[16*16]
#ifdef	VGAPAINT_MAIN
={
	0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	2,1,2,1,2,1,0,0,0,1,2,1,2,1,2,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
}
#endif
;

EXTERN uchar eyedropper[16*16]
#ifdef	VGAPAINT_MAIN
={
	0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,
	0,0,0,0,0,0,0,0,0,0,0,2,1,1,2,0,
	0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,2,
	0,0,0,0,0,0,0,0,0,2,1,1,1,1,1,2,
	0,0,0,0,0,0,0,0,2,1,1,1,1,1,2,0,
	0,0,0,0,0,0,0,2,1,1,1,1,1,2,0,0,
	0,0,0,0,0,0,2,1,1,1,1,1,2,0,0,0,
	0,0,0,0,0,0,2,1,1,1,1,2,0,0,0,0,
	0,0,0,0,0,2,0,2,1,1,2,0,0,0,0,0,
	0,0,0,0,2,0,0,0,2,2,0,0,0,0,0,0,
	0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,
	0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,
	0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,
	0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,
	2,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,
	0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
}
#endif
;

EXTERN	uchar packmem[768];
EXTERN	char	*program_name;

/* options word */

EXTERN struct Options {
	flag	be_square:1,	/* adjust aspect ratio to .9 */
		reptdraw:1, 	/* repeat draw toggle */
		are_repting:1,	/* repeating this time? */
		gamma_adjust:1,	/* adjust colors in vid_xxxRGB6 for gamma? */
		brushflickerfree:1,	/* flickerfree brush */
		autotransp:1,	/* brush auto-transparency */
		advanced_capture:1,	/* what do you think!? */
		scr_captured:1,	/* a screen was captured in-shell */
		VESACapt:1,
		coords:1,
		CPUhog:1,
		wimp_mode:1,		// wimp mode: nothing adventurous
		nodirect_pal:1,		// don't use direct palette writes
		noVESA:1,		// don't allow VESA modes
		noHack:1,		// don't allow hacked modes
		stdVGAonly:1,		// don't allow the 'okay' modes (Mode X)
		useLFN:1,		// use Win95 Long FileNames
		adjustBrush,		// adjust brush bounds for grid
		reqImageDrag:1,		// image drag
		noVESA20:1,		// don't use VESA 2.0 extended options
		noVESA32bit:1,		// don't use VESA 32-bit protected mode switch functions
		noVESA_LFB:1,		// don't use a Linear Frame Buffer
		noVESAmodesearch:1,	// don't query video BIOS for modes
		releaseTest:1,		// disable debugging options despite "Athena=1" in vp386.ini
		debugOpts:1,		// enable debugging options (Athena=1)
		useHiresTools:1,	// use high resolution tools
		usedirectVGA:1,		// use direct VGA manipulation
		fastPreview:1,
		tile_zoom:1,
		logging:1;
} opt
#ifdef VGAPAINT_MAIN
={ 1,0,0,0,0,0,0,0,0,0,0 };
#endif
;

EXTERN struct SystemFlags {
	flag	realDPMI:1,		// are we using a real DPMI interface, or DOS/4GW's poor excuse for one?
		VESA:1,			// Is a VESA compatible BIOS installed?
		VESA2_0:1,		// Do we have VESA 2.0 for protected mode support?
		MTask:1,		// Are we under a multitasking enviro?
		Windows:1,		// Are we under Windows(tm)? (shudder)
		Win95:1,		// Are we under Windows 95(tm)? (ack)
		LinuxDOSEMU:1;		// running under Linux DOSEMU?
} sys
#ifdef VGAPAINT_MAIN
={ 0 };	// set all zero
#endif
;

EXTERN struct ModeState {
	int	requester_count;
} state
#ifdef	VGAPAINT_MAIN
={ 0 }
#endif
;

#define	DC_NORMAL	(0)
#define	DC_RANGEFORW	(1)
#define	DC_RANGEBACK	(2)

EXTERN boolean	restore_scrn INIT(FALSE);	/* restore the screen */
EXTERN boolean	dabort INIT(FALSE);	/* abort current drawing function */
EXTERN color	dcolr;				/* current drawing color */
EXTERN uchar	dcolrp;				/* current drawing color 'pointer' */
EXTERN int	dcstrip	INIT(0);		// current ccycling strip
EXTERN int	dcrange	INIT(0);		// current ccycling range
EXTERN int	dcmode	INIT(DC_NORMAL);	/* drawing color mode */

#define	FILL_NORMAL	(0)
#define	FILL_TILE	(1)
#define	FILL_STRETCH	(2)

EXTERN int	fillmode INIT(FILL_NORMAL);	/* filling mode */
EXTERN int	fill_ccrange	INIT(0);	/* color range used for gradient fills */

#define	LMODE_NORMAL	(0)
#define	LMODE_ANTIALIAS	(1)
#define	LMODE_AABLEND	(2)

EXTERN int	linemode;			// line mode

#define	BMODE_NORMAL	(0)
#define	BMODE_ADD	(1)
#define	BMODE_TRANSP	(2)
#define	BMODE_SHADE	(3)

EXTERN int	blitmode;			// drawing blit mode

#define	RDCMODE_ADAPTIVE	(0)
#define	RDCMODE_6x7x6A		(1)
#define	RDCMODE_6x7x6		(2)
#define	RDCMODE_6x6x6		(3)

#define	RDPMODE_TOP		(0)
#define	RDPMODE_BOTTOM		(1)

#define	RDDMODE_NONE		(0)
#define	RDDMODE_FINE		(1)
#define	RDDMODE_COARSE		(2)
#define	RDDMODE_FS		(3)

EXTERN int	reduce_mode INIT(RDCMODE_ADAPTIVE);
EXTERN int	reduceplace_mode INIT(RDPMODE_TOP);
EXTERN int	reducedither_mode INIT(RDDMODE_NONE);
EXTERN int	reduce_maxcol INIT(256);

EXTERN uchar	palset[256];			// current palette "set"

/* monitor gamma adjustment */

EXTERN uchar monitor_gamma[256*3];	/* forward translation: red then green then blue */
EXTERN uchar bitmap_gamma[64*3];	/* backward translation: red then green then blue */
EXTERN uchar monitor_redigamma INIT(64);	/* red gamma slider value */
EXTERN uchar monitor_grnigamma INIT(64);	/* green gamma slider value */
EXTERN uchar monitor_bluigamma INIT(64);	/* blue gamma slider value */
EXTERN double	monitor_rgamma INIT(1.0);
EXTERN double	monitor_ggamma INIT(1.0);
EXTERN double	monitor_bgamma INIT(1.0);
EXTERN uchar *paltrnmem;		// palette translation memory
EXTERN ushort paltrndesc;

EXTERN	color	dinvert;		/* drawing invert color */

/* real mode memory */

EXTERN void *	realmem		INIT(NULL);	/* real mode memory */
EXTERN char *	realtmp		INIT(NULL);	// 512b temporary buffer
EXTERN ushort	realdsc		INIT(0);	/* real mode memory descriptor */

/* gridding control */

struct GridControl {
	long xoff,yoff;
	ulong xspc,yspc;
};

EXTERN struct GridControl grid
#ifdef	VGAPAINT_MAIN
={
	0,0,8,8
}
#endif
;

// drawing tool selection

enum DrawingTool {
	DTOOL_DOTDRAW	= 0,
	DTOOL_LINEDRAW	= 1,
	DTOOL_LINE	= 2,
	DTOOL_CURVE	= 3,
	DTOOL_FILL	= 4,
	DTOOL_SPRAY	= 5,
	DTOOL_RECT	= 6,
	DTOOL_CIRCLE	= 7,
	DTOOL_ELLIPSE	= 8,
	DTOOL_POLYGON	= 9,
	DTOOL_BRUSH	= 10,
	DTOOL_TEXT	= 11,
	DTOOL_GRID	= 12,
	DTOOL_MIRRORS	= 13,
	DTOOL_MAGNIFY	= 14,
	DTOOL_ZOOM	= 15,
	DTOOL_UNDO	= 16,
	DTOOL_CLEAR	= 17
};

#define	DTOOL_DBL	(0x100)

// auxiliary rectangles to ease programming

EXTERN struct RectBound	palrect_large;

// helpfile

EXTERN struct HelpFileHandle *vp386_helpfile INIT(NULL);

/******** function prototypes ********/

int	CheckKeyInterrupt(void);

void	snapToGrid(mouse_coord *x,mouse_coord *y,int xo,int yo);
void	mouse_read_draw(mouse_coord *x,mouse_coord *y,mouse_coord *b,int flags);
void	draw_color_shift(void);

/* external in Polygon.c and Fill.c and Palette.c */

TOOL	doFloodFill,doFillPolygon;
void	DoPalette(void);

/* parameter parsing */

void	ParamParse(int argc,char **argv,char *inistr);

/* version checking */

void	check_for_bozo_alteration(void);
void	print_copyright();


void	SelectVideoDriver(void);

void	Log(ulong logstr_num,...);

#undef	EXTERN
#undef	INIT

#endif
