#ifndef	VGAPAINT_VIDEOS_H
#define	VGAPAINT_VIDEOS_H

#include "video.h"

#ifdef	VGAPAINT_VIDEOS_C
#define	EXTERN
#define	INIT(x)	=x
#else
#define	EXTERN extern
#define	INIT(x)
#endif

struct FastPick {
	uchar			*fplum;		// luminance interpolation table
	struct FastPickEntry	*fpent;		// entries to colors
};

struct FastPickEntry {
	uchar r,g,b,index;
	ushort lum;
	uchar y,z;
};

struct FillDriver {
	boolean	(*init)(BMP,coord,coord,BMP,long,long);
	void	(*dispose)(void);
	void	(*rec_hline)(coord,coord,coord);
	void	(*map_init)(void);
	void	(*map_hline)(BMP,BMP,coord,coord,coord);
};

void	vid13_sfill_rec_hline(coord,coord,coord);
void	vid13_sfill_map_init(void);
boolean	vid13_sfill_hinit(BMP,coord,coord,BMP,long,long);
boolean	vid13_sfill_vinit(BMP,coord,coord,BMP,long,long);
boolean	vid13_sfill_init(BMP,coord,coord,BMP,long,long);
boolean	vid13_hgradient_init(BMP,coord,coord,BMP,long,long);
boolean	vid13_vgradient_init(BMP,coord,coord,BMP,long,long);
void	vid13_sfill_dispose(void);
void	vid13_stretch_map_hline(BMP,BMP,coord,coord,coord);
void	vid13_stretch_blend_map_hline(BMP,BMP,coord,coord,coord);
void	vid13_hgradient_map_hline(BMP,BMP,coord,coord,coord);
void	vid13_vgradient_map_hline(BMP,BMP,coord,coord,coord);

void	vid_antialias_line(struct BitMap *dst,coord x1,coord y1,coord x2,coord y2,color f,color b,boolean blend);
void	vid_antialias_plot(struct BitMap *dst,coord x,coord y,ulong fgcol,ulong bgcol,ulong cv,boolean blend);
void	vid_antialias_circle(struct BitMap *dst,coord x,coord y,coord r,color f,color b,boolean blend);
void	vid_antialias_ellipse(struct BitMap *dst,coord x,coord y,coord a,coord b,color fc,color bc,boolean blend,boolean fill);

int	FPick_QCompare(const struct FastPickEntry *,const struct FastPickEntry *);
struct FastPick *FPick_Allocate(ushort colors);
void	FPick_Free(struct FastPick *);
void	FPick_Initialize(struct FastPick *,ushort,ushort,uchar *);
uchar	FPick_Choose(struct FastPick *,ushort,uchar,uchar,uchar);

void	vid13_grey(BMP dst,coord x1,coord y1,coord xs,coord ys,color pri,color sec);

EXTERN struct FillDriver vs_drivers[]
#ifdef	VGAPAINT_VIDEOS_C
={
	{
		&vid13_sfill_init,
		&vid13_sfill_dispose,
		&vid13_sfill_rec_hline,
		&vid13_sfill_map_init,
		&vid13_stretch_map_hline
	},
	{
		&vid13_sfill_init,
		&vid13_sfill_dispose,
		&vid13_sfill_rec_hline,
		&vid13_sfill_map_init,
		&vid13_stretch_blend_map_hline
	},
	{	NULL,NULL,NULL,NULL,NULL	},
	{	NULL,NULL,NULL,NULL,NULL	},
	{
		&vid13_hgradient_init,
		&vid13_sfill_dispose,
		&vid13_sfill_rec_hline,
		&vid13_sfill_map_init,
		&vid13_hgradient_map_hline
	},
	{	
		&vid13_vgradient_init,
		&vid13_sfill_dispose,
		&vid13_sfill_rec_hline,
		&vid13_sfill_map_init,
		&vid13_vgradient_map_hline
	}
}
#endif
;

EXTERN struct FillDriver *vsd INIT(&vs_drivers[0]);

#undef	EXTERN
#undef	INIT
#endif

