#define	VGAPAINT_VIDEOX_C

#include <conio.h>

#include "videox.h"
#include "vgadecod.h"

#pragma off (check_stack)

boolean	vid13x_init(enum VD_InitCode vdic,long x,long y) {
	static char videox_size;
	void *realvm;
	boolean double_it,max_timing_x,max_timing_y;
	uchar htotal,hsync,of;
	int ysize;

	//////////////

	switch(vdic) {
	case VD_STARTUP:
		vds=&vd13xspecs;
		vidbm.vm=NULL;
		if (!(realvm=malloc(320*200))) return FALSE;
		vid_initBitMap(&vidbm,(uchar *)realvm,0,0,320,200,320,piccol);
	case VD_REINIT:
	case VD_FROM13:
		vid_setmode(0x13);

		x=(vidbm.width+3) & 0xFFFFFFFC;

		double_it = vidbm.height>(videox_size&2 ? 240 : 200);

		vdrv_cur->y_aspect = y_aspect = ((vidbm.height>=400) ? 2 : 1);

		if (double_it) {
			y=vidbm.height-1;
			x_ratio = vdrv_cur->x_ratio>>1;
			y_ratio = vdrv_cur->y_ratio<<1;
			SetSystemFont(sys6x16);
		} else {
			y=(vidbm.height<<1)-1;
			x_ratio = vdrv_cur->x_ratio;
			y_ratio = vdrv_cur->y_ratio;
			SetSystemFont(NULL);
		}

		// reconfigure vga

		vid_initBitMap(&realvidbm,(uchar *)0xA0000,0,0,x,vidbm.height,((x>>2)+1)&~1,piccol);	/* the bpr is funny but necessary */
		vidbm.syncrect=TRUE;
		vidbm.syncx1=vidbm.syncy1=0x7FFF;
		vidbm.syncx2=vidbm.syncy2=-0x8000;
		disable();
		outportb(0x3d4,0x14);
		outportb(0x3d5,0);
		outportb(0x3d4,0x17);
		outportb(0x3d5,0xe3);
		outportb(0x3c4,4);
		outportb(0x3c5,6);
		outportb(0x3d4,0x11);
		outportb(0x3d5,inportb(0x3d5) & 0x7f);
		outportb(0x3d4,0x01);
		outportb(0x3d5,(x>>2)-1);
		outportb(0x3d4,0x12);
		outportb(0x3d5,y & 0xFF);
		outportb(0x3d4,0x13);
		outportb(0x3d5,((x>>2)+1)>>1);	/* offset is in WORDS */
		outportb(0x3d4,0x07);
		outportb(0x3d5,(inportb(0x3d5) & 0xBD) + (y&0x100 ? 2 : 0) + (y&0x200 ? 64 : 0));

		if (double_it) { outp(0x3d4,0x09); outp(0x3d5,inp(0x3d5) & 0x60); }

		// special Mode X parameters obtained from Mode X routines by Matt Pritchard

		outp(0x3d4,17); outp(0x3d5,inp(0x3d5) & 0x7f);		// turn off write protect
		if (videox_size & 1) {	// big X
			outp(0x3c2,(inp(0x3cc) & 0xF3) + 4);		// misc - go to 28MHz clock
			outp(0x3d4,0x00); outp(0x3d5,inp(0x3d5)+12);	// horiz total
			outp(0x3d4,0x02); outp(0x3d5,inp(0x3d5)+10);	// start horiz blanking
			outp(0x3d4,0x03); outp(0x3d5,inp(0x3d5)+10);	// end horiz blanking
			outp(0x3d4,0x04); outp(0x3d5,inp(0x3d5)+10);	// start horiz sync
			outp(0x3d4,0x05); outp(0x3d5,inp(0x3d5)+10);	// end horiz sync
		};
		if (videox_size & 2) {	// big Y
			int x,y;

			outp(0x3c2,inp(0x3cc) | 0xC0);			// misc - go to 480 line density on monitor
			outp(0x3d4,0x06); y=(uchar)inp(0x3d5);		// get vertical total
			outp(0x3d4,0x07); x=inp(0x3d5);
			if (x&1) y+=256; if (x&32) y+=512;
			y += 0x4e;					// add 78 lines
			x&=0xDE;
			if (y&256) x|=1; if (y&512) x|=32;
			outp(0x3d4,0x06); outp(0x3d5,(uchar)y);		// set vertical total & overflow bits
			outp(0x3d4,0x07); outp(0x3d5,x);
			outp(0x3d4,0x10); outp(0x3d5,inp(0x3d5)+0x4e);	// set vertical sync start
			outp(0x3d4,0x11); x=inp(0x3d5);
				outp(0x3d5,(x&0xF0)+((x+0x4e)&0x0F));	// set vertical sync end
			outp(0x3d4,0x15); outp(0x3d5,inp(0x3d5)+0x51);	// set vertical blank start
			outp(0x3d4,0x16); outp(0x3d5,inp(0x3d5)+0x4d);	// set vertical blank end
		};

		// set the maximum video size

		outp(0x3d4,2);		vd13xspecs.o_vidx = inp(0x3d5)*4;
		outp(0x3d4,7);		if (inp(0x3d5) & VGA_OVERFLOW_VBLSTART8) ysize=256; else ysize=0;
		outp(0x3d4,9);		if (inp(0x3d5) & 0x20) ysize+=512;
		outp(0x3d4,21);		ysize += (ulong)inp(0x3d5);
		vd13xspecs.o_vidy = ysize;

		// compute "maximum" parameters by reading retrace widths

		{
			ulong	htotal,vtotal;
			uchar	hrtr_start,hrtr_end;
			ulong	vrtr_start,vrtr_end;
			uchar	ov;
			int	bump;

			// read horizontal total and retrace interval

			outp(0x3d4,0);	htotal=(ulong)inp(0x3d5)+5;
			outp(0x3d4,4);	hrtr_start = inp(0x3d5);
			outp(0x3d4,5);	hrtr_end = (hrtr_start&0xe0)+(inp(0x3d5)&0x1f); if (hrtr_end<=hrtr_start) hrtr_end+=0x20;

			vd13xspecs.o_maxx = (htotal - (hrtr_end+2-hrtr_start))<<2;

			// read vertical total and retrace interval

			outp(0x3d4,7);	ov = inp(0x3d5);
			outp(0x3d4,6);	vtotal = (ulong)inp(0x3d5)	+ (ov & VGA_OVERFLOW_VTOTAL8 ? 256 : 0)
									+ (ov & VGA_OVERFLOW_VTOTAL9 ? 512 : 0);
			outp(0x3d4,21);	vrtr_start = (ulong)inp(0x3d5)	+ (ov & VGA_OVERFLOW_VRETRACE8 ? 256 : 0)
									+ (ov & VGA_OVERFLOW_VRETRACE9 ? 512 : 0);
			outp(0x3d4,22);	vrtr_end = (vrtr_start & 0xfffffff0) + ((ulong)inp(0x3d5)&0x0f);
					if (vrtr_end <= vrtr_start) vrtr_end += 0x10;

			vd13xspecs.o_maxy = vtotal - (vrtr_end+2-vrtr_start);
		}

		max_timing_x = (x>vd13xspecs.o_vidx);
		max_timing_y = (y>=vd13xspecs.o_vidy);

		// if we need to go to max timing, then:
		// 1) push the retrace intervals as close to the display starts as possible
		// 2) shrink blank intervals to be the same as the retrace intervals

		if (max_timing_x) {
			ulong	htotal;
			uchar	hrtr_start,hrtr_end;
			int	bump;

			// read horizontal total and retrace interval

			outp(0x3d4,0);	htotal=(ulong)inp(0x3d5)+5;
			outp(0x3d4,4);	hrtr_start = inp(0x3d5);
			outp(0x3d4,5);	hrtr_end = (hrtr_start&0xe0)+(inp(0x3d5)&0x1f); if (hrtr_end<=hrtr_start) hrtr_end+=0x20;

			// check how much we need to move the intervals

			bump = (htotal - (x>>2) - (hrtr_end+1-hrtr_start))>>1;
			hrtr_start	= htotal - (hrtr_end+2-hrtr_start) - bump;
			hrtr_end	= (htotal-2-bump)&0x1f;

			// horizontal retrace interval read, move it and write it to hblank also

			outp(0x3d4,2);	outp(0x3d5,hrtr_start);
			outp(0x3d4,3);	outp(0x3d5,(inp(0x3d5)&0xe0)+hrtr_end);
			outp(0x3d4,4);	outp(0x3d5,hrtr_start);
			outp(0x3d4,5);	outp(0x3d5,(inp(0x3d5)&0xe0)+hrtr_end);
		}
		if (max_timing_y) {
			ulong	vtotal;
			ulong	vrtr_start,vrtr_end;
			uchar	ov;
			int	bump;

			// read vertical total and retrace interval

			outp(0x3d4,7);	ov = inp(0x3d5);
			outp(0x3d4,6);	vtotal = (ulong)inp(0x3d5)	+ (ov & VGA_OVERFLOW_VTOTAL8 ? 256 : 0)
									+ (ov & VGA_OVERFLOW_VTOTAL9 ? 512 : 0);
			outp(0x3d4,21);	vrtr_start = (ulong)inp(0x3d5)	+ (ov & VGA_OVERFLOW_VRETRACE8 ? 256 : 0)
									+ (ov & VGA_OVERFLOW_VRETRACE9 ? 512 : 0);
			outp(0x3d4,22);	vrtr_end = (vrtr_start & 0xfffffff0) + ((ulong)inp(0x3d5)&0x0f);
					if (vrtr_end <= vrtr_start) vrtr_end += 0x10;

			bump = (vtotal - (y+1) - (vrtr_end+1-vrtr_start))>>1;
			vrtr_start = vtotal - (vrtr_end+2-vrtr_start) - bump;
			vrtr_end = vtotal - 2 - bump;

			ov &= ~(VGA_OVERFLOW_VRETRACE8 + VGA_OVERFLOW_VRETRACE9 + VGA_OVERFLOW_VBLSTART8);
			if (vrtr_start & 0x100)	ov |= VGA_OVERFLOW_VRETRACE8 | VGA_OVERFLOW_VBLSTART8;
			if (vrtr_start & 0x200) ov |= VGA_OVERFLOW_VRETRACE9;
			outp(0x3d4,21);	outp(0x3d5,vrtr_start & 0xff);
			outp(0x3d4,22); outp(0x3d5,(inp(0x3d5) & 0xf0) | (vrtr_end & 0x0f));
			outp(0x3d4,16);	outp(0x3d5,vrtr_start & 0xff);
			outp(0x3d4,17); outp(0x3d5,(inp(0x3d5) & 0xf0) | (vrtr_end & 0x0f));
			outp(0x3d4,9);	outp(0x3d5,(inp(0x3d5) & 0xdf) + (vrtr_start&0x200?0x20:0));
		}

		outp(0x3d4,17); outp(0x3d5,inp(0x3d5) | 0x80);		// turn on write protect

		enable();
		maxclr = 256;

		break;
	case VD_CLOSEDOWN:
	case VD_TO13:
		disable();
		outportb(0x3d4,0x14);
		outportb(0x3d5,0x40);
		outportb(0x3d4,0x17);
		outportb(0x3d5,0xa3);
		outportb(0x3c4,4);
		outportb(0x3c5,14);
		enable();
		if (vdic==VD_CLOSEDOWN)
			if (vidbm.vm) free(vidbm.vm);
		break;
	case VD_RESIZE:
		x=(x+3) & 0xFFFFFFFC;
		free(vidbm.vm);
		if (!(realvm=malloc(x*y))) return FALSE;
		vid_initBitMap(&vidbm,(uchar *)realvm,0,0,x,y,x,piccol);

		vid13x_init(VD_FROM13,0,0);

		clipReset();
		mouse_bounds_reset();
		break;
	case VD_SETSIZE:
		videox_size = y;
		break;
	case VD_INITMAXSIZE:
		break;			// i'll make this later
	};
	return TRUE;
}

void	vid13x_rhline(coord x,coord y,uchar *dm1,coord xs) {
	uchar *vm1,*vm2;
	uchar *dm2;
	uchar p,xso;
	coord xst;

	vm1=(uchar *)0xA0000+(x>>2)+y*realvidbm.bpr;
	xso = xs&3;
	xs>>=2;
	dm1 -= (x & 3);

	for(p=0;p<4;p++) {
		outportb(0x3c4,2);
		outportb(0x3c5,1<<p);
		vm2=vm1;
		dm2=dm1++;
		xst=xs;
		if (p<(x&3)) {
			++vm2;
			dm2 += 4;
		};
		if (((p-x)&3)<xso) ++xst;
		if (xst)
			do {
				*vm2++=*dm2++;
				dm2+=3;
			} while(--xst);
	};
}

void	vid13x_rhlineread(coord x,coord y,uchar *dm1,coord xs) {
	uchar *vm1,*vm2;
	uchar *dm2;
	uchar p,xso;
	coord xst;

	vm1=(uchar *)0xA0000+(x>>2)+y*realvidbm.bpr;
	xso = xs&3;
	xs>>=2;
	dm1 -= (x & 3);

	for(p=0;p<4;p++) {
		outportb(0x3ce,4);
		outportb(0x3cf,p);
		vm2=vm1;
		dm2=dm1++;
		xst=xs;
		if (p<(x&3)) {
			++vm2;
			dm2 += 4;
		};
		if (((p-x)&3)<xso) ++xst;
		if (xst)
			do {
				*dm2++=*vm2++;
				dm2+=3;
			} while(--xst);
	};
}

uchar *vid13x_rbitblt_asm1(uchar *src,uchar *dst,ulong cnt);
#pragma aux vid13x_rbitblt_asm1 =	\
	"x:",				\
	"mov al,[esi+8]",		\
	"mov ah,[esi+12]",		\
	"rol eax,16",			\
	"add edi,4",			\
	"mov al,[esi]",			\
	"mov ah,[esi+4]",		\
	"add esi,16",			\
	"dec ecx",			\
	"mov [edi-4],eax",		\
	"jne x"				\
	parm [esi] [edi] [ecx] modify exact [eax ecx esi edi] value [edi];

void	vid13x_rbitblt(coord x,coord y,coord xs,coord ys,uchar *dm1,long dmod,boolean no_offset) {
	uchar *vm1,*vm2;
	uchar *dm2;
	uchar p;
	long vmod;
	coord xst,yst;

	if (xs<=0) return;
	if (ys<=0) return;

	xs=(xs+3+(x&3))>>2;
	x&=0xFFFFFFFC;

	vm1=(uchar *)0xA0000+(x>>2)+y*realvidbm.bpr;
	if (!no_offset) dm1+=x+y*vidbm.bpr;

	vmod=realvidbm.bpr-xs;
	dmod-=(xs<<2);
	if(vmod<0 || dmod<0) exit(5);

	for(p=1;p<16;p+=p) {
		outportb(0x3c4,2);
		outportb(0x3c5,p);
		vm2=vm1;
		dm2=dm1++;
		yst=ys;
		do {
#if 0
			xst=xs;
			do {
				*vm2++=*dm2++;
				dm2+=3;
			} while(--xst);
#else
			if (xs>>2) {
				vm2 = vid13x_rbitblt_asm1(dm2,vm2,xs>>2);
				dm2 += (xs>>2)<<4;
			}
			xst = xs&3;
			if (xst) do { *vm2++ = *dm2; dm2+=4; } while (--xst);
#endif
			vm2+=vmod;
			dm2+=dmod;
		} while(--yst);
	};
}

/* be very careful with the pointer functions -- they are called
** when SS != DS, and ES != DS.  That means use qmovebes() and no
** pointers to automatic variables. */

#pragma off (check_stack)

static	uchar	v13x_ms_plane;

void	vid13x_drawptr(struct MousePointerInfo *mpi,coord x,coord y) {
	uchar *vm1=(uchar *)0xA0000,*vm2;
	uchar *dm1=mpi->image,*dm2;
	uchar *bm1=mpi->backup;
	ushort xh=mpi->s_width,yh=mpi->s_height;
	ushort yht;
	ulong vmod;
	uchar c,p;

	if (x>=0)	vm1+=(x>>2);
	if (y>=0)	vm1+=(y*realvidbm.bpr);
	mpi->vdp=vm1;

	if (y<0) {
		yh=mpi->s_height+y;
		dm1-=y*mpi->s_width;
	} else if (y>(vidbm.height-mpi->s_height)) yh=vidbm.height-y;

	if (x<0) {
		xh+=x;
		dm1-=x;
		x=0;
	} else if (x>(vidbm.width-mpi->s_width)) xh=vidbm.width-x;

	mpi->width=xh;
	mpi->height=yh;

	if (xh<=0) return;
	if (yh<=0) return;

	vmod=realvidbm.bpr;
	v13x_ms_plane=p=1<<(x & 3);

	outportb(0x3ce,5);
	outportb(0x3cf,inportb(0x3cf) & 0xF7);	/* use read mode 0 */

	do {
		outportb(0x3c4,2);	/* sequencer set write mask */
		outportb(0x3c5,p);
		outportb(0x3ce,4);	/* set read plane */
		outportb(0x3cf,x++ & 3);
		vm2=vm1;
		if ((p+=p)==16) {
			p=1;
			vm1++;
		};
		dm2=dm1++;
		yht=yh;
		do {
			*bm1++=*vm2;
			if (c=*dm2) *vm2=(c-1 ? mpi->high : mpi->low);
			dm2+=mpi->s_width;
			vm2+=vmod;
		} while(--yht);
	} while(--xh);
}

void	vid13x_eraseptr(struct MousePointerInfo *mpi) {
	uchar *vm1=mpi->vdp,*vm2;
	uchar *dm=mpi->backup;
	uchar p;
	ulong vbpr;
	ushort xs,ys,yst;

	if ((xs=mpi->width)<=0) return;
	if ((ys=mpi->height)<=0) return;

	vbpr=realvidbm.bpr;

	p=v13x_ms_plane;

	do {
		outportb(0x3c4,2);
		outportb(0x3c5,p);
		vm2=vm1;
		if ((p+=p)==16) {
			p=1;
			vm1++;
		};
		yst=ys;
		do {
			*vm2=*dm++;
			vm2+=vbpr;
		} while(--yst);
	} while(--xs);
}

#pragma on (check_stack)

