/* Mode X Zoom routines */

#define	VGAPAINT_VIDEOZ_C
#include "videoz.h"
#include "video.h"
#include "asmfunc.h"
#include "vgapaint.h"
#include "picture.h"

void vidZblitzoom(BMP src,coord x1,coord y1,BMP dst,coord x2,coord y2,coord xs,coord ys) {
	uchar *vm1,*vm2;
	long modulo1,modulo2;

	vid_tap_rect(dst,x2,y2,xs*zoom_x,ys*zoom_y);
	modulo1=src->bpr;
	modulo2=dst->bpr;
	vm1=src->vm+y1*src->bpr+x1;
	vm2=dst->vm+y2*dst->bpr+x2;

	// all ops must be _before_ this point

	if (!opt.tile_zoom) {
		if (zoom_x == zoom_y) {
			switch(zoom_x) {
			case 1:
				rectcopy(vm2,modulo2,vm1,modulo1,xs,ys);
				return;
			case 2:
				asm_2xblit_fwd(vm2,modulo2,vm1,modulo1,xs,ys);
				return;
			case 4:
				asm_4xblit_fwd(vm2,modulo2,vm1,modulo1,xs,ys);
				return;
			case 8:
				asm_8xblit_fwd(vm2,modulo2,vm1,modulo1,xs,ys);
				return;
			case 16:
				asm_16xblit_fwd(vm2,modulo2,vm1,modulo1,xs,ys);
				return;
			}
		}

//		vid13_scale(src,x1,y1,xs,ys,dst,x2,y2,xs*zoom_x,ys*zoom_y);

		{
			ulong xst;
			ulong cp4 = zoom_x>>2;
			uchar cp1 = zoom_x&3;
			uchar row;
			uchar *vm1t;
			ulong i;
			ulong c;

			modulo2 -= xs*zoom_x;

			do {
				row = zoom_y;
				do {
					vm1t = vm1;
					xst = xs;
					do {
						c = expand8to32(*vm1t++);

						i = cp4;
						if (i) 	do {
								*(ulong *)vm2 = c;
								vm2 += sizeof(ulong);
							} while(--i);

						i = cp1;
						if (i) do *vm2++=c; while(--i);
					} while(--xst);

					vm2 += modulo2;

				} while(--row);
				vm1 += modulo1;
			} while(--ys);
		}
	} else {
		coord	xst;
		int	t;
		uchar	*tile;
		uchar	*tilemem = pict_spare->bm->vm;

		if (zoom_x==zoom_y && !(zoom_x & (zoom_x-1))) {
			modulo1 -= xs;
			modulo2 = (modulo2 - xs)*min(zoom_x,zoom_y);

			while(ys--) {
				xst = xs;
				switch(zoom_x) {
				case 2:
					#define copy(a)	\
						*(uchar *)(vm2 + a*dst->bpr + 0) = tile[ 0+256*8*a];	\
						*(uchar *)(vm2 + a*dst->bpr + 1) = tile[ 8+256*8*a];

					while(xst--) {
						t = *vm1++;
						tile = tilemem + ((t&15)<<4)+256*16*(t>>4);
						copy(0);
						copy(1);
						vm2 += 2;
					}

					#undef copy

					break;
				case 4:
					#define copy(a)	\
						*(uchar *)(vm2 + a*dst->bpr + 0) = tile[ 0+256*4*a];	\
						*(uchar *)(vm2 + a*dst->bpr + 2) = tile[ 8+256*4*a];	\
						*(uchar *)(vm2 + a*dst->bpr + 1) = tile[ 4+256*4*a];	\
						*(uchar *)(vm2 + a*dst->bpr + 3) = tile[12+256*4*a];

					while(xst--) {
						t = *vm1++;
						tile = tilemem + ((t&15)<<4)+256*16*(t>>4);
						copy(0);
						copy(1);
						copy(2);
						copy(3);
						vm2 += 4;
					}

					#undef copy

					break;
				case 8:
					#define copy(a)	\
						*(uchar *)(vm2 + a*dst->bpr + 0) = tile[ 0+256*2*a];	\
						*(uchar *)(vm2 + a*dst->bpr + 4) = tile[ 8+256*2*a];	\
						*(uchar *)(vm2 + a*dst->bpr + 1) = tile[ 2+256*2*a];	\
						*(uchar *)(vm2 + a*dst->bpr + 5) = tile[10+256*2*a];	\
						*(uchar *)(vm2 + a*dst->bpr + 2) = tile[ 4+256*2*a];	\
						*(uchar *)(vm2 + a*dst->bpr + 6) = tile[12+256*2*a];	\
						*(uchar *)(vm2 + a*dst->bpr + 3) = tile[ 6+256*2*a];	\
						*(uchar *)(vm2 + a*dst->bpr + 7) = tile[14+256*2*a];

					while(xst--) {
						t = *vm1++;
						tile = tilemem + ((t&15)<<4)+256*16*(t>>4);
						copy(0);
						copy(1);
						copy(2);
						copy(3);
						copy(4);
						copy(5);
						copy(6);
						copy(7);
						vm2 += 8;
					}

					#undef copy

					break;
				case 16:

					#define copy(a)	\
						*(ulong *)(vm2 + a*dst->bpr +  0) = *(ulong *)(tile+ 0+256*a);	\
						*(ulong *)(vm2 + a*dst->bpr +  4) = *(ulong *)(tile+ 4+256*a);	\
						*(ulong *)(vm2 + a*dst->bpr +  8) = *(ulong *)(tile+ 8+256*a);	\
						*(ulong *)(vm2 + a*dst->bpr + 12) = *(ulong *)(tile+12+256*a);

					while(xst--) {
						t = *vm1++;
						tile = tilemem + ((t&15)<<4)+256*16*(t>>4);
						copy(0);
						copy(1);
						copy(2);
						copy(3);
						copy(4);
						copy(5);
						copy(6);
						copy(7);
						copy(8);
						copy(9);
						copy(10);
						copy(11);
						copy(12);
						copy(13);
						copy(14);
						copy(15);
						vm2 += 16;
					}

					#undef copy

					break;
				}
				vm1 += modulo1;
				vm2 += modulo2;
			}
		} else {
			ulong	yaccum,yinc;
			ulong	xaccum,xinc;
			ulong	yconstinc;
			coord	xs2 = xs * zoom_x;
			coord	ys2 = ys * zoom_y;
			uchar	*tilemem2;

			modulo2 -= xs2;

			xinc = (0xfffffL+zoom_x*16)/zoom_x;
			yinc = (0xfffffL+zoom_y*16)/zoom_y;

			yconstinc = (yinc>>20)*modulo1;	yinc &= 0xfffff;

			yaccum = 0;
			do {
				tilemem2 = tilemem + 256*(yaccum>>16);

				xaccum = 0;
				xst = xs2;
				do {
					t = vm1[xaccum>>20];
					tile = tilemem2 + ((t & 15)<<4)+256*16*(t>>4);
					*vm2++ = tile[(xaccum>>16)&15];
					xaccum += xinc;
				} while(--xst);

				yaccum += yinc;
				vm1 += yconstinc;
				vm2 += modulo2;
				if (yaccum >= 0x100000L) {
					yaccum -= 0x100000L;
					vm1 += modulo1;
				}
			} while(--ys2);
		}
	}
}
