#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <a/types.h>

#include "list.h"
#include "inifile.h"
#include "io.h"

struct List VPALoadList;

boolean	vp_ini_assigner(char *line) {
	char	linetmp[192];
	char	*name = linetmp;

	strcprocess(linetmp,line);

	// parse string; should be "assign-name: assign-path"

	while(*name && *name!=':') ++name;
	if (!*name) return FALSE;

	++name; while(*name && isspace(*name)) ++name;

	if (!*name) return FALSE;

	VPAssign(linetmp,name);

	return TRUE;
}

struct IniItem vp_ini_autoload[]={
	{ "AutoLoad"		,(long)&VPALoadList,0, 256,INI_DSTRLST,0,NULL },
	{NULL}
};

struct IniItem vp_ini_video[]={
	{ "RedGamma"		,0,0,0,INI_FLOAT,0,NULL	},
	{ "GreenGamma"		,0,0,0,INI_FLOAT,0,NULL	},
	{ "BlueGamma"		,0,0,0,INI_FLOAT,0,NULL	},
	{NULL}
};

struct IniItem vp_ini_options[]={
	{ "InitialModeRequester",0,0,0,INI_BOOL,0,NULL },
	{ "RequesterImageDrag",0,0,0,INI_BOOL,0,NULL },
	{ "Athena",0,0,0,INI_BOOL,0,NULL }, // don't ask
	{ "SmoothBalloons",0,0,0,INI_BOOL,0,NULL },
	{ "StartupOptions",0,0,256,INI_DSTRING,0,NULL },
	{NULL}
};

struct IniItem vp_ini_assigns[]={
	{ "Assign"		,(long)&vp_ini_assigner,0,0,INI_FUNCTION,0,NULL },
	{NULL}
};

struct IniItem vp_ini_prefs[]={
	{ "RepeatDraw"		,FALSE,0,0,INI_BOOL,0,FALSE	},
	{ "Coords"		,FALSE,0,0,INI_BOOL,0,FALSE	},
	{ "BeSquare"		,TRUE ,0,0,INI_BOOL,0,TRUE	},
	{ "AutoTransparency"	,FALSE,0,0,INI_BOOL,0,FALSE	},
	{ "AdjustBrushBounds"	,FALSE,0,0,INI_BOOL,0,FALSE	},
	{ "FlickerFreeBrush"	,FALSE,0,0,INI_BOOL,0,FALSE	},
	{ "HiresTools"		,FALSE,0,0,INI_BOOL,0,FALSE	},
	{ "ImitateWindows95"	,FALSE,0,0,INI_BOOL,0,FALSE	},
	{ "ScrollMode"		,FALSE,0,0,INI_BOOL,0,FALSE	},
	{ "FastPreview"		,FALSE,0,0,INI_BOOL,0,FALSE	},
	{ "PictureWidth"	,320,0,32768,INI_ULONG,0,320	},
	{ "PictureHeight"	,200,0,32768,INI_ULONG,0,200	},
	{ "StartVideoMode"	,NULL,0,256,INI_DSTRING,0,NULL	},
	{ "ScrollSpeed"		,0x10000L,0,0x7FFFFFFFL,INI_ULONG,0,0x10000L },
	{ "ReduceMode"		,0,0,1,INI_ULONG,0,0		},
	{NULL}
};

struct IniGroup vp_inigroups[]={
	{ "Extensions"		,vp_ini_autoload	},
	{ "Video"		,vp_ini_video		},
	{ "Options"		,vp_ini_options		},
	{ "Assigns"		,vp_ini_assigns		},
	{ "Prefs"		,vp_ini_prefs		},
	{NULL}
};

struct IniItem vp_ini_videodriver_opts[]={
	{ "RedGamma"		,0,0,0,INI_FLOAT,0,NULL },
	{ "GreenGamma"		,0,0,0,INI_FLOAT,0,NULL },
	{ "BlueGamma"		,0,0,0,INI_FLOAT,0,NULL },
	{ "UseGammaAdjustment"	,FALSE,0,0,INI_BOOL,0,FALSE },
	{NULL}
};

struct IniGroup vp_inigroup_videodriver[]={
	{ NULL			,vp_ini_videodriver_opts },
	{NULL}
};
