#define	VGAPAINT_ZONES_C
#include "vgapaint.h"
#include "zones.h"
#include "mouse.h"
#include "picture.h"

#define ZoneInside(z,x,y) ((x)>=(z)->x && (y)>=(z)->y && (x)<(z)->x+(z)->xs && (y)<(z)->y+(z)->ys)

void ZoneRefresh(struct ZoneRange *zr) {
	struct Zone *z;
	int ind;
	ulong tmp;

	while(zr) {
		z=zr->zonelist;
		ind=0;
		if (z)
			while(z->xs>0) {
				tmp=z->flags;
				if (!(tmp & ZN_DISABLED)) {
					if (z->flags & ZN_TEXTRENDER) {
						if (z->flags & ZN_SYSTEXT)
							SysText(zonebm,z->x+((z->xs-strlen(z->text)*sysfontwidth)>>1),
								z->y+((z->ys+1-sysfontheight)>>1),z->text,ST0,ST2);
						else
							vd->text6(zonebm,z->x+((z->xs-strlen(z->text)*6)>>1),z->y+((z->ys-7)>>1),z->text,ST0,ST2);
					}
					if (z->dispVec && !(z->flags & ZN_TEXTRENDER)) (*z->dispVec)(zr,z,ind,z->flags & ZN_FRAME);
					else if (tmp & ZN_INVERTED) {
						ZoneDraw(zr,z,ind);
						z->flags=tmp;
					} else if (tmp & ZN_3D) {
						z->flags |= ZN_INVERTED;
						ZoneErase(zr,z,ind);
						z->flags=tmp;
					}
				}
				z++;
				ind++;
			};
		if (zr->refVec)
			(*zr->refVec)(zr);
		zr=zr->next;
	};
	vd->refresh();
}

void ZoneDraw(struct ZoneRange *zr,struct Zone *z,int ind) {
	if (z->dispVec && !(z->flags & ZN_TEXTRENDER)) {
		ulong temp;
		temp=zr->doubleClick ? 2 : 1;
		(*z->dispVec)(zr,z,ind,temp);
		z->flags=(z->flags & ~ZN_FRAME)+temp;
	} else if (z->flags & ZN_3D) {
		rectI3D((struct Rectangle *)z);
		z->flags|=ZN_INVERTED;
	} else ZoneInvert(z);
}

void ZoneErase(struct ZoneRange *zr,struct Zone *z,int ind) {
	if (z->dispVec && !(z->flags & ZN_TEXTRENDER)) {
		(*z->dispVec)(zr,z,ind,0);
		z->flags &= ~ZN_FRAME;
	} else if (z->flags & ZN_INVERTED) 
		if (z->flags & ZN_3D) {
			rectD3D((struct Rectangle *)z);
			z->flags &= ~ZN_INVERTED;
		} else ZoneInvert(z);
}

void ZoneInvert(struct Zone *z) {
	mouse_hide();
	vd->bar(zonebm,z->x,z->y,z->xs,z->ys,0x80000000+STI);
	mouse_show();
	z->flags ^= ZN_INVERTED;
}

long ZoneRangeAct(struct ZoneRange *zr,coord x,coord y) {
	struct Zone *z;
	int index;
	long index2=0;

	while(zr) {
		z=zr->zonelist;
		index=0;
		if (z)
			while (z->xs>0) {
				if (!(z->flags & ZN_DISABLED))
					if (ZoneInside(z,x,y)) {
						ZoneHit(zr,z,index,x,y);
						return index2+index;
					}
				z++,index++;
			}
		index2+=0x10000;
		zr=zr->next;
	};
	return -1;
}

void ZoneDoHandlers(struct ZoneRange *zr,struct Zone *z,coord x,coord y,boolean rs) {
	if (!rs || !(z->flags & ZN_LEFTSPECIAL)) {
		if (z->cusVec) (*z->cusVec)(zr,z,x,y);
	}
	if (rs)
		if (z->rightVec)
			z->rightVec(zr,z,x,y);
}

void ZoneHit(struct ZoneRange *zr,struct Zone *z,int index,coord x,coord y) {
	struct Zone *z2;
	mouse_coord mx,my,mb;
	boolean rs=FALSE;
	uchar	save_frame;

	mouse_read2(&mx,&my,&mb);

	if (mb & 2)
		if (z->flags & ZN_RIGHTSPECIAL) {
			save_frame = z->flags & ZN_FRAME;
			rs=TRUE;
		}

	switch(rs ? ZR_TAP : (zr->flags & ZR_TYPEMASK)) {
	case ZR_CHOICE:
		if (z!=(z2=zr->highlighted)) {
			zr->doubleClick=FALSE;
			ZoneDraw(zr,zr->highlighted=z,index);
			if (z->flags & ZN_INSTANT) ZoneDoHandlers(zr,z,x,y,rs);
			mouse_wait_unkey();
			if (z2) ZoneErase(zr,z2,zr->highindex);
			zr->highindex=index;
		} else {
			zr->doubleClick=!zr->doubleClick;
			ZoneDraw(zr,z,index);
			mouse_wait_unkey();
		};
		break;
	case ZR_TOGGLE:
		if (z->flags & ZN_INVERTED) ZoneErase(zr,z,index);
		else	ZoneDraw(zr,z,index);
		if (z->flags & ZN_INSTANT) ZoneDoHandlers(zr,z,x,y,rs);
		mouse_wait_unkey();
		break;
	case ZR_TAP:
		ZoneDraw(zr,z,index);
		if (z->flags & ZN_INSTANT) ZoneDoHandlers(zr,z,x,y,rs);
		mouse_wait_unkey();
		ZoneErase(zr,z,index);

		// restore frame if was a special right click

		if (rs) {
			z->flags = (z->flags & ~ZN_FRAME) | save_frame;

			if ((zr->flags & ZR_TYPEMASK) == ZR_TOGGLE)
				if (z->flags & ZN_INVERTED)
					ZoneDraw(zr,z,index);
				else
					ZoneErase(zr,z,index);
		}

		break;
	}
	ZoneDoHandlers(zr,z,x,y,rs);
	vd->refresh();
}

int	palette_coordToColor(coord x,coord y) {
	x = (x-ZTool4[0].x)/toolpos.c_width;
	y = (y-ZTool4[0].y)/toolpos.c_height;

	if (toolmode == TOOLMODE_TOP)
		return (ZRTool1[3].page+((y<<4)+x))&0xff;
	else
		return (ZRTool1[3].page+(y+(x<<3)))&0xff;
}

void paletteHandler(struct ZoneRange *zr,struct Zone *z,coord x,coord y) {
	coord c1,xc,yc,b,c2,xc2,yc2;
	boolean redraw;
	int last_color = -1;

	do {
		vd->refresh();
		mouse_read2(&x,&y,&b);
		x -= z->x;
		y -= z->y;
		if (x>=0 && x<z->xs && y>=0 && y<z->ys && b) {
			x /= toolpos.c_width;
			y /= toolpos.c_height;
			xc = z->x + x*toolpos.c_width;
			yc = z->y + y*toolpos.c_height;
			if (toolmode == TOOLMODE_TOP)
				c1 = (y<<4)+x;
			else
				c1 = y+(x<<3);

			if (c1 == last_color) continue;
			last_color = c1;

			redraw=FALSE;

			if (b & 1) {
				c2=zr->highindex;

				if (toolmode == TOOLMODE_TOP) {
					xc2=toolpos.c_width*((c2-zr->page) & 15);
					yc2=toolpos.c_height*(((c2-zr->page)>>4) & 3);
				} else {
					xc2=toolpos.c_width*(((c2-zr->page)>>3) & 7);
					yc2=toolpos.c_height*(c2 & 7);
				}

				xc2 += z->x;
				yc2 += z->y;

				if (c1+zr->page!=c2) {
					mouse_hide();
					if (!((c2-zr->page)&0xc0)) vd->box(&vidbm,xc2-1,yc2-1,xc2+toolpos.c_width,yc2+toolpos.c_height,-1);
					vd->box(&vidbm,xc-1,yc-1,xc+toolpos.c_width,yc+toolpos.c_height,-1);
					redraw=TRUE;
					fcolorpos=zr->highindex=(c1+zr->page)&0xff;
				};
			} else {
				if (zr->auxhighindex != c1+zr->page) {
					bcolorpos=zr->auxhighindex=(c1+zr->page)&0xff;
					mouse_hide();
					vd->bar(&vidbm,palrect_large.x1+1,palrect_large.y1+1,
						palrect_large.x2-palrect_large.x1-1,palrect_large.y2-palrect_large.y1-1,palset[(uchar)(c1+zr->page)]);
					redraw=TRUE;
				};
			};

			if (redraw) {
				vid_draw3d(&vidbm,palrect_large.x1+7,palrect_large.y1+3,palrect_large.x2-7,palrect_large.y2-3);
				vd->bar(&vidbm,palrect_large.x1+8,palrect_large.y1+4,palrect_large.x2-palrect_large.x1-15,
					palrect_large.y2-palrect_large.y1-7,palset[zr->highindex]);
				mouse_show();
			};
		};
	} while(b);

	fcolor = palset[fcolorpos];
	bcolor = palset[bcolorpos];
}

void palette_pickColor(uchar color) {
	ZRTool1[3].highindex=color;
	fcolor = palset[color];

	if ((color-ZRTool1[3].page) & 0xc0) {
		fcolorpos = color;
		ZRTool1[3].page=((color+4-0x20) & ((toolmode==TOOLMODE_TOP) ? 0xF0 : 0xF8));
		if (toolgrid) palette_redrawHandler(&ZRTool1[3]);
	} else {
		coord x1,y1,x2,y2;
		uchar page = ZRTool1[3].page;
		if (toolgrid) {
			if (toolmode == TOOLMODE_TOP) {
				x1=ZTool4[0].x+toolpos.c_width *( (fcolorpos-page)     & 15);
				y1=ZTool4[0].y+toolpos.c_height*(((fcolorpos-page)>>4) &  3);
				x2=ZTool4[0].x+toolpos.c_width *( ( color   -page)     & 15);
				y2=ZTool4[0].y+toolpos.c_height*((( color   -page)>>4) &  3);
			} else {
				x1=ZTool4[0].x+toolpos.c_width *(((fcolorpos-page)>>3) & 7);
				y1=ZTool4[0].y+toolpos.c_height*( (fcolorpos-page)     & 7);
				x2=ZTool4[0].x+toolpos.c_width *((( color   -page)>>3) & 7);
				y2=ZTool4[0].y+toolpos.c_height*( ( color   -page)     & 7);
			}

			vd->box(&vidbm,x1-1,y1-1,x1+toolpos.c_width,y1+toolpos.c_height,-1);
			vd->box(&vidbm,x2-1,y2-1,x2+toolpos.c_width,y2+toolpos.c_height,-1);

			vd->bar(&vidbm,palrect_large.x1+8,palrect_large.y1+4,palrect_large.x2-palrect_large.x1-15,palrect_large.y2-palrect_large.y1-7,fcolor);
		};
		fcolorpos = color;
	};
	vd->refresh();
}

void palette_pickHighColor(uchar c) {
	bcolorpos=ZRTool1[3].auxhighindex=c;
	bcolor = palset[bcolorpos];
	if (toolgrid) {
		vd->bar(&vidbm,palrect_large.x1+1,palrect_large.y1+1,palrect_large.x2-palrect_large.x1-1,
			palrect_large.y2-palrect_large.y1-1,c);
		vid_draw3d(&vidbm,palrect_large.x1+7,palrect_large.y1+3,palrect_large.x2-7,palrect_large.y2-3);
		vd->bar(&vidbm,palrect_large.x1+8,palrect_large.y1+4,palrect_large.x2-palrect_large.x1-15,
			palrect_large.y2-palrect_large.y1-7,fcolor);
	};
	vd->refresh();
}

void palette_redrawHandler(struct ZoneRange *zr) {
	coord x,y;
	uchar c;
	uchar b,b2;

	vd->bar(&vidbm,zr->zonelist[0].x-1,zr->zonelist[0].y-1,zr->zonelist[0].xs+2,zr->zonelist[0].ys+2,St0);
	vid_draw3d(&vidbm,palrect_large.x1,palrect_large.y1,palrect_large.x2,palrect_large.y2);
	vid_draw3d(&vidbm,palrect_large.x1+7,palrect_large.y1+3,palrect_large.x2-7,palrect_large.y2-3);

	b=zr->page;
	c=fcolorpos;

	switch(toolmode) {
	case TOOLMODE_RIGHT:
		for (x=zr->zonelist[0].x;x<zr->zonelist[0].x+8*toolpos.c_width;x+=toolpos.c_width)
			for (y=zr->zonelist[0].y;y<zr->zonelist[0].y+8*toolpos.c_height;y+=toolpos.c_height) {
				b2 = palset[b];

				if (pict_cur->pal_bits[b2>>3] & (1<<(b2&7)))
					vd->bar(&vidbm,x,y,toolpos.c_width,toolpos.c_height,b2);
				else
					vid13_grey(&vidbm,x,y,toolpos.c_width,toolpos.c_height,St2,St0);
				++b;
			}
//		if (!((c-zr->page)&0xc0)) {
		if ((uchar)(c-zr->page) < 0x40) {
			x=zr->zonelist[0].x+toolpos.c_width *(((c-zr->page)>>3)&7);
			y=zr->zonelist[0].y+toolpos.c_height*( (c-zr->page)    &7);
			vd->box(&vidbm,x-1,y-1,x+toolpos.c_width,y+toolpos.c_height,-1);
		};
		break;
	case TOOLMODE_TOP:
		for (y=zr->zonelist[0].y;y<zr->zonelist[0].y+4*toolpos.c_height;y+=toolpos.c_height)
			for (x=zr->zonelist[0].x;x<zr->zonelist[0].x+16*toolpos.c_width;x+=toolpos.c_width) {
				b2 = palset[b];

				if (pict_cur->pal_bits[b2>>3] & (1<<(b2&7)))
					vd->bar(&vidbm,x,y,toolpos.c_width,toolpos.c_height,b2);
				else
					vid13_grey(&vidbm,x,y,toolpos.c_width,toolpos.c_height,St2,St0);
				++b;
			}
//		if (!((c-zr->page)&0xc0)) {
		if ((uchar)(c-zr->page) < 0x40) {
			x=zr->zonelist[0].x+toolpos.c_width *( (c-zr->page)    &15);
			y=zr->zonelist[0].y+toolpos.c_height*(((c-zr->page)>>4)& 3);
			vd->box(&vidbm,x-1,y-1,x+toolpos.c_width,y+toolpos.c_height,-1);
		};
		break;
	}
}

void toolSpecial1(struct ZoneRange *zr,struct Zone *z,int index,char frame) {
	if (index>=6 && index<10 && frame>=0 && frame<3) {
		mouse_hide();
//		vd->bltpattern3d(&vidbm,&toolicons[index+frame*4-6][0],z->x,z->y,z->xs,z->ys);
		if (toolpos.use_hires)
			vid13_bltpattern3dscale(zonebm,&toolicons_hires[index+frame*4-6][0],z->x,z->y,26,24,toolpos.tools_xmult,toolpos.tools_ymult);
		else
			vid13_bltpattern3dscale(zonebm,&toolicons[index+frame*4-6][0],z->x,z->y,13,12,toolpos.tools_xmult,toolpos.tools_ymult);
		if (frame)	vid_inv3d (zonebm,z->x,z->y,z->x+z->xs-1,z->y+z->ys-1);
		else		vid_draw3d(zonebm,z->x,z->y,z->x+z->xs-1,z->y+z->ys-1);
		mouse_show();
	};
}

void contSpecial1(struct ZoneRange *zr,struct Zone *z,int index,char frame) {
	mouse_hide();
//	vd->bltpattern3d(&vidbm,&tool_continuous_icon[frame][0],z->x,z->y,z->xs,z->ys);
	if (toolpos.use_hires)
		vid13_bltpattern3dscale(zonebm,&tool_continuous_icon_hires[frame][0],z->x,z->y,26,24,toolpos.tools_xmult,toolpos.tools_ymult);
	else
		vid13_bltpattern3dscale(zonebm,&tool_continuous_icon[frame][0],z->x,z->y,13,12,toolpos.tools_xmult,toolpos.tools_ymult);
	if (frame)	vid_inv3d (zonebm,z->x,z->y,z->x+z->xs-1,z->y+z->ys-1);
	else		vid_draw3d(zonebm,z->x,z->y,z->x+z->xs-1,z->y+z->ys-1);
	mouse_show();
}

void gridHandler(struct ZoneRange *zr,struct Zone *z,coord x,coord y) {
	gridmode=!!(z->flags & ZN_INVERTED);
}

void clearHandler(struct ZoneRange *zr,struct Zone *z,coord x,coord y) {
	mouse_hide();
	UndoInvalidate();
	vd->set(winbm,bcolor);
	rectmodified=TRUE;
	rectposx=vposx;
	rectposy=vposy;
	rectx1=winbm->x1;
	recty1=winbm->y1;
	rectx2=winbm->x2-1;
	recty2=winbm->y2-1;
	UndoSave();
	mouse_show();
	vd->refresh();

	pict_cur->dirty = TRUE;
}

void palshiftLeft(struct ZoneRange *zr,struct Zone *z,coord x,coord y) {
	mouse_hide();
	ZRTool1[3].page=(ZRTool1[3].page-8)&0xFF;
	palette_redrawHandler(&ZRTool1[3]);
	mouse_show();
}

void palshiftRight(struct ZoneRange *zr,struct Zone *z,coord x,coord y) {
	mouse_hide();
	ZRTool1[3].page=(ZRTool1[3].page+8)&0xFF;
	palette_redrawHandler(&ZRTool1[3]);
	mouse_show();
}

boolean rectInside(struct Rectangle *r,coord x,coord y) {
	if ((x-=r->x)>=0)
		if ((y-=r->y)>=0)
			if (x<r->width)
				if (y<r->height)
					return TRUE;
	return FALSE;
}

int rectSearch(struct Rectangle *r,coord x,coord y) {
	int x2,y2,ind=0;

	while (r->x !=(coord)RECT_END) {
		if ((x2=(x-r->x))>=0)
			if ((y2=(y-r->y))>=0)
				if (x2<r->width)
					if (y2<r->height)
						return ind;
		++ind;
		++r;
	};
	return -1;
}

void rectInvert(struct Rectangle *r) {
	mouse_hide();
	vd->bar(zonebm,r->x,r->y,r->width,r->height,0x800000FF);
	mouse_show();
}

void rectInvert2(struct Rectangle *r,color c) {
	mouse_hide();
	vd->bar(zonebm,r->x,r->y,r->width,r->height,0x80000000+c);
	mouse_show();
}

void rectD3D(struct Rectangle *r) {
	mouse_hide();
	vid_draw3d(zonebm,r->x,r->y,r->x+r->width-1,r->y+r->height-1);
	mouse_show();
}

void rectI3D(struct Rectangle *r) {
	mouse_hide();
	vid_inv3d(zonebm,r->x,r->y,r->x+r->width-1,r->y+r->height-1);
	mouse_show();
}

void	ShiftZoneSet(struct ZoneRange *zr,coord xo,coord yo) {
	struct Zone *z;
	do {
		if (z=zr->zonelist)
			while(z->xs>0) {
				z->x+=xo;
				z->y+=yo;
				++z;
			};
	} while(zr=zr->next);
}

void	ShiftRectangles(struct Rectangle *r,coord xo,coord yo) {
	while(r->x != RECT_END) {
		r->x+=xo;
		r->y+=yo;
		r++;
	};
}

void	ZoneRangeInit(struct ZoneRange *zr) {
	struct Zone *z;

	while(zr) {
		z=zr->zonelist;
		while(z->xs > 0) {
			if ((z->flags & ZN_AUTOWIDTH) && (z->flags & ZN_TEXTRENDER))
				if (z->flags & ZN_SYSTEXT) {
					z->xs = strlen(z->text)*sysfontwidth+4*vdrv_cur->x_aspect;
					z->ys = sysfontheight+4*vdrv_cur->y_aspect-1;
				} else
					z->xs = strlen(z->text)*6+4;
			if (z->flags & ZN_FITRIGHT)
				z->x = z[-1].x + z[-1].xs;
			++z;
		}
		zr=zr->next;
	}
}

